\boxes.xpl	16-Mar-2018
\Bouncing Boxes (aka: Frame Buffer Test)
\Based on fbtestXIV.c by J-P Rosti (aka: -rst- on 'Raspberry Compote')

def	Boxes = 200,			\number of boxes to display
	ScrW=960, ScrH=540,		\screen dimensions
	PageSize = ScrW*ScrH,		\size of screen (or page) in bytes
	BoxW=ScrH/10, BoxH=BoxW;	\dimensions of boxes
int	XB(Boxes), YB(Boxes),		\position of boxes on screen
	DXB(Boxes), DYB(Boxes),		\velocity of boxes
	FBP,				\frame buffer pointer
	Page,				\0 or 1
	N;				\index


proc	DrawBox(X0, Y0, W, H, C);	\Draw WxH rectangle at X0,Y0 in color C
int	X0, Y0, W, H, C;
int	Y;
for Y:= Y0+Page*ScrH to Y0+Page*ScrH+H-1 do
	[Move(X0, Y);  Line(X0+W-1, Y, C)];


proc	DrawScreen;
[Page:= Page|1;					\flip to page on which to draw
FillMem(Page*PageSize+FBP, 0, PageSize);	\erase it
for N:= 0 to Boxes-1 do				\draw the boxes
	[DrawBox(XB(N), YB(N), BoxW, BoxH, rem(N/15)+1);
	XB(N):= XB(N)+DXB(N);			\move the boxes
	YB(N):= YB(N)+DYB(N);
	if XB(N)<0 ! XB(N)>ScrW-BoxW then	\if box hit screen side then
		[DXB(N):= -DXB(N);		\ reverse its direction, and
		XB(N):= XB(N) + 2*DXB(N);	\ counteract move already made
		];
	if YB(N)<0 ! YB(N)>ScrH-BoxH then	\do same for vertical direction
		[DYB(N):= -DYB(N);
		YB(N):= YB(N) + 2*DYB(N);
		];
	];
ShowPage(Page);			\show what we just drew (at next vertical sync)
WaitForVSync;			\to regulate speed and eliminate flicker
];	\DrawScreen


[SetFB(ScrW, ScrH, 8);		\set up graphic display
N:= GetFB;			\find out where Linux put it
FBP:= N(3);
Page:= 0;
for N:= 0 to Boxes-1 do
	[XB(N):= Ran(ScrW-BoxW);\place the boxes in random locations
	YB(N):= Ran(ScrH-BoxH);
	DXB(N):= Ran(10)+1;	\set them moving in random directions
	DYB(N):= Ran(10)+1;
	];
repeat DrawScreen until KeyHit;
SetVid(3);			\restore normal text display
]
