\graphics.inc	13-Aug-2016	loren.blaney@gmail.com
\Graphic routines for pulley demo

int	PenX, PenY;		\drawing pen coordinates (pixels)

char	Screen(ImW*ImH);	\screen buffer (gets copied to display screen)

def	Black, Blue, Green, Cyan, Red, Magenta, Brown, White,  \attribute colors
	Gray, LBlue, LGreen, LCyan, LRed, LMagenta, Yellow, BWhite; \EGA palette

def	Pi = 3.14159265358979323846;



proc	WaitVB;			\Wait for start of vertical blank
begin
DelayUS(16666);			\vsync apparently is not available
end;	\WaitVB



proc	Erase(C);		\Set entire Screen buffer to specified color
int	C;
int	S, I;
begin
C:= C + C<<8 + C<<16 + C<<24;	\do 4 bytes at once, for speed
S:= Screen;
for I:= 0, ImW*ImH/4-1 do S(I):= C;
end;	\Erase



proc	MovePen(X, Y);		\Set pen position
int	X, Y;
begin
PenX:= X;
PenY:= Y;
end;	\MovePen



proc	DrawPoint(X, Y, C);	\Draw a pixel in Screen buffer
int	X, Y, C;		\coordinates and color
begin
if X<0 ! X>=ImW then return;
if Y<0 ! Y>=ImH then return;
Screen(X + Y*ImW):= C;
PenX:= X;			\also set pen position
PenY:= Y;
end;	\DrawPoint



proc	DrawLine(X, Y, C); \Draw line in Screen from PenX,PenY to X,Y in color C
int	X, Y, C;	\coordinates of end-of-line, color
int	DX, DY,		\delta X, delta Y
	IX, IY,		\plotting increments along X and Y axes
	SY,		\flag: step along Y direction
	D,		\decision variable (move straight or diagonally)
	E, NE,		\East, Northeast (straight or diagonal)
	T, I;		\scratch
begin
DX:= X - PenX;				\delta X
if DX >= 0 then				\if positive then increment
	IX:= 1
else	[DX:= -DX;   IX:= -1];		\else absolute value and decrement

DY:= Y - PenY;				\same for Y direction
if DY >= 0 then
	IY:= 1
else	[DY:= -DY;   IY:= -1];

if DX >= DY then			\step along X direction
	SY:= false
else	begin
	SY:= true;			\step along Y direction
	T:= DX;   DX:= DY;   DY:= T;	\swap DX and DY
	end;

D:= 2*DY - DX;				\set up decision variable stuff
E:= 2*DY;
NE:= 2*(DY-DX);


if PenX>=0 & PenX<ImW & PenY>=0 & PenY<ImH then	\clip
	Screen(PenX + PenY*ImW):= C;	\plot initial point
for I:= 1, DX do
	begin
	if D < 0 then
		begin			\move straight
		D:= D + E;
		if SY then PenY:= PenY + IY
		      else PenX:= PenX + IX;
		end
	else	begin			\move diagonally
		D:= D + NE;
		PenX:= PenX + IX;
		PenY:= PenY + IY;
		end;
	if PenX>=0 & PenX<ImW & PenY>=0 & PenY<ImH then	\clip
		Screen(PenX + PenY*ImW):= C;
	end;
end;	\DrawLine



proc	DrawRectangle(X, Y, W, H, C); \Draw a rectangle
int	X, Y, W, H,	\upper left corner coordinates, width, height (pixels)
	C;		\color
begin
MovePen(X, Y);
DrawLine(X+W-1, Y, C);
DrawLine(X+W-1, Y+H-1, C);
DrawLine(X, Y+H-1, C);
DrawLine(X, Y, C);
end;	\DrawRectangle



proc	DrawCircle(X0, Y0, R, C);	\Draw a circle in Screen
int	X0, Y0,	\coordinates of center
	R,	\radius (pixels)
	C;	\line color
int	X, Y, E, U, V;

	proc	DrawOctants;
	begin				\Segment
	DrawPoint(X0+Y, Y0+X, C);	\ 0
	DrawPoint(X0+X, Y0+Y, C);	\ 1
	DrawPoint(X0-X, Y0+Y, C);	\ 2
	DrawPoint(X0-Y, Y0+X, C);	\ 3
	DrawPoint(X0-Y, Y0-X, C);	\ 4
	DrawPoint(X0-X, Y0-Y, C);	\ 5
	DrawPoint(X0+X, Y0-Y, C);	\ 6
	DrawPoint(X0+Y, Y0-X, C);	\ 7
	end;	\DrawOctants

begin
X:= 0;
Y:= R;
U:= 1;
V:= 1 -R -R;
E:= 1 -R;
while X < Y do
	begin
	DrawOctants;
	if E < 0 then
		[U:= U+2;   V:= V+2;   E:= E+U]
	else	[U:= U+2;   V:= V+4;   E:= E+V;   Y:= Y-1];
	X:= X+1;
	end;
if X = Y then DrawOctants;
end;	\DrawCircle
