\rmouse2.xpl	4-Jun-2017
\Mouse pointer demo using ShowMouse and MoveMouse intrinsics

def	VMode=$112,		\graphic video mode (640x480x24)
	ScrW=640, ScrH=480;	\screen dimensions (pixels)
int	Mouse,			\pointer to mouse data array
	C0, C1, C2, C3,		\corner colors for gradient
	MButton,		\mouse button went from up to down
	RX0, RY0, RX1, RY1;	\rectangle corners


proc	ShowGradientRectangle(X, Y, W, H);	\Display a gradient rectangle
int	X, Y, W, H;	\upper left corner coordinates, width, height (pixels)
int	I, J, C, CX0, CX1;
[if W < 0 then [W:= -W;  X:= X-W];	\use absolute values
 if H < 0 then [H:= -H;  Y:= Y-H];
for J:= Y to Y+H-1 do			\for each scan line...
	[CX0:= (C1-C0)*J/(H*H);		\interpolate (sorta) colors from top to
	 CX1:= (C3-C2)*J/(H*H);		\ bottom of rectangle
	 for I:= X to X+W-1 do		\for each pixel...
		[C:= (CX1-CX0)*I/(W*W);	\interpolate (sorta) from left to right
		Point(I, J, C);
		];
	];
];	\ShowGradientRectangle


proc	DrawRect;		\Move mouse pointer and draw rectangles
[Mouse:= GetMouse;
if Mouse(2) then		\a mouse button is down
	[if ~MButton then
		[MButton:= true; \the mouse button just went down
		RX0:= Mouse(0);  RY0:= Mouse(1); \establish corner of rectangle
		C0:= Ran(256)<<16;		 \ along with its colors
		C1:= Ran(256)<<8;
		C2:= Ran(256);
		C3:= 0;
		];
	\The mouse button is still being held down
	if Mouse(0)#RX1 ! Mouse(1)#RY1 then	 \the mouse moved
		[RX1:= Mouse(0);  RY1:= Mouse(1);\second corner of rectangle
		ShowMouse(false);		 \turn off pointer while drawing
		ShowGradientRectangle(RX0, RY0, RX1-RX0, RY1-RY0);
		ShowMouse(true);
		];
	]
else	MButton:= false;			\mouse button is released
MoveMouse;					\move mouse pointer as necessary
];	\DrawRect


[SetVid(VMode);
Move((ScrW-18*8)/2, ScrH/2);			\center text
Text($106, "drag me beautiful");

ShowMouse(true);				\turn on mouse pointer
repeat	DrawRect;
until	KeyHit;

SetVid(3);					\restore normal text mode
]
