\TREK.XPL	21-Mar-2014
\CLASSIC STAR TREK GAME.
\WRITTEN BY MIKE MAYFIELD IN BASIC
\CONVERTED TO XPL AND MODIFIED BY LOREN BLANEY

\REVISION HISTORY:
\APR-29-81, ORIGINAL
\FEB-28-86, MODIFIED FOR 32-BIT XPL, L.B.
\FEB-24-87, CHANGED 'ELSE' TO 'OTHER' IN CASE STATEMENTS
\NOV-06-90, MODIFIED FOR PC.
\21-Mar-2014: Modified for Raspberry Pi (and xpx.bat).
 
def	INTSIZE=\2\4;	\NUMBER OF BYTES IN AN INTEGER

code	ABS=0, RAN=1, REM=2, RESERVE=3, SWAP=4, EXTEND=5,
	CHIN=7, CHOUT=8, CRLF=9, INTIN=10, INTOUT=11,
	TEXT=12, OPENI=13, OPENO=14, CLOSE=15, CURSOR=23;

def	TV=0, KB=0, PR=\2\0, FILE=3, FF=$0C;	\I/O STUFF

def	DWARPMAX=80,	\MAXIMUM DECI-WARP FACTOR
	IENERGY=3000,	\INITIAL & RELOAD ENERGY
	ITORPS=8,	\INITIAL & RELOAD NO. OF TORPEDOS
	IKSHIELD=50;	\INITIAL KLINGON SHIELD ENERGY
def	\EQUIPMENT\ ENGINES, SSENSOR, LSENSOR, PHASERS,
	PTTUBES, SHIELDS, DAMCTRL, COMPUTER;

integer
BASEDEST,	\STARBASE HAS BEEN TORPEDOED FLAG
BASEQUAD,	\NO. OF BASES IN QUADRANT
BASEGXY,	\TOTAL STARBASES IN GALAXY
DOCKED,		\BOOLEAN--DOCKED TO STARBASE
ENERGY,		\CURRENT ENTERPRISE ENERGY (NOT INCL. SHIELDS)
KLNQUAD,	\NO. OF KLINGONS IN QUADRANT
IKLN,		\INITIAL NO. OF KLINGONS IN GALAXY
KLNGXY,		\TOTAL KLINGONS IN GALAXY
TORPS,		\PHOTON TORPEDOS ON BOARD
XQUAD, YQUAD,	\CURRENT ENTERPRISE QUADRANT
SENERGY,	\SHIELD ENERGY
XSEC, YSEC,	\CURRENT ENTERPRISE SECTOR
STARQUAD,	\NO. OF STARS IN QUADRANT
DATE,		\CURRENT STARDATE
IDATE,		\STARTING STARDATE
DATES,		\STAR DATES TO COMPLETE MISSION
FINISHED,	\BOOLEAN--GAME FINISHED
I, X, CH;	\MISCELLANEOUS

integer	\ARRAYS
CC,	\COURSE CONTROL
DAMAGE,	\DAMAGE STATE OF EQUIPMENT
NAME,	\EQUIPMENT NAMES
KLN,	\KLN(I,0),KLN(I,1) = SECTOR COORDINATES OF I'TH KLINGON
	\ KLN(I,2) = SHIELD POWER OF KLINGON (IF <0 THEN GONE)
GALAXY,	\CONTAINS PACKED DECIMAL OF KLINGONS, STARBASES,
	\ & STARS.  8*8 QUADRANTS
QUAD,	\CURRENT QUADRANT 8*8 SECTORS
MAP;	\LIBRARY COMPUTER MEMORY OF GALAXY ARRAY



proc	CR; CRLF(TV);



proc	STR; int TXT; TEXT(TV,TXT);



proc	NUM; int I; INTOUT(TV,I);



proc	NUM2(I);
\OUTPUT RIGHT JUSTIFIED POSITIVE INTEGER (BLANKS IF =0)
int	I;
begin
case of
I>=100:	[STR(" "); NUM(I)];
I>=10:	[STR("  "); NUM(I)];
I>=1:	[STR("   "); NUM(I)]
other	\I=0\ STR("    ");
end;



funct	SQRT(N);	\SQUARE ROOT FUNCTION
int	N, GUESS;
begin
GUESS:=1;
for I:=1,10 do GUESS:=((N/GUESS) +GUESS) /2;
return GUESS;
end;



proc	YOUWIN;
begin
STR("THE LAST KLINGON BATTLE CRUISER IN THE GALAXY HAS BEEN
 DESTROYED."); CR;
STR("THE FEDERATION HAS BEEN SAVED!!"); CR; CR;
STR("YOUR EFFICIENCY RATING IS ");
NUM(IKLN*100 /(DATE-IDATE)); CR;
FINISHED:=true;
end;



proc	CONQUER;
begin
STR("THERE ARE STILL "); NUM(KLNGXY);
STR(" KLINGON BATTLE CRUISERS LEFT.
 THE FEDERATION WILL BE CONQUERED."); CR; CR;
FINISHED:=true;
end;



proc	DESTROYED;
begin
CR; STR("*** THE ENTERPRISE IS DESTROYED ***"); CR; CR;
CONQUER;
end;



proc	WRECK;	\RANDOMLY DAMAGE SOMETHING TO A RANDOM DEGREE
int	ITEM;
begin
ITEM:=RAN(8);
DAMAGE(ITEM):=DAMAGE(ITEM) +RAN(4) +2;
		\(DON'T ALLOW THINGS TO GET FIXED RIGHT AWAY)
STR(NAME(ITEM)); STR(" DAMAGED"); CR;
end;



proc	KLNFIRE;		\KLINGON PHASER FIRE
int	I,DX,DY,DIST,HIT;
begin
if KLNQUAD=0 then return;
if DOCKED then
	[STR("STARBASE SHIELDS PROTECT THE ENTERPRISE"); CR;
	return];
for I:=0,2 do if KLN(I,2)>=0 then
	[DX:=XSEC-KLN(I,0); DY:=YSEC-KLN(I,1);
	DIST:=SQRT(DX*DX +DY*DY);	\DISTANCE BETWEEN K & E
	HIT:=6*KLN(I,2) /DIST*(RAN(4)+7) /10;
				\AVE = 6*50 /3*0.8 = 80
	SENERGY:=SENERGY-HIT;
	NUM(HIT);
	STR(" UNIT HIT ON ENTERPRISE!  FIRED FROM SECTOR ");
	NUM(KLN(I,0)); STR(","); NUM(KLN(I,1)); CR;
	STR(" SHIELDS DOWN TO "); NUM(SENERGY); STR(" UNITS");
	CR;
	if SENERGY<0 then DESTROYED	\(I.E. YOU LOSE)
	else if HIT>RAN(300) then WRECK]; \CHANCE OF DAMAGE
end;



proc	NOENERGY;
begin
STR("THE ENTERPRISE IS DEAD IN SPACE.  IF YOU
SOMEHOW MANAGE TO SURVIVE ALL IMPENDING
ATTACKS, YOU WILL BE DEMOTED TO THE RANK
OF PRIVATE."); CR;
if KLNQUAD=0 then CONQUER else repeat KLNFIRE until FINISHED;
end;



proc	SHORTSCAN;		\SHORT RANGE SENSOR SCAN
int	X,Y,ITEM;
addr	CONDITION, BORDER;

	proc	LINE; int J; addr TXT;	\DISPLAY A SCAN LINE
	[CR; for I:=0,7 do [STR("  "); CHOUT(TV,QUAD(I,J))];
	STR("		"); STR(TXT)];

begin			\SHORTSCAN
DOCKED:=false;		\CHECK IF DOCKED TO STARBASE
for Y:=YSEC-1,YSEC+1 do for X:=XSEC-1,XSEC+1 do
	if X>=0 & X<=7 & Y>=0 & Y<=7 then
	    if QUAD(X,Y)=^B then
		DOCKED:=true;
if DOCKED then
	[ENERGY:=IENERGY; TORPS:=ITORPS;
	for ITEM:=ENGINES,COMPUTER do DAMAGE(ITEM):=0;
	SENERGY:=0;
	STR("SHIELDS DROPPED FOR DOCKING PURPOSES"); CR];
if DAMAGE(SSENSOR)>0 then
	[CR; STR("*** SHORT RANGE SENSORS ARE OUT ***"); CR;
	CR; return];
CONDITION:=if DOCKED then "DOCKED"
	else if KLNQUAD>0 then "RED"
	else if ENERGY<300 then "YELLOW"
	else "GREEN";
BORDER:="--------------------------";
STR(BORDER);
LINE(0,"STARDATE	"); NUM(DATE);
LINE(1,"CONDITION	"); STR(CONDITION);
LINE(2,"QUADRANT	"); NUM(XQUAD); STR(","); NUM(YQUAD);
LINE(3,"SECTOR		"); NUM(XSEC); STR(","); NUM(YSEC);
LINE(4,"ENERGY		"); NUM(ENERGY);
LINE(5,"TORPEDOS	"); NUM(TORPS);
LINE(6,"SHIELDS		"); NUM(SENERGY);
LINE(7,"
"); STR(BORDER); CR;
if DAMAGE(COMPUTER)=0 then
	[if XQUAD>=0 & XQUAD<=7 & YQUAD>=0 & YQUAD<=7 then
		MAP(XQUAD,YQUAD):=GALAXY(XQUAD,YQUAD)]
else [STR("COMPUTER IS DOWN--SCAN NOT RECORDED"); CR];
end;



proc	QUADRANT;	\SETUP QUADRANT ENTERPRISE IS IN
int	X,Y,I;

	proc	EMPTY;	\RANDOMLY FIND AN EMPTY SECTOR (.)
	[repeat X:=RAN(8); Y:=RAN(8) until QUAD(X,Y)=^.];

begin		\QUADRANT
if XQUAD>=0 & XQUAD<=7 & YQUAD>=0 & YQUAD<=7 then \ENTERPRISE
	[KLNQUAD:=GALAXY(XQUAD,YQUAD)/100; \WITHIN KNOWN GALAXY
	BASEQUAD:=REM(0)/10;		\GET NO. OF STARBASES
	STARQUAD:=REM(0)]		\GET NO. OF STARS
	else [KLNQUAD:=0; BASEQUAD:=0; STARQUAD:=0];
for Y:=0,7 do for X:=0,7 do QUAD(X,Y):=^.;
QUAD(XSEC,YSEC):=^E;	\PUT ENTERPRISE AT ITS COORDINATES
for I:=0,2 do KLN(I,2):=-1;	\INIT KLINGON ARRAY
for I:=1,KLNQUAD do	\PUT KLINGONS (IF ANY) SOMEWHERE
	[EMPTY; QUAD(X,Y):=^K;
	KLN(I-1,0):=X; KLN(I-1,1):=Y; KLN(I-1,2):=IKSHIELD];
for I:=1,BASEQUAD do
	[EMPTY; QUAD(X,Y):=^B];	\PUT STARBASE(S) SOMEWHERE
for I:=1,STARQUAD do [EMPTY; QUAD(X,Y):=^*];\PUT STARS SOMEWHER
if KLNQUAD>0 then
	begin STR("COMBAT AREA--CONDITION RED"); CR;
	if SENERGY<=200 then
		[STR("SHIELDS DANGEROUSLY LOW"); CR];
	end;
end;



proc	COMMAND;	\EXECUTE OPERATOR'S COMMAND
int	CMD;



proc	CMD1;		\COURSE CONTROL
int	COURSE,DWARP,FRACTION,IC,
	DX,DY,STARTX,STARTY,BIGX,BIGY,I,ITEM,X,Y;
begin				\LOOP UNTIL HE GETS IT RIGHT
loop	[STR("COURSE: "); OPENI(KB); COURSE:=INTIN(KB);
	if COURSE<0 then COURSE:=COURSE+360;
	IC:= COURSE/45;		\(FOR COURSE CONTROL ARRAY)
	FRACTION:=REM(0);		\[0,44]
	if IC>=0 & IC<=7 then quit;
	STR("INCORRECT COURSE DATA"); CR];
loop	[STR("DECIWARP FACTOR: "); DWARP:=INTIN(KB);
	if DWARP=0 then return	\(0 DECIWARPS DOES NOTHING)
	else if DAMAGE(ENGINES)>0 & DWARP>2 then
	       [STR("WARP ENGINES ARE DAMAGED, MAXIMUM SPEED");
		CR; STR(" IS 2 DECIWARPS"); CR]
	else if DWARP>0 & DWARP<=DWARPMAX then quit
	else STR("ENGINES WON^'T TAKE MORE THAN 80 DECIWARPS");
		CR];
if 4*DWARP>ENERGY then
	[STR("INSUFFICIENT ENERGY AVAILABLE FOR MANEUVER"); CR;
	STR(" YOU HAVE "); NUM(ENERGY);
	STR(" UNITS OF ENERGY"); CR; STR(
	" SUGGEST YOU GET SOME FROM YOUR SHIELDS WHICH HAVE");
	CR; STR(" "); NUM(SENERGY); STR(" UNITS"); CR; return];
ENERGY:=ENERGY-4*DWARP;		\BURN ENERGY FOR MOVE

ITEM:=RAN(8);		\RANDOMLY FIX SOME ITEM REAL FAST
if DAMAGE(ITEM)>0 then DAMAGE(ITEM):=1;
for ITEM:=ENGINES,COMPUTER do		\MAKE ON GOING REPAIRS
	if DAMAGE(ITEM)>0 then
		begin DAMAGE(ITEM):=DAMAGE(ITEM)-1;
		if DAMAGE(ITEM)=0 then
			[STR(NAME(ITEM)); STR(" REPAIRED");CR];
		end;
if 10>RAN(100) then WRECK;		\10% CHANCE OF DAMAGE
KLNFIRE; if FINISHED then return;

STARTX:=XSEC; STARTY:=YSEC;		\MOVE THE ENTERPRISE
   \SAVE STARTING SECTOR IN CASE ENTERPRISE LEAVES THE QUADRANT
QUAD(XSEC,YSEC):=^.;
BIGX:=45*XSEC; BIGY:=45*YSEC;
	\SCALED UP TO ACCUMULATE FRACTIONAL INCREMENTS
DX:=45*CC(IC,0) +(CC(IC+1,0) -CC(IC,0))*FRACTION;
DY:=45*CC(IC,1) +(CC(IC+1,1) -CC(IC,1))*FRACTION;
for I:=1,DWARP do		\MOVE A SECTOR AT A TIME
	begin
	BIGX:=BIGX+DX; BIGY:=BIGY+DY;
	XSEC:=BIGX/45; YSEC:=BIGY/45;
	if XSEC>7 ! XSEC<0 ! YSEC>7 ! YSEC<0 then\LEFT QUADRANT
		[DX:=(DWARP*DX)/45; DY:=(DWARP*DY)/45;
		XQUAD:=(8*(XQUAD+10) +STARTX +DX)/8 -10;
		XSEC:=ABS(REM(0)); \(NEGATIVE QUADS ARE TRICKY)
		YQUAD:=(8*(YQUAD+10) +STARTY +DY)/8 -10;
		YSEC:=ABS(REM(0));
		QUADRANT;	\SETUP NEW QUADRANT
		I:=DWARP]	\EXIT FOR LOOP
	else if QUAD(XSEC,YSEC)#^. then
		[STR("WARP ENGINES SHUTDOWN AT SECTOR ");
		NUM(XSEC); STR(","); NUM(YSEC); CR;
		STR(" DUE TO BAD NAVIGATION"); CR;
		\BACK UP ENTERPRISE TO SECTOR BEFORE CRASH
		XSEC:=(BIGX-DX)/45; YSEC:=(BIGY-DY)/45;
		if 50>RAN(100) then WRECK;
		I:=DWARP];		\EXIT FOR LOOP
	end;
DATE:=DATE+1; if DATE>IDATE+DATES then
	[STR("IT IS STARDATE "); NUM(DATE); CR;
	CONQUER; return];
QUAD(XSEC,YSEC):=^E;
for I:=0,2 do if KLN(I,2)>=0 then		\MOVE KLINGONS
	[QUAD(KLN(I,0),KLN(I,1)):=^.;
	repeat X:=RAN(8); Y:=RAN(8) until QUAD(X,Y)=^.;
	QUAD(X,Y):=^K;
	KLN(I,0):=X; KLN(I,1):=Y];
SHORTSCAN;
end;



proc	CMD2;		\SHORT RANGE SENSOR SCAN
SHORTSCAN;



proc	CMD3;		\LONG RANGE SENSOR SCAN
int	X,Y;
addr	LINE;
begin
if DAMAGE(LSENSOR)>0 then
	[STR("LONG RANGE SENSORS ARE INOPERABLE"); CR; return];
STR("LONG RANGE SENSOR SCAN FOR QUADRANT ");
NUM(XQUAD); STR(","); NUM(YQUAD); CR;
LINE:="     +-----+-----+-----+";
for Y:=YQUAD-1,YQUAD+1 do
	begin STR(LINE); CR;
	STR("     |");
	for X:=XQUAD-1,XQUAD+1 do
		begin
		if X>=0 & X<=7 & Y>=0 & Y<=7 then \IN KNOWN GXY
			[NUM2(GALAXY(X,Y));
			if DAMAGE(COMPUTER)=0 then
				MAP(X,Y):=GALAXY(X,Y)]
		else NUM2(0);  \DISPLAY BLANKS IF BEYOND GALAXY
		STR(" |");
		end;
	CR;
	end;
STR(LINE); CR;
if DAMAGE(COMPUTER)>0 then
	[STR("COMPUTER IS DOWN--SCAN NOT RECORDED"); CR];
end;



proc	CMD4;		\FIRE PHASERS
int	UNITS,I,DX,DY,HIT,DIST;
begin
if KLNQUAD=0 then [STR(
"SHORT RANGE SENSOR DETECTS NO KLINGONS IN THIS QUADRANT"); CR;
	return];
if DAMAGE(PHASERS)>0 then
	[STR("PHASERS ARE DISABLED"); CR; return];
repeat	STR("PHASERS LOCKED ON TARGET; AVAILABLE ENERGY IS ");
	NUM(ENERGY); CR;
	STR(" NUMBER OF UNITS TO FIRE: ");
	OPENI(KB); UNITS:=INTIN(KB);
	if UNITS=0 then return
until UNITS<=ENERGY & UNITS>=0;
ENERGY:=ENERGY-UNITS;
KLNFIRE; if FINISHED then return;		\KLINGON FIRES FIRST
if DAMAGE(COMPUTER)>0 then
	[STR("COMPUTER FAILURE HAMPERS ACCURACY"); CR;
	UNITS:=RAN(UNITS)];
for I:=0,2 do if KLN(I,2)>=0 then
	begin	 	\COMPUTE PHASER HIT ON KLINGON(S)
	DX:=XSEC-KLN(I,0); DY:=YSEC-KLN(I,1);
	DIST:=SQRT(DX*DX +DY*DY);  \DISTANCE BETWEEN ENT & KLN
	HIT:=UNITS /DIST /KLNQUAD*(RAN(4)+7) /10;
	KLN(I,2):=KLN(I,2)-HIT;
	NUM(HIT); STR(" UNITS HIT KLINGON AT SECTOR ");
	NUM(KLN(I,0)); STR(","); NUM(KLN(I,1)); CR;
	STR(" SENSORS SHOW "); NUM(KLN(I,2));
	STR(" UNITS LEFT)"); CR;
	if KLN(I,2)<0 then
		[STR("*** KLINGON AT SECTOR ");
		NUM(KLN(I,0)); STR(","); NUM(KLN(I,1));
		STR(" DESTROYED ***"); CR;
		QUAD(KLN(I,0),KLN(I,1)):=^.; \SPACE OUT KLINGON
		KLNQUAD:=KLNQUAD-1; KLNGXY:=KLNGXY-1;
		GALAXY(XQUAD,YQUAD):=GALAXY(XQUAD,YQUAD)-100;
		if KLNGXY=0 then YOUWIN];
	end;
end;



proc	CMD5;		\FIRE PHOTON TORPEDO
int	X,Y,		\SECTOR COORDINATES OF TORPEDO
	BIGX,BIGY,	\SCALED (*45) COORDINATES OF TORPEDO
	COURSE,IC,FRACTION,DX,DY,I;
begin
if DAMAGE(PTTUBES)>0 then
	[STR("TORPEDO TUBES ARE NOT OPERATIONAL"); CR; return];
if TORPS=0 then [STR("TORPEDO TUBES ARE EMPTY"); CR; return];
STR("PHOTON TORPEDO COURSE: "); OPENI(KB); COURSE:=INTIN(KB);
if COURSE<0 then COURSE:=COURSE+360;
IC:=COURSE/45; if \ILLEGAL\ IC<0 ! IC>7 then
	[STR("INCORRECT COURSE DATA"); CR; return];
FRACTION:=REM(0);		\[0,44]
BIGX:=45*XSEC; BIGY:=45*YSEC;
DX:=45*CC(IC,0) +(CC(IC+1,0) -CC(IC,0))*FRACTION;
DY:=45*CC(IC,1) +(CC(IC+1,1) -CC(IC,1))*FRACTION;
STR("-- TORPEDO TRACK --"); CR;
loop	begin
	BIGX:=BIGX+DX; BIGY:=BIGY+DY;
	X:=(BIGX+22)/45; Y:=(BIGY+22)/45;
	if X<0 ! X>7 ! Y<0 ! Y>7 then
		[STR("  (YOU MISSED)"); CR; quit];
					\DISPLAY TORPEDO TRACK
	STR("       "); NUM(X); STR(","); NUM(Y); CR;
	if QUAD(X,Y)=^K then
		[STR("*** KLINGON DESTROYED ***"); CR;
		KLNQUAD:=KLNQUAD-1; KLNGXY:=KLNGXY-1;
		if KLNGXY=0 then YOUWIN;
		for I:=0,2 do if KLN(I,0)=X & KLN(I,1)=Y
			then KLN(I,2):=-1;
		QUAD(X,Y):=^.; quit];
	if QUAD(X,Y)=^* then
		[STR("YOU CAN^'T DESTROY STARS!"); CR; quit];
	if QUAD(X,Y)=^B then
		[STR("*** STARBASE DESTROYED *** "); CR;
		STR("......CONGRATULATIONS"); CR;
		BASEQUAD:=BASEQUAD-1; BASEGXY:=BASEGXY-1;
		BASEDEST:=true;
		QUAD(X,Y):=^.; quit];
	end;
TORPS:=TORPS-1;
GALAXY(XQUAD,YQUAD):=100*KLNQUAD +10*BASEQUAD +STARQUAD;
KLNFIRE;
end;



proc	CMD6;		\SHIELD CONTROL
int	UNITS;
begin
if DAMAGE(SHIELDS)>0 then
	[STR("SHIELD CONTROL IS NONOPERATIONAL"); CR; return];
repeat	NUM(ENERGY+SENERGY); STR(" ENERGY UNITS AVAILABLE");
	CR; STR(" NUMBER OF UNITS TO SHIELDS: ");
	OPENI(KB); UNITS:=INTIN(KB)
until UNITS>=0 & UNITS<=ENERGY+SENERGY;
ENERGY:=ENERGY+SENERGY-UNITS; SENERGY:=UNITS;
end;



proc	CMD7;		\DAMAGE CONTROL REPORT
int	ITEM;
begin
if DAMAGE(DAMCTRL)>0 then
	[STR("DAMAGE CONTROL IS DAMAGED"); CR; return];
STR("-- DAMAGE CONTROL REPORT --
	  -- DEVICE --     -- EST. TIME TO REPAIR --"); CR;
for ITEM:=ENGINES,COMPUTER do
	[NUM(ITEM+1); STR(" -	"); STR(NAME(ITEM));
	STR("		"); NUM(DAMAGE(ITEM)); CR];
end;



proc	CMD8;		\LIBRARY COMPUTER OPTIONS
int	OPT;



proc	OPT1;		\DISPLAY CUMULATIVE GALACTIC RECORD
int	X,Y;
addr	BORDER;
begin
STR("COMPUTER MAP OF GALAXY FOR QUADRANT ");
NUM(XQUAD); STR(","); NUM(YQUAD); CR;
STR("        0     1     2     3     4     5     6     7"); CR;
BORDER:=
"     +-----+-----+-----+-----+-----+-----+-----+-----+";
STR(BORDER); CR;
for Y:=0,7 do
	[STR("  "); NUM(Y); STR("  |");
	for X:=0,7 do [NUM2(MAP(X,Y)); STR(" |")];
	CR];
STR(BORDER); CR;
end;



proc	OPT2;		\STATUS REPORT
begin
STR("-- STATUS REPORT --
NUMBER OF KLINGONS LEFT = "); NUM(KLNGXY); CR;
STR("NUMBER OF STARDATES LEFT = "); NUM(IDATE+DATES-DATE); CR;
STR("NUMBER OF STARBASES LEFT = "); NUM(BASEGXY); CR;
if BASEDEST then
STR("STAR FEET COMMAND REVIEWING YOUR RECORD TO CONSIDER
 COURT MARTIAL."); CR;
end;



proc	CALCULATE(X1,Y1,X2,Y2);		\TRAJECTORY CALCULATOR
int	X1,Y1,X2,Y2,DX,DY,GE45,FRACTION,DIR;
int	DIRTBL;	\TRAJECTORY DIRECTION TABLE
begin
DX:=X2-X1; DY:=Y1-Y2;		\(POSITIVE Y IS  D O W N)
GE45:=ABS(DY)>=ABS(DX);
FRACTION:= if GE45 then -45*DX/DY else 45*DY/DX;
	\TRAJECTORY DIRECTION TABLE
DIRTBL:=[0,90,180,90,0,-90,180,-90];
DIR:=DIRTBL(-4*(DY<=0) -2*(DX<=0) -1*GE45) +FRACTION;
\NOTE: DIRECTION TABLE INDEX UTILIZES TRUE BOOLEAN = -1
\ (THIS NASTY TRICK WAS INSPIRED BY THE MANY LINES OF BASIC
\ IN THE ORIGINAL.)
STR("DIRECTION = "); NUM(DIR); STR("			");
STR("DISTANCE = "); NUM(SQRT(DX*DX +DY*DY)); CR;
end;



proc	OPT3;		\PHOTON TORPEDO CALCULATIONS
int	I;
begin
if KLNQUAD=0 then [STR(
"SHORT RANGE SENSOR DETECTS NO KLINGONS IN THIS QUADRANT"); CR;
	return];
for I:=0,2 do if KLN(I,2)>=0 then
	CALCULATE(XSEC,YSEC,KLN(I,0),KLN(I,1));
end;



proc	OPT4;		\GENERAL TRAJECTORY CALCULATIONS
begin
STR("YOU ARE AT QUADRANT "); NUM(XQUAD); STR(","); NUM(YQUAD);
STR(" SECTOR "); NUM(XSEC); STR(","); NUM(YSEC); CR;
STR(" ENTER INITIAL AND TARGET COORDINATES (IX,IY,TX,TY): ");
OPENI(KB);
CALCULATE(INTIN(KB), INTIN(KB), INTIN(KB), INTIN(KB));
end;



loop begin			\COMPUTER (CMD 8)
if DAMAGE(COMPUTER)>0 then
	[STR("COMPUTER IS DOWN"); CR; return];
STR("COMPUTER IS UP AND AWAITING COMMAND: ");
OPENI(KB); OPT:=CHIN(KB);	\CHARS ARE MORE GENERAL THAN NOS.
case OPT of
^1:	[OPT1; return];
^2:	[OPT2; return];
^3:	[OPT3; return];
^4:	[OPT4; return]
other	[STR("
-- FUNCTIONS AVAILABLE FROM COMPUTER --
  1 = CUMULATIVE GALATIC MAP
  2 = STATUS REPORT
  3 = PHOTON TORPEDO CALCULATOR
  4 = TRAJECTORY CALCULATOR"); CR];
end;



proc	CMD9;		\SURRENDER
int	CH;
begin
STR("	S U R R E N D E R  ???
 EVEN A COWARD DESERVES A CHANCE TO RECONSIDER
 DO YOU REALLY WANT TO SURRENDER? ");
OPENI(KB); CH:=CHIN(KB);
if (CH!$20)#^y then return;
STR("KLINGONS DO NOT ACCEPT SURRENDER."); CR;
DESTROYED;
end;



begin	\COMMAND
STR("COMMAND: "); OPENI(KB); CMD:=CHIN(KB);
case CMD of
^1:	CMD1;
^2:	CMD2;
^3:	CMD3;
^4:	CMD4;
^5:	CMD5;
^6:	CMD6;
^7:	CMD7;
^8:	CMD8;
^9:	CMD9
other	[STR("
    -- COMMAND LIST --
  1 = WARP ENGINE CONTROL
  2 = SHORT RANGE SENSOR SCAN
  3 = LONG RANGE SENSOR SCAN
  4 = FIRE PHASERS
  5 = FIRE PHOTON TORPEDO
  6 = SHIELD CONTROL
  7 = DAMAGE CONTROL REPORT
  8 = LIBRARY COMPUTER
  9 = SURRENDER TO KLINGONS"); CR];
if FINISHED then return;
if ENERGY+SENERGY<4 then NOENERGY	\(I.E. YOU LOSE)
else if ENERGY<4 & DAMAGE(SHIELDS)>0 then [STR(
"YOU HAVE INSUFFICIENT MANEUVERING ENERGY AND SHIELD CONTROL
 IS PRESENTLY INCAPABLE OF TRANSFERING ENERGY TO THE ENGINE
 ROOM.
"); NOENERGY];
end;



proc	PRINT_DIRECTIONS;
begin
OPENO(PR);
TEXT(PR, "
	    * * * *   S T A R   T R E K   * * * *

The Federation is being invaded by a band of Klingon pirates
whose objective is to test our defenses.  If even one survives
the trial period, Klingon headquarters will launch an all-out
attack.  As captain of the Federation starship 'ENTERPRISE'
your mission is to find and destroy the invaders before the
time runs out.

The known galaxy is divided into 64 quadrants arranged like a
checker board, 8 on a side.  Each quadrant is likewise divided
into 64 sectors arranged as an 8 by 8 square.  Each sector can
contain a Klingon (K), star (*), starbase (B), the Enterprise
herself (E), or empty space (.).  Both quadrants and sectors
are numbered; a starbase in sector 3,5 is three sectors from
the left and 5 sectors down.

Each time you move the Enterprise takes one stardate.

Docking at a starbase is done by occupying an adjacent sector,
and reprovisions your starship with energy and photon torpedoes
as well as repairing all damage.

Your starship will act on the following commands:

COMMAND 1: WARP ENGINE CONTROL
   Course is indicated in degrees as shown.       135  90  45
   One deciwarp will move you the distance          \  |  /
   of one sector.  Therefore to get from      180 ____\|/____ 0
   sector 6,5 to 3,5 you would use:                   /|\
   COURSE: 180                                      /  |  \
   DECIWARP FACTOR: 3                             225 270 315

COMMAND 2: SHORT RANGE SENSOR SCAN
   Displays the quadrant you are currently in, showing stars,
   Klingons, starbases, and the Enterprise, along with other
   pertient data.

COMMAND 3: LONG RANGE SENSOR SCAN
   Summarizes the quadrant you're in and the surrounding ones.
   Each quadrant is represented as a 3-digit number; the first
   (hundreds) digit is the number of Klingons in that quadrant
   while the second digit is the number of starbases, and the
   third digit is the number of stars.  An entry of 305 means
   3 Klingons, no starbases and 5 stars.
");
\CHOUT(PR, FF);
if ChIn(1) then [];

TEXT(PR, "

COMMAND 4: FIRE PHASERS
   Enables you to destroy the Klingons by hitting them with
   suitably large numbers of energy units to deplete their
   shields.  Phaser fire bypasses stars and starbases, but is
   attenuated by the distance it travels.

COMMAND 5: FIRE PHOTON TORPEDO
   Launches a photon torpedo on the course you specify.

COMMAND 6: SHIELD CONTROL
   Transfers the number of energy units you specify to the
   shields.  Your shields will protect you from Klingon phaser
   fire.

COMMAND 7: DAMAGE CONTROL REPORT
   Displays state of repair for all devices.  If a device is
   damaged then the estimated time (moves) to repair it is
   displayed.

COMMAND 8: LIBRARY COMPUTER
   The Library Computer has four options:
   OPTION 1: CUMULATIVE GALATIC MAP
      Displays cumulative galatic map which shows computer
      memory of the results of all previous long- and short-
      range sensor scans.
   OPTION 2: STATUS REPORT
      Shows the total number of Klingons, stardates, and
      starbases left in the galaxy.
   OPTION 3: PHOTON TORPEDO CALCULATOR
      Computes course and distance to all Klingons in your
      quadrant.
   OPTION 4: TRAJECTORY CALCULATOR
      Computes course and distance between any pair of sector
      coordinates.

COMMAND 9: SURRENDER TO KLINGONS
   Terminates the game.

");
\CHOUT(PR, FF);
CLOSE(PR);
if ChIn(1) then [];
end;	\PRINT_DIRECTIONS



proc	INITIALIZE;		\INITIALIZE GALAXY ETC.
int	CH,ITEM,X,Y,N;
begin
FINISHED:=false;
CHOUT(TV,$0C);
CR; STR("	     * * *   S T A R   T R E K   * * *");
CURSOR(0,7); STR("Would you like a printout of the directions (n/y)? ");
OPENI(KB); CH:=CHIN(KB);
if (CH!$20) = ^y then PRINT_DIRECTIONS;

IDATE:=2000 +RAN(20)*100; DATE:=IDATE;
ENERGY:=IENERGY; TORPS:=ITORPS; SENERGY:=0;
BASEDEST:=false;
XQUAD:=RAN(8); YQUAD:=RAN(8); XSEC:=RAN(8); YSEC:=RAN(8);
for ITEM:=ENGINES,COMPUTER do DAMAGE(ITEM):=0;

\GENERATE WHAT EXISTS IN THE GALAXY
BASEGXY:=0; KLNGXY:=0; DATES:=20;
for Y:=0,7 do for X:=0,7 do
	[N:=RAN(100);
	KLNQUAD:= if N>=99 then 3
		else if N>=96 then 2
		else if N>=81 then 1
		else 0;
	KLNGXY:=KLNGXY+KLNQUAD;
	if KLNQUAD#0 then DATES:=DATES+1;
	BASEQUAD:= if RAN(100)>=97 then 1 else 0;
	BASEGXY:=BASEGXY+BASEQUAD;
	STARQUAD:=RAN(8)+1;
	GALAXY(X,Y):=KLNQUAD*100 +BASEQUAD*10 +STARQUAD];
if BASEGXY =0 then [GALAXY(4,3):= GALAXY(4,3)+10; BASEGXY:=1];
for Y:=0,7 do for X:=0,7 do MAP(X,Y):=0;
IKLN:=KLNGXY;

CR; STR("YOU MUST DESTROY "); NUM(KLNGXY);
STR(" KLINGONS IN "); NUM(DATES); STR(" STARDATES WITH ");
NUM(BASEGXY); STR(" STARBASE"); if BASEGXY#1 then STR("S");
STR("."); CR;
QUADRANT;	\SETUP & DISPLAY THE CURRENT QUADRANT
SHORTSCAN;
end;



begin		\MAIN PROC
DAMAGE:=RESERVE(8*INTSIZE);
KLN:=RESERVE(3*INTSIZE); for I:=0,2 do KLN(I):=RESERVE(3*INTSIZE);
QUAD:=RESERVE(8*INTSIZE); for X:=0,7 do QUAD(X):=RESERVE(8*INTSIZE);
GALAXY:=RESERVE(8*INTSIZE); for X:=0,7 do GALAXY(X):=RESERVE(8*INTSIZE);
MAP:=RESERVE(8*INTSIZE); for X:=0,7 do MAP(X):=RESERVE(8*INTSIZE);

NAME:=[	"WARP ENGINES        ",
	"SHORT RANGE SENSORS ",
	"LONG RANGE SENSORS  ",
	"PHASER CONTROL      ",
	"PHOTON TORPEDO TUBES",
	"SHIELD CONTROL      ",
	"DAMAGE CONTROL      ",
	"LIBRARY COMPUTER    "];

	\COURSE CONTROL ARRAY
CC:=[	[1,0],	[1,-1],	[0,-1],
	[-1,-1],[-1,0],	[-1,1],
	[0,1],	[1,1],	[1,0]	];

repeat [INITIALIZE; repeat COMMAND until FINISHED;
	CR; STR("DO YOU WANT TO TRY AGAIN? ");
	OPENI(KB); CH:=CHIN(KB)]
until (CH!$20)#^y;
end;	\MAIN
