\XPL0.XPL	2-Mar-2018
\XPL0 Compiler. Based on XPLPX V3.4.1. No code generation: outputs I2L code.
\This outputs extended I2L codes. Other programs convert this to an executable.
\Copyright 1984, 2018 P.J.R. Boyle
\Based on IBM-PC native language version by Larry Fish with mods by Loren Blaney
\
\This program is free software; you can redistribute it and/or modify it under
\ the terms of the GNU General Public License version 2 as published by the
\ Free Software Foundation.
\This program is distributed in the hope that it will be useful, but WITHOUT
\ ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
\ FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
\ details.
\You should have received a copy of the GNU General Public License along with
\ this program (in the file LICENSE.TXT); if not, write to the Free Software
\ Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
\
\You can contact the authors at: loren.blaney@gmail.com
\
\REVISIONS:
\04-Oct-2015: Released.
\06-Oct-2015: Always eliminate output file when errors are detected.
\12-Aug-2016: Version 1.0 release.
\29-May-2017: Version 2.0: Show "codesr.xpl not found" if it's missing.
\ Increase RealMax to 1600. Check for valid calls to intrinsics. Slash (/) is
\ no longer allowed as a command-line switch because it prevents path names.
\30-Jun-2017: Version 2.1: Fewer subscript warnings and codesrx adds GetPalette.
\02-Mar-2018: Version 2.2: codesrx adds Floor, Ceil, Pow, and SetHexDigits.

code	Abs=0,		Rem=2,		Reserve=3,
	Extend=5,	ChIn=7,		ChOut=8,	CrLf=9,
	IntIn=10,	IntOut=11,	Text=12,	OpenI=13,
	OpenO=14,	Close=15,	Trap=17,	GetErr=22,
	FSet=24,	HexOut=27,	FOpen=29,	FClose=32,
	Fix=50,		TrapC=75;
code real		Float=49,	RlRes=46;

def	IntSize=4,	\number of bytes in an integer
	RealSize=8,	\number of bytes in a floating point value (a 'real')
	SymMax=1600,	\maximum number of symbols in the symbol table
	SigChar=16,	\number of significant chars in an identifer name
	RealMax=1600,	\maximum number of real constants (in scope at one time)
	QuitMax=160,	\maximum number of 'quit's inside a 'loop'
	HandMax=8,	\maximum nesting depth of 'include' files (file handles)
	LevelMax=8,	\maximum number of procedure (static) nesting levels
	BoxNum=256,	\number of hash boxes (= maximum no. of list headers)
	HashMask=$FF,	\bit mask for symbol table hash codes
	EmptyPtr=-1;	\empty symbol pointer for hash linked lists

def	Bel=$07, EOL=$0A, EOF=$1A;	\ASCII control characters

int	CaseSensitive,	\switch (-c) make identifer names case-sensitive
	Debug,		\switch (-d): put .xpl source code into output .iil file
	ShortBool,	\switch (-b): use short-circuit boolean evaluation
	WarnFlag,	\switch (-w): display warning messages

	Conditional,	\flag: used to ignore blocks of code by setting to false
	StrTerm,	\flag: string termination type (0=null, nonzero=MSB set)
	InHand,		\input .xpl file handle
	OutHand;	\output .iil file handle
char	OutName($80);	\output file name, used to delete it if error

int	ErrCtr,		\count of compile errors detected
	LstDev,		\listing output device number (8 to display errors)
	SrcDev,		\source input device number (3 for input .xpl file)
	BinDev,		\binary output device number (3 for output .iil file)
	Char,		\the current character.  Most of the time this contains
			\ the terminator of the current atom
	Atom,		\present atom descriptor: This contains a reserved word
			\ hash or the ASCII for a special character
			\ it's = 0 if the atom is a constant or identifier
	AType;		\present atom type descriptor
def	\AType\ Special, Identifier, IntCon, RealCon;
char	Ident;		\array: current identifier name
int	Hash,		\current identifier hash code
	LabelNum,	\label number (e.g: K17:)
	IAtom,		\value of current integer constant (from proc RAtom)
	Remainder;	\value of remainder from constant integer division
real	RlAtom;		\value of current real constant (from proc RAtom)

int	IdType;		\present identifier (ID) name descriptor
def	UNDEF=0,	\undefined ID
	ADDRVAR=1,	\address variable ID (type = integer)
	INVAR=3,	\integer variable ID (odd values=integer; even=real)
	RLVAR=4,	\real variable ID
	INCON=5,	\integer constant ID
	RLCON=6,	\real constant ID
	INPROC=7,	\integer procedure ID
	RLPROC=8,	\real procedure ID
	INFPROC=9,	\integer forward procedure ID
	RLFPROC=10,	\real forward procedure ID
	INOPT=11,	\integer optimized procedure ID
	RLOPT=12,	\real optimized procedure ID
	INEPRO=13,	\integer xpl external procedure
	RLEPRO=14,	\real xpl external procedure
	ININT=15,	\integer intrinsic ID
	RLINT=16,	\real intrinsic ID
	INEXT=17,	\integer assembly language external procedure ID
	RLEXT=18;	\real assembly language external procedure ID

int	LEV,		\static level of current identifier
	VAL,		\value or address of current identifier
	SymNum,		\position in SYMTBL of current identifer
	FacTyp;		\factor (or operand) type (REAL or INTEGER)
def	\FacTyp\ REAL, INTEGER;
int	FIXES,		\array: 'quit' fixes still outstanding
	FIXCTR,		\count of the number of outstanding 'quit's
	LEVEL,		\static nesting level of current procedure
	NORLSY,		\current number of real constants in RLTBL
	NOSYM,		\current number of symbols in symbol table
	OptProc,	\flag: generate optimized, instead of normal, proc call
	StkLoad;	\number of integers left on stack by 'for' or 'case'

\Symbol table arrays:
char	SYMBOL,		\identifier names (Ident)
	SYMTYP,		\type descriptors (IdType)
	SYMLEV,		\level (LEV)
	SYMTAG;		\tag for warnings (0=unused, bit 0=used, 1=addr, 2=for,
			\ 4..7=number of declared array dimensions)
int	SYMVAL,		\value or address (VAL)
	SYMPTR,		\list linkage pointers
	BOX;		\hash boxes (symbol linked-list headers)
real	RLTBL;		\real constant table

int	HandInx,	\index to old include file handles
	OldHand;	\array of old include file handles

\Reserved word hash codes:
def	ADRSYM=$88E4,	BEGSYM=$84C7,	CASEYM=$8053,	CODSYM=$8184,
	DEFSYM=$9CC6,	DOSYM=$0CEF,	ELSEYM=$99F3,	ENDSYM=$99A4,
	EXITYM=$9B69,	EXTNYM=$9B74,	FALSYM=$944C,	FFUNYM=$94B5,
	FORSYM=$9592,	FPRSYM=$9672,	FUNSYM=$96CE,	GESYM=$0C85,
	GETSYM=$90D4,	IFSYM=$0D46,	INTSYM=$A9B4,	LESYM=$0DE5,
	LOOPYM=$BD8F,	NOTSYM=$B594,	OFSYM=$0D86,	PROCYM=$CE2F,
	QUITYM=$CAC9,	REALYM=$C4C1,	REPSYM=$C4D0,	RETSYM=$C4D4,
	THENYM=$DD65,	TRUSYM=$DE35,	UNTSYM=$D9B4,	WHILYM=$D169,
	CHARYM=$8161,	EPRSYM=$9A72,	EFUNYM=$98B5,	PUBSYM=$CEC2,
	OTHSYM=$B2E8,	INCSYM=$A9A3,	LSLSYM=$BE0C,	LSRSYM=$BE92,
	CONSYM=$818E,	ABSSYM=$8833,	REMSYM=$C4CD,	SWAPYM=$C281,
	EXTSYM=$9B74,	PORTYM=$CD92,	FIXSYM=$9558,	FLOSYM=$95EF,
	SQRTYM=$C252,	STRSYM=$C2F2,	ASMSYM=$8A0D,	SQSYM=$0E11,
	TOSYM=$0EEF,	DOWNYM=$9D97,	ASRSYM=$8A12,	ANDSYM=$89A4,
	ORSYM=$0D92,	XORSYM=$ED92;



func	GETBC;		\Get buffered character from device 8
int	C, D;		\Return EOF if end of program
begin
for D:= 1 to HandMax do
	[C:= ChIn(8);  if C#EOF then return C];
return C;
end;	\GETBC



proc	ERROR(N);	\Display error message N
int	N;
int	ERR, CH, I;
char	STRING;
def	MAXERR=75;	\maximum error number
begin
ERR:= Reserve((MAXERR+1)*IntSize);
for I:= 0 to MAXERR do ERR(I):= "? ";	\unused error numbers ="?"

ERR(0):= "INTERNAL ERROR ";
ERR(1):= "TOO MANY VARIABLES ";
ERR(2):= "TOO MANY REAL CONSTANT NAMES ";
ERR(3):= "TOO MANY NAMES ";
ERR(4):= "TOO MANY 'QUITS' ";
ERR(5):= "TOO MANY STATIC LEVELS ";
ERR(6):= "NUMBER OUT OF RANGE ";
ERR(7):= ERR(6);			\for intrinsic declarations
ERR(10):= "UNDECLARED NAME ";
ERR(11):= "NAME ALREADY DECLARED ";
ERR(20):= "ILLEGAL START OF A STATEMENT ";	\in ASSIGN
ERR(21):= "^":=^"* ";
ERR(22):= "'THEN'* ";
ERR(23):= "'DO'* ";
ERR(24):= "'TO' OR 'DOWNTO'* ";
ERR(26):= "ILLEGAL FACTOR ";		\unrecognizable special factor
ERR(27):= "STATEMENT STARTING WITH A CONSTANT "; \in ASSIGN
ERR(28):= "'UNTIL'* ";
ERR(29):= "'OTHER'* ";
ERR(30):= "'ELSE'* ";
ERR(31):= "DIGIT* ";
ERR(33):= "INTEGER VARIABLE* ";		\in a 'for' statement
ERR(37):= "REAL VALUE* ";
ERR(38):= "^">^"* ";		\ASR ->>
ERR(39):= "^"(^"* ";
ERR(40):= "^"=^"* ";
ERR(41):= "^";^"* ";
ERR(42):= "CONSTANT* ";			\in GETCON
ERR(43):= "VARIABLE* ";			\for an 'addr' operator
ERR(44):= "^")^"* ";
ERR(45):= "NAME* ";
ERR(46):= "MIXED MODE ";
ERR(47):= "INTEGER* ";
ERR(48):= "'OF'* ";
ERR(49):= "^":^"* ";
ERR(50):= "^"]^"* ";
ERR(51):= "NO ARGUMENTS DECLARED ";
ERR(52):= "STATEMENT STARTING WITH 'ELSE' ";
ERR(53):= "STATEMENT STARTING WITH 'OTHER' ";
ERR(54):= "ILLEGAL INTRINSIC CALL ";
ERR(60):= "'QUIT' NOT IN A 'LOOP' ";
ERR(61):= "EOF* ";
ERR(62):= "EOF INSIDE A BLOCK ";
ERR(63):= "EOF INSIDE A STRING ";
ERR(65):= "'FPROC' & ITS 'PROC' NOT AT SAME LEVEL ";
ERR(66):= "'FPROC' REFERENCE NOT FOUND ";
ERR(67):= "'PROC' OR 'FUNC'* ";
ERR(68):= "'EPROC'S AND 'PUBLIC'S MUST BE GLOBAL ";
ERR(69):= "'INCLUDE'S NESTED TOO DEEP ";
ERR(70):= "BAD FILE SPEC ";
ERR(71):= "FILE NOT FOUND ";
ERR(72):= "'INT', 'REAL', 'CHAR' or 'ADDR'* ";
ERR(73):= "DIVIDE BY ZERO ";
ERR(74):= "MATH ERROR IN A CONSTANT EXPRESSION ";
ERR(75):= "EXPRESSION MUST BE ENCLOSED IN PARENTHESES ";

if LstDev = 8 then
	begin
	OpenI(8);
	loop	begin
		CH:= GETBC;
		if CH=EOF then quit;
		ChOut(0, CH);
		end;
	CrLf(0);
	end;

ChOut(0, Bel);
CrLf(0);
Text(0, "***** ERROR NO. ");  IntOut(0, N);  Text(0, " *****");
CrLf(0);
STRING:= ERR(N);
I:= 0;
loop	begin
	CH:= STRING(I);			\output message
	if CH>=$80 then quit;
	if CH=^* then Text(0, " EXPECTED BUT NOT FOUND")
	else ChOut(0, CH);
	I:= I+1;
	end;
CrLf(0);
Text(0, "ATTEMPT TO CONTINUE (Y/N)? ");

Close(BinDev);
FClose(OutHand);
asm	ldr	r0, OutName		@ delete output file to prevent a
asm	bl	remove			@  possible infinite loop in iilo

OpenI(0);
case ChIn(0) of ^N, ^n: [Close(LstDev);  exit 1] other [];
BinDev:= 7;				\discard the output file
ErrCtr:= ErrCtr+1;
end;	\ERROR



proc	WARNING(N);	\Display warning message N
int	N;
int	WARN, CH, I;
char	STRING;
def	MAXWARN=10;	\maximum warning number
begin
if ~WarnFlag then return;
WARN:= Reserve((MAXWARN+1)*IntSize);
for I:= 0 to MAXWARN do WARN(I):= "? ";	\unused warning numbers = "?"

WARN(1):= "LOCAL NAME SAME AS MORE-GLOBAL NAME ";
WARN(2):= "ROUNDING ERRORS MAKE EQUALITY UNLIKELY ";
WARN(3):= "CONTROL CHARACTER ";
WARN(4):= "USE 'OTHER' INSTEAD OF 'ELSE' ";
WARN(5):= "COMMAS MISSING IN 'DEFINE' ";
WARN(7):= "DOUBLED UNARY OPERATOR: ++, --, OR ~~ ";
WARN(8):= "DEFINED BUT NOT USED ";
WARN(9):= "'ADDR' OF 'FOR' LOOP CONTROL VARIABLE ";
WARN(10):= "NUMBER OF SUBSCRIPTS ";

if LstDev = 8 then
	begin
	OpenI(8);
	loop	begin
		CH:= GETBC;
		if CH=EOF then quit;
		ChOut(0, CH);
		end;
	CrLf(0);
	end;

Text(0, "
***** WARNING NO. ");  IntOut(0, N);  Text(0, " *****
");
STRING:= WARN(N);
I:= 0;
loop	begin
	CH:= STRING(I);
	if CH>=$80 then quit;
	if CH=^* then Text(0, " EXPECTED BUT NOT FOUND")
		else ChOut(0, CH);
	I:= I+1;
	end;
CrLf(0);
Text(0, "CONTINUE (Y/N)? ");
OpenI(0);
case ChIn(0) of ^N, ^n: [Close(LstDev);  exit 1] other [];
end;	\WARNING



proc	CHKUSE(LIM);	\If warning, display unused identifier (symbol) names
int	LIM;
int	F, I, K, N, C;
begin
if not WarnFlag then return;
F:= false;
N:= NOSYM;
C:= 0;
while N>LIM do
	begin
	N:= N-1;
	if (SYMTAG(N)&$0F)=0 then	\UNUSED
		begin
		if ~F then
			begin
			CrLf(0);
			for I:= 0 to 78 do ChOut(0, ^*);
			CrLf(0);
			F:= true;
			end;
		K:= N;
		for I:= 0 to SigChar-1 do
			[ChOut(0, SYMBOL(K));  K:= K+SymMax];
		Text(0, "  ");
		C:= C+1;
		if (C&3)=3 then CrLf(0);
		end;
	end;
if F then
	begin
	if (C&3)#3 then CrLf(0);
	for I:= 0 to 78 do ChOut(0, ^*);
	CrLf(0);
	WARNING(8);
	end;
end;	\CHKUSE



proc	DEBDUMP;	\Dump .xpl source to output file for debug option (-d)
int	CH;


	func	DUMPLINE;	\Dump a line of source code as a comment
	begin
	CH:= GETBC;
	if CH=EOF then return false;
	Text(BinDev, "; ");
	loop	begin
		if CH=EOF then return false;
		ChOut(BinDev, CH);
		if CH=EOL then return true;
		CH:= GETBC;
		end;
	end;	\DUMPLINE


begin	\DEBDUMP
if LstDev=8 then
	begin
	OpenI(8);
	while DUMPLINE do;
	OpenO(8);
	end;
CrLf(BinDev);
end;	\DEBDUMP



proc	GETCH;		\Get a character from the source (input) device
begin
Char:= ChIn(SrcDev);  ChOut(LstDev, Char);
if Debug then
	if Char=EOL then DEBDUMP;
if Char=^\ then				\filter out comments
	begin
	Char:= ChIn(SrcDev);  ChOut(LstDev, Char);
	if Char=^\ then			\filter out rest of line
		loop   [Char:= ChIn(SrcDev);  ChOut(LstDev, Char);
			if Char=EOL then return;
			if Char=EOF then return]
	else	loop   [if Char=EOL then return;
			if Char=EOF then return;
			Char:= ChIn(SrcDev);  ChOut(LstDev, Char);
			if Char=^\ then [Char:= ^ ;  return]];
	end;
end;	\GETCH



proc	GETCH_;		\Get a non-underline character from the source device
repeat GETCH until Char#^_;

\---------------------- ROUTINES TO HANDLE INCLUDE FILES -----------------------

proc	FALLBACK;	\Terminate an include and fall back to previous handle
begin
HandInx:= HandInx-1;
FClose(InHand);
InHand:= OldHand(HandInx);
FSet(InHand, if HandInx=0 then ^I else ^i);  \only main file gets the big buffer
if LEVEL<0 then LEVEL:= 0;	\restore LEVEL used for auto 'code' declarations
end;	\FALLBACK



proc	INCLUDE;	\Set up an include file
char	NAME;
def	NAMMAX=80;
int	NEWHAND, I;


	proc	GETC;		\Get character with no filtering
	begin
	Char:= ChIn(SrcDev);
	ChOut(LstDev, Char);
	end;	\GETC


	func	GETNAME;	\Read file specification
	int	EXTFLG, I, K;
	char	DEFEXT;
	begin
	DEFEXT:= ".xpl";
	EXTFLG:= false;

	while Char<=$20 do		\eat leading spaces and control chars
		[if Char=EOF then ERROR(61);  GETC];

	K:= 0;				\copy file name into NAME
	loop	begin
		case Char of
		  ^.:	EXTFLG:= true;
		  EOL:	return false;
		  ^;:	quit
		other	[];

		NAME(K):= Char;
		K:= K+1;
		if K>=NAMMAX  then return false;
		GETC;
		end;

	if K=0 then return false;	\deal with empty filename

	if EXTFLG then			\deal with default extensions
		NAME(K-1):= NAME(K-1) ! $80
	else	begin
		if (K+4) >= NAMMAX then return false;
		for I:= 0 to 3 do NAME(K+I):= DEFEXT(I);
		end;
	return true;
	end;	\GETNAME


begin	\INCLUDE
NAME:= Reserve(NAMMAX);
if HandInx >= HandMax then
	[ERROR(69);  while Char#^; & Char#EOF do GETC;  return];
if not GETNAME then
	[ERROR(70);  while Char#^; & Char#EOF do GETC;  return];

Trap($FFFB);				\open file
NEWHAND:= FOpen(NAME, 0);
Trap($FFFF);
if GetErr = 3 then [ERROR(71);  return];

OldHand(HandInx):= InHand;		\save old file handle on stack
HandInx:= HandInx+1;
InHand:= NEWHAND;

FSet(InHand, ^i);			\include files always use small buffers

Text(0, "INCLUDING: ");
for I:= 2 to HandInx do Text(0, "   ");
Text(0, NAME);  CrLf(0);
end;	\INCLUDE



proc	INCLCODE;	\Include 'code' declarations
int	NEWHAND;
char	NAME;
begin
NAME:= "codesr.xpl";
Trap($FFFB);
NEWHAND:= FOpen(NAME, 0);
Trap($FFFF);
if GetErr=3 then
	[Text(0, "codesr.xpl not found");
	ERROR(71);  return];
OldHand(HandInx):= InHand;	\save old file handle on stack
HandInx:= HandInx+1;
InHand:= NEWHAND;
FSet(InHand, ^i);		\include files always use small buffers

Text(0, "INCLUDING: ");
Text(0, NAME);  CrLf(0);
end;	\INCLCODE

\-------------------------------------------------------------------------------

fproc	CONEXPRESS;
fproc	LOOKUP, TTxt;	\FOR 'ASM'



proc	RAtom;		\Read in an atom
\Outputs:  Atom, AType, Ident, Hash, IAtom, Char, RlAtom.
int	LEN, NEG, EXP, I, INTOVF, Braces;
real	FRACT, DENOM;


	proc	RFRACT;		\Read the fractional part of a real number
	begin
	AType:= RealCon;  Atom:= 0;
	GETCH_;
	FRACT:= Float(0);  DENOM:= Float(10);	\("10.0" is not as portable)
	while Char>=^0 & Char<=^9 do
		begin
		FRACT:= FRACT +Float(Char-^0) /DENOM;
		DENOM:= DENOM*Float(10);
		GETCH_;
		end;
	RlAtom:= RlAtom +FRACT;
	end;	\RFRACT


	proc	REXP;		\Read an exponent, if any
	if Char=^E ! Char=^e then
		begin
		AType:= RealCon;
		GETCH_;
		if Char=^- then [NEG:= true;  GETCH_]
		else NEG:= false;
		if Char=^+ then GETCH_;
		EXP:= 0;
		if Char<^0 ! Char>^9 then ERROR(31);
		while Char>=^0 & Char<=^9 do
			[EXP:= EXP*10 + Char-^0;  GETCH_];
		if NEG then EXP:= -EXP;
		while EXP>0 do
			[RlAtom:= RlAtom *Float(10);  EXP:= EXP-1];
		while EXP<0 do
			[RlAtom:= RlAtom /Float(10);  EXP:= EXP+1];
		end;	\REXP


	proc	DoAsmLine;	\Output a line of assembly code
	int	HaveComment, SDebug;
	begin
	SDebug:= Debug;  Debug:= false;	\don't let debug text interrupt asm code
	CrLf(BinDev);  ChOut(BinDev, ^`); \tell iil that this is an asm line
	HaveComment:= false;
	loop	begin
		if Char=^@ then HaveComment:= true;
		if not HaveComment then ChOut(BinDev, Char);
		GETCH;
		if Char>=^A & Char<=^Z & not HaveComment then
			begin
			RAtom;			\(AType=Identifier)
			LOOKUP;
			case IdType of
			  ADDRVAR, INVAR, RLVAR:
				[if LEV=0 then TTxt("[r10")
				else \if LEV=LEVEL then\ TTxt("[r11");
				\\else TTxt("[ebp]+");	\xplr can't support this
				TTxt(", #"); IntOut(BinDev, VAL); TTxt("]")];
			  INCON:
				[TTxt("#"); IntOut(BinDev, VAL)];
			  UNDEF:
				ERROR(10)
			other	ERROR(26);
			end;
		if Char=EOF then [ERROR(62);  exit 1];
		if not HaveComment then
			[if Char=^{ then Braces:= Braces+1;
			 if Char=^} then Braces:= Braces-1;
			];
		if Braces<=0 then quit;		\don't output final } to BinDev
		if Char=EOL then quit;
		end;
	CrLf(BinDev);
	GETCH;
	Debug:= SDebug;
	end;	\DoAsmLine


begin	\RAtom
while Char<=$20 do	\skip spaces, tabs, cr's, lf's, & ff's, etc.
	begin		\ but don't go past eof
			\if HandInx=0 then it's a hard EOF
	if Char=EOF then if HandInx>0 then FALLBACK
		    else [AType:= Special;  Atom:= EOF;  return];
	GETCH;
	end;
if Char>=^a then if Char<=^z then				\reserved word
	begin
	AType:= Special;
	Atom:= Char;  GETCH;
	Atom:= Atom<<5|Char;  GETCH;
	if Char>=^a & Char<=^z then [Atom:= Atom<<5|Char;  GETCH];
	Atom:= Atom & $0000FFFF;		\truncate to 16 bits
	while Char>=^a & Char<=^z do GETCH;
	case Atom of
	  TRUSYM: [AType:= IntCon;  Atom:= 0;  IAtom:= true];
	  FALSYM: [AType:= IntCon;  Atom:= 0;  IAtom:= false];
	  CONSYM: begin
		  RAtom;
		  CONEXPRESS;
		  if FacTyp=INTEGER then Conditional:= IAtom else ERROR(47);
		  while Atom=^; do RAtom;	\eat semicolon, if any
		  loop	begin			\eat atoms until cond=true
			if Conditional \#0\ then quit;
			if AType=Special then
			  if Atom=EOF then quit
			  else if Atom=^" then	\ignore "con" inside strings
			    begin
			    if Char#^" then	\null string ("")
			      loop begin
				 Char:= ChIn(SrcDev);  ChOut(LstDev, Char);
				 if Char=EOF then [ERROR(63);  exit 1];
				 if Char=^^ then
					[Char:= ChIn(SrcDev);  ChOut(LstDev, Char)]
				 else	if Char=^" then quit;
				 end;
			    GETCH;
			    end;
			RAtom;
			end;
		  end;
	  STRSYM: begin
		  RAtom;
		  CONEXPRESS;
		  if FacTyp=INTEGER then StrTerm:= IAtom else ERROR(47);
		  while Atom=^; do RAtom;	\eat semicolon, if any
		  end;
	  ASMSYM:
	    if Conditional then
	  	begin				\INSERT IN-LINE ASSEMBLY CODE
		while Char=$20\SPACE\ ! Char=$09\TAB\ do
			[ChOut(BinDev, Char);  GETCH];  \don't skip EOL
		Braces:= 1;
		if Char=^{ then
			begin
			GETCH;		\eat {
			Braces:= 1;
			repeat DoAsmLine until Braces<=0;
			GETCH;		\eat }
			end
		else	DoAsmLine;
		RAtom;		\return atom following 'asm' line(s)
		end;
	  INCSYM: [INCLUDE;  GETCH;  RAtom]
	other	[];
	return;
	end;
if Char>=^A then if Char<=^Z ! Char=^_ then			\identifier
	begin
	AType:= Identifier;  Atom:= 0;
	Ident(0):= Char;  Hash:= Char;  GETCH;
	LEN:= 1;
	loop	begin
		if not CaseSensitive then	\shift to uppercase
			if Char>=^a & Char<=^z then Char:= Char & $DF;
		case of
		  Char>=^A & Char<=^Z,  Char>=^a & Char<=^z,  Char>=^0 &
		  Char<=^9,  Char=^_ :
			begin
			if LEN <SigChar then
				begin
				Ident(LEN):= Char;
				Hash:= Hash+Char;
				LEN:= LEN+1;
				end;
			GETCH;
			end
		other	quit;
		end;
	for LEN:= LEN to SigChar-1 do
		[Ident(LEN):= ^ ;  Hash:= Hash+^ ];
	Hash:= Hash & HashMask;
	return;
	end;
if Char>=^0 then if Char<=^9 then			       \UNSIGNED INTEGER
	begin
	AType:= IntCon;		\assume integer until shown otherwise
	Atom:= 0;
	INTOVF:= false;
	IAtom:= Char-^0;  GETCH_;
	loop	begin
		I:= IAtom;
		if Char<^0 ! Char>^9 then quit;
		I:= IAtom*10+Char-^0;
		if IAtom>214748364 ! IAtom=214748364 & Char>^7 then
			[INTOVF:= true;  quit];	\overflowed, but ok if it's real
		IAtom:= I;
		GETCH_;
		end;
	RlAtom:= Float(IAtom);
	IAtom:= I;			\(can't Float(2147483648))
	while Char>=^0 & Char<=^9 do	\if more digits then it must be a real
		[RlAtom:= RlAtom*Float(10) + Float(Char-^0);  GETCH_];
	if Char=^. then RFRACT;					\UNSIGNED REAL
	REXP;
	if AType=IntCon & INTOVF & IAtom#$80000000 then
		if Conditional then ERROR(6);
	return;
	end;
case Char of
  ^.:	begin
	RlAtom:= Float(0);					\UNSIGNED REAL
	RFRACT;
	REXP;
	return;
	end;
  ^$:	begin						   \UNSIGNED HEX INTEGER
	AType:= IntCon;  Atom:= 0;
	GETCH_;
	case of
	  Char>=^0 & Char<=^9:	IAtom:= Char-^0;
	  Char>=^A & Char<=^F:	IAtom:= Char-$37;
	  Char>=^a & Char<=^f:	IAtom:= Char-$57
	other	[\DIGIT EXPECTED\ ERROR(31);  return];
	loop	begin
		GETCH_;
		case of
		  Char>=^0 & Char<=^9:	I:= Char-^0;
		  Char>=^A & Char<=^F:	I:= Char-$37;
		  Char>=^a & Char<=^f:	I:= Char-$57
		other return;
		if IAtom > $FFF_FFFF then
			if Conditional then ERROR(6);
		IAtom:= IAtom*16+I;
		end;
	end;
  ^%:	begin						\UNSIGNED BINARY INTEGER
	AType:= IntCon;  Atom:= 0;
	GETCH_;
	if Char>=^0 & Char<=^1 then IAtom:= Char-^0
	else [\DIGIT EXPECTED\ ERROR(31);  return];
	loop	begin
		GETCH_;
		if Char>=^0 & Char<=^1 then I:= Char-^0
		else return;
		if IAtom<0 then		\(if IAtom > $7FFF_FFFF ... unsigned)
			if Conditional then ERROR(6);
		IAtom:= IAtom*2+I;
		end;
	end;
  ^^:	begin
	AType:= IntCon;						\meta character
	Atom:= 0;				\=integer constant
	Char:= ChIn(SrcDev);  ChOut(LstDev, Char);
	if Char <$20 ! Char=$7F then WARNING(3);
	IAtom:= Char;
	GETCH;
	return;
	end;
  ^":	begin
	AType:= Special;				      \special character
	Atom:= Char;		\(' and backslash have no effect inside strings)
	Char:= ChIn(SrcDev);  ChOut(LstDev, Char);
	return;
	end
other	[];
AType:= Special;					      \special character
Atom:= Char;
GETCH;
case Char of
  ^=:	case Atom of
	^::	[GETCH;  Atom:= GETSYM];
	^>:	[GETCH;  Atom:= GESYM];
	^<:	[GETCH;  Atom:= LESYM]
	other	[];
  ^<:	[if Atom = ^< then [GETCH;  Atom:= LSLSYM]];
  ^>:	begin
	if Atom = ^> then [GETCH;  Atom:= LSRSYM]
	else if Atom = ^- then
		[GETCH;
		if Char#^> then ERROR(38);
		GETCH;
		Atom:= ASRSYM];
	end
other	[];
end;	\RAtom



proc	SKIPIT;		\Skip rest of a statement, for error recovery
begin
while Atom#EOF & Atom#^; & Atom#ENDSYM & Atom#^] & Atom#BEGSYM & Atom#^[ do
	RAtom;
end;	\SKIPIT



proc	SYMOUT(SYM);	\Output symbol name at SYM
int	SYM;
int	I, C;
begin
for I:= 0 to SigChar-1 do
	begin
	C:= SYMBOL(SYM);
	if C = $20 then return;
	ChOut(BinDev, C);
	SYM:= SYM + SymMax;
	end;
end;	\SYMOUT

\=============================== CODE GENERATOR ================================

proc	TTxt(STR);	\Output opcode string
char	STR;
int	I, CH;
begin
for I:= 0 to 32000 do
	begin
	CH:= STR(I);
	if CH >= $80 then
		[CH:= CH & $7F;   I:= 32000];
	if CH=^| then CrLf(BinDev) else ChOut(BinDev, CH);
	end
end;	\TTxt



proc	BUGMSG(S);	\Display message for internal compiler error (i.e: bug)
int	S;
begin
Text(0, "INTERNAL ERROR - ");  Text(0, S);  CrLf(0);
TTxt(";INTERNAL ERROR - ");  TTxt(S);  CrLf(BinDev);
ERROR(0);
end;	\BUGMSG



proc	Hex1Out(Dev, N); \Output one hex digit
int	Dev, N;
char	HexDigit;
begin
HexDigit:= "0123456789ABCDEF ";
ChOut(Dev, HexDigit(N & $0F));
end;	\Hex1Out



proc	Hex2Out(Dev, N); \Output two hex digits (a byte)
int	Dev, N;
begin
Hex1Out(Dev, N>>4);
Hex1Out(Dev, N);
end;	\Hex2Out



proc	Hex4Out(Dev, N); \Output four hex digits
int	Dev, N;
begin
Hex2Out(Dev, N>>8);
Hex2Out(Dev, N);
end;	\Hex4Out



proc	LabelData(N);	\Make a data label
int	N;
begin
TTxt("|L");	\"|" is necessary because there might already be a label here
IntOut(BinDev, N);
ChOut(BinDev, ^:);
end;	\LabelData



proc	LabelCode(N);	\Make a code (kode) label
int	N;
begin
TTxt("|K");	\"|" is necessary because there might already be a label here
IntOut(BinDev, N);
ChOut(BinDev, ^:);
if Debug then CrLf(BinDev);
end;	\LabelCode



func	NewLabel;	\Generate a new label number
begin
LabelNum:= LabelNum+1;
return LabelNum;
end;	\NewLabel



proc	GenOp(Op);		\Output a 1-byte opcode
int	Op;
begin
Hex2Out(BinDev, Op);  CrLf(BinDev);
end;	\GenOp



proc	GenLOD(Lev, Off);	\$01: TOS:= @(Level+Offset)
int	Lev, Off;
begin
TTxt("01 ");
Hex2Out(BinDev, Lev);  ChOut(BinDev, ^ );
Hex4Out(BinDev, Off);  CrLf(BinDev);
end;	\GenLOD



proc	GenSTO(Lev, Off);	\$03: @(Level+Offset):= TOS
int	Lev, Off;
begin
TTxt("03 ");
Hex2Out(BinDev, Lev);  ChOut(BinDev, ^ );
Hex4Out(BinDev, Off);  CrLf(BinDev);
end;	\GenSTO



proc	GenCAL(Lab, Ext);	\$05: Procedure call
int	Lab,
	Ext;	\flag: external procedure (eproc or efunc)
begin
TTxt("05 ");
Hex4Out(BinDev, Lab);  CrLf(BinDev);
end;	\GenCAL



proc	GenRET(Lev);		\$06:
int	Lev;
begin
TTxt("06 ");
Hex2Out(BinDev, Lev);  CrLf(BinDev);
end;	\GenRET



proc	GenJMP(Lable);		\$07:
int	Lable;
begin
TTxt("07 ");
Hex4Out(BinDev, Lable);  CrLf(BinDev);
end;	\GenJMP



proc	GenJPC(Lab, Sense);	\$08: Jump if TOS=false (or true)
int	Lab, Sense;	\normally sense = false, for jump on false
begin
TTxt("08 ");
Hex2Out(BinDev, Sense);  ChOut(BinDev, ^ );
Hex4Out(BinDev, Lab);  CrLf(BinDev);
end;	\GenJPC



proc	GenHPI(V);		\$09:
int	V;	\number of bytes of heap space to skip the heap pointer over
begin
TTxt("09 ");  Hex4Out(BinDev, V);  CrLf(BinDev);
end;	\GenHPI



proc	GenARG(BYTES);		\$0A: Move proc args from virtual stack to heap
int	BYTES;
begin
TTxt("0A ");  Hex4Out(BinDev, BYTES);  CrLf(BinDev);
end;	\GenARG



proc	GenIMM(T, V);		\$0B & $24:
int	T,	\type:	^L=label	^C=constant
	V;	\value:	label number	immediate
begin
TTxt("0B ");
Hex2Out(BinDev, T);  ChOut(BinDev, ^ );
if T = ^C then HexOut(BinDev, V)
	  else Hex4Out(BinDev, V);
CrLf(BinDev);
end;	\GenIMM



proc	GenCML(Lab, LAST, TYPE, FUNC, ARGS, BYTES);	\$0C: Intrinsic call
int	Lab, LAST, TYPE, FUNC, ARGS, BYTES;
int	IntTbl;
begin
include codesrx.xpl;
\\e.g:	true,  4,	\\var:=\Abs(int)=0
if IntTbl(Lab*2)#FUNC then ERROR(54);
\\CrLf(0); IntOut(0, BYTES); Text(0, "/"); IntOut(0, IntTbl(Lab*2+1)); CrLf(0);
if IntTbl(Lab*2+1)#BYTES then ERROR(54);

\If strings are null-terminated (i.e: 'string'=0) then convert the Text
\ intrinsic number 12 to 255. This is a Text routine that uses null
\ termination. (This Text routine is also called intr12a.)
if Lab=12 & StrTerm=0 then Lab:= 255;

TTxt("0C ");
Hex2Out(BinDev, Lab);  ChOut(BinDev, ^ );
Hex2Out(BinDev, LAST);  ChOut(BinDev, ^ );
Hex2Out(BinDev, TYPE);  ChOut(BinDev, ^ );
Hex2Out(BinDev, FUNC);  ChOut(BinDev, ^ );
Hex2Out(BinDev, ARGS);  CrLf(BinDev);
end;	\GenCML



proc	GenFOR(Label, Lev, Off, Downto); \$18, $49: Compare for 'for' loop
int	Label, Lev, Off, Downto;
begin
TTxt(if Downto then "49 " else "18 ");
Hex4Out(BinDev, Label);  ChOut(BinDev, ^ );
Hex2Out(BinDev, Lev);  ChOut(BinDev, ^ );
Hex4Out(BinDev, Off);  CrLf(BinDev);
end;	\GenFOR



proc	GenINP(Lev, Off, Downto);\$19, $4A: Increment/Decrement 'for' loop var.
int	Lev, Off, Downto;	\This also leaves a copy of the variable on TOS
begin
TTxt(if Downto then "4A " else "19 ");
Hex2Out(BinDev, Lev);  ChOut(BinDev, ^ );
Hex4Out(BinDev, Off);  CrLf(BinDev);
end;	\GenINP



proc	GenADR(Lev, Off);	\$21: Load the address of an integer variable
int	Lev, Off;
begin
TTxt("21 ");
Hex2Out(BinDev, Lev);  ChOut(BinDev, ^ );
HexOut(BinDev, Off);  CrLf(BinDev);
end;	\GenADR



proc	GenFADR(Lev, Off);	\$22: Load the address of a real variable
int	Lev, Off;
begin
TTxt("22 ");
Hex2Out(BinDev, Lev);  ChOut(BinDev, ^ );
HexOut(BinDev, Off);  CrLf(BinDev);
end;	\GenFADR



proc	GenCJP(Lab, Sense);	\$25: Case jump
int	Lab, Sense;	\normally Sense = false, for jump on false
begin
TTxt("25 ");
Hex2Out(BinDev, Sense);  ChOut(BinDev, ^ );
Hex4Out(BinDev, Lab);  CrLf(BinDev);
end;	\GenCJP



proc	GenJSR(Lab);		\$26: Optimized procedure call
int	Lab;
begin
TTxt("26 ");  Hex4Out(BinDev, Lab);  CrLf(BinDev);
end;	\GenJSR



proc	GenDRP(N);		\$28: Drop N items from hardware stack
int	N;	\number of 32-bit items
begin
if N > 0 then
	[TTxt("28 ");  Hex4Out(BinDev, N);  CrLf(BinDev)];
end;	\GenDRP



proc	GenCEXT(Lab, LAST, TYPE, FUNC, ARGS);	\$29: External assembly routine
int	Lab, LAST, TYPE, FUNC, ARGS;
begin
TTxt("	b	");  SYMOUT(Lab);  CrLf(BinDev);
end;	\GenCEXT



proc	GenFLOD(Lev, Off);	\$2A: Load a floating-point variable
int	Lev, Off;
begin
TTxt("2A ");
Hex2Out(BinDev, Lev);  ChOut(BinDev, ^ );
Hex4Out(BinDev, Off);  CrLf(BinDev);
end;	\GenFLOD



proc	GenFSTO(Lev, Off);	\$2B: Store a floating-point variable
int	Lev, Off;
begin
TTxt("2B ");
Hex2Out(BinDev, Lev);  ChOut(BinDev, ^ );
Hex4Out(BinDev, Off);  CrLf(BinDev);
end;	\GenFSTO



proc	GenFIMM(T, V);		\$2C: Load a floating-point constant
int	T,	\Type (^C or ^L)
	V;	\V (Value) is a 32-bit address of a pointer, for constant arrays
begin
TTxt("2C ");
Hex2Out(BinDev, T);  ChOut(BinDev, ^ );
Hex4Out(BinDev, V);
CrLf(BinDev);
end;	\GenFIMM



proc	DoGenFIMM(T, V);
int	T, V;		\arguments are not used
int	SPC, I;
char	P;
begin
GenOp($FC\DSTART\);

SPC:= NewLabel;
LabelData(SPC);
P:= addr RlAtom;
TTxt("FA");		\.byte
for I:= 0 to 7 do [ChOut(BinDev, ^ );  Hex2Out(BinDev, P(I))];
CrLf(BinDev);

GenOp($FD\DEND\);
GenFIMM(^C, SPC);
end;	\DoGenFIMM



proc	GenMATH(T);		\Select real or integer math opcodes
int	T;
begin
if T > $10 then GenOp(T\$2D-$30\) else
	case T of
	  $0D:	GenOp(\ADD\$0D);
	  $0E:	GenOp(\SUB\$0E);
	  $0F:	GenOp(\MUL\$0F);
	  $10:	GenOp(\DIV\$10)
	other	BUGMSG("GenMATH");
end;	\GenMATH



proc	GenARY(Lev);		\$48: 
int	Lev;
begin
TTxt("48 ");
Hex2Out(BinDev, Lev);  CrLf(BinDev);
end;	\GenARY



proc	GenREGARY(Lev, Off);	\$F6: Assign a register to an array
int	Lev, Off;
begin
TTxt("F6 ");
Hex2Out(BinDev, Lev);  ChOut(BinDev, ^ );
Hex4Out(BinDev, Off);  CrLf(BinDev);
end;	\GenREGARY



proc	GenOPTBASE(Lev);	\$F7: Generate start an optimized procedure
int	Lev;
begin
TTxt("F7 ");
Hex2Out(BinDev, Lev);
CrLf(BinDev);
end;	\GenOPTBASE



proc	GenBASE;		\$F4: Generate start of (nested) procedure
int	Lev;
begin
TTxt("F4 ");
Hex2Out(BinDev, Lev);
CrLf(BinDev);
end;	\GenBASE

\===============================================================================

proc	LOOKUP;			\Look up identifier in symbol table
\Inputs: Ident, Hash
\Outputs: IdType, VAL, LEV, SymNum.
\If two identifiers of the same name are in the symbol table then the most
\ recent entry is used.
int	I, K, PTR;
begin
PTR:= BOX(Hash);
loop	begin
	if PTR = EmptyPtr then [IdType:= UNDEF;  quit];
	I:= 0;  K:= PTR;
	while Ident(I)=SYMBOL(K) & I<SigChar do
		[I:= I+1;  K:= K+SymMax];
	if I=SigChar then			\found
		[IdType:= SYMTYP(PTR);
		VAL:= SYMVAL(PTR);
		LEV:= SYMLEV(PTR);
		SymNum:= PTR;			\(for forward proc)
		quit];
	PTR:= SYMPTR(PTR);
	end;
end;	\LOOKUP



proc	INSERT(STYP, SLEV, SVAL);
\Insert the current identifier into the symbol table
\Inputs:  STYP, SLEV, SVAL, Ident, Hash, NOSYM, SYMBOL, & BOX.
int	STYP, SLEV, SVAL;
int	I, K;
begin
LOOKUP;
if IdType # UNDEF then if LEV=LEVEL then \collision\ ERROR(11)
				    else WARNING(1);
if NOSYM >= SymMax then \table full\ [ERROR(3);  NOSYM:= SymMax-1];
K:= NOSYM;
for I:= 0 to SigChar-1 do [SYMBOL(K):= Ident(I);  K:= K+SymMax];
SYMTYP(NOSYM):= STYP;
SYMLEV(NOSYM):= SLEV;
SYMVAL(NOSYM):= SVAL;
SYMTAG(NOSYM):= 0;
SYMPTR(NOSYM):= BOX(Hash);			\link back
BOX(Hash):= NOSYM;
NOSYM:= NOSYM+1;
end;	\INSERT



proc	GETCON;			\Get a constant--either by value or by name
int	NEG;
begin
if Atom=^+ then RAtom;
if Atom=^- then [NEG:= true;  RAtom] else NEG:= false;
case AType of
  IntCon:
	[if NEG then IAtom:= -IAtom;
	FacTyp:= INTEGER];
  RealCon:
	[if NEG then RlAtom:= -RlAtom;
	FacTyp:= REAL];
  Identifier:
	begin
	LOOKUP;
	if IdType#UNDEF then SYMTAG(SymNum):= SYMTAG(SymNum)!$01;
	case IdType of
	 INCON:	[IAtom:= if NEG then -VAL else VAL;
		FacTyp:= INTEGER];
	 RLCON:	[RlAtom:= if NEG then-RLTBL(VAL) else RLTBL(VAL);
		FacTyp:= REAL]
	other	ERROR(42);
	end
other	ERROR(42);
end;	\GETCON

\-------------------------------------------------------------------------------

proc	CONEXPRESS;		\Evaluate constant expressions
\Outputs: FacTyp, IAtom, RlAtom
int	SFacTyp, ITEMP, IFVAR;
real	RTEMP;


	proc INTTEST;		\Test for integer errors
	if FacTyp # INTEGER then ERROR(47);


	proc MIXTEST(TYPE);	\Test for mixed mode errors
	int TYPE;
	if TYPE#FacTyp then ERROR(46);


	proc	CFACTOR;
	begin
	case Atom of
	  ^(:	begin
		RAtom;
		CONEXPRESS;
		if Atom#^) then ERROR(44);		
		end;
	ABSSYM:	begin					\absolute value function
		RAtom;
		if Atom#^( then ERROR(39) else RAtom;
		CONEXPRESS;
		if FacTyp=INTEGER then IAtom:= abs(IAtom)
				  else RlAtom:= abs(RlAtom);
		if Atom#^) then ERROR(44);
		end;
	SQRTYM:	begin					\square-root function
		RAtom;
		if Atom#^( then ERROR(39) else RAtom;
		CONEXPRESS;
		if FacTyp=INTEGER then IAtom:= sqrt(IAtom)
				  else RlAtom:= sqrt(RlAtom);
		if Atom#^) then ERROR(44);
		end;
	SQSYM:	begin					\square function
		RAtom;
		if Atom#^( then ERROR(39) else RAtom;
		CONEXPRESS;
		if FacTyp=INTEGER then IAtom:= sq(IAtom)
				  else RlAtom:= sq(RlAtom);
		if Atom#^) then ERROR(44);
		end;
	SWAPYM:	begin					\swap bytes function
		RAtom;
		if Atom#^( then ERROR(39) else RAtom;
		CONEXPRESS;
		if FacTyp#INTEGER then ERROR(47);
		IAtom:= swap(IAtom);
		if Atom#^) then ERROR(44);
		end;
	REMSYM:	begin					\remainder
		RAtom;
		if Atom#^( then ERROR(39) else RAtom;
		CONEXPRESS;
		if FacTyp#INTEGER then ERROR(47);
		IAtom:= Remainder;
		if Atom#^) then ERROR(44);
		end;
	FIXSYM:	begin					\fix function
		RAtom;
		if Atom#^( then ERROR(39) else RAtom;
		CONEXPRESS;
		if FacTyp#REAL then ERROR(37);
		IAtom:= Fix(RlAtom);
		FacTyp:= INTEGER;
		if Atom#^) then ERROR(44);
		end;
	FLOSYM:	begin					\float function
		RAtom;
		if Atom#^( then ERROR(39) else RAtom;
		CONEXPRESS;
		if FacTyp#INTEGER then ERROR(47);
		RlAtom:= Float(IAtom);
		FacTyp:= REAL;
		if Atom#^) then ERROR(44);
		end
	other	GETCON;
	RAtom;
	end;	\CFACTOR


	proc	CSHIFTEXP;
	int	ITEMP;
	begin
	CFACTOR;
	ITEMP:= IAtom;
	case Atom of
	LSLSYM:	begin
		INTTEST;
		RAtom;
		CFACTOR;
		INTTEST;
		IAtom:= ITEMP << IAtom;
		end;	
	LSRSYM:	begin
		INTTEST;
		RAtom;
		CFACTOR;
		INTTEST;
		IAtom:= ITEMP >> IAtom;
		end;
	ASRSYM:	begin
		INTTEST;
		RAtom;
		CFACTOR;
		INTTEST;
		IAtom:= ITEMP ->> IAtom;
		end
	other	[];
	end;	\CSHIFTEXP


	proc	CTERM;
	int	SFacTyp;
	int	ITEMP;
	real	RTEMP;
	begin
	CSHIFTEXP;
	SFacTyp:= FacTyp;
	loop	begin
		ITEMP:= IAtom;  RTEMP:= RlAtom;
		case Atom of
		  ^*:	begin
			RAtom;
			CSHIFTEXP;
			MIXTEST(SFacTyp);
			if FacTyp=INTEGER then IAtom:= ITEMP*IAtom
				else RlAtom:= RTEMP*RlAtom;
			end;
		  ^/:	begin
			RAtom;
			CSHIFTEXP;
			MIXTEST(SFacTyp);
			if IAtom=0 ! RlAtom=0.0 then ERROR(73) \divide by zero
			else if FacTyp=INTEGER then
				[IAtom:= ITEMP / IAtom;  Remainder:= Rem(0)]
				else RlAtom:= RTEMP/RlAtom;
			end
		other	quit;
		end;
	end;	\CTERM


	proc	CALGEXP;	\Algebriac expression
	int	SFacTyp;
	int	ITEMP;
	real	RTEMP;
	begin
	CTERM;
	SFacTyp:= FacTyp;
	loop	begin
		ITEMP:= IAtom;  RTEMP:= RlAtom;
		case Atom of
		  ^+:	begin
			RAtom;
			CTERM;
			MIXTEST(SFacTyp);
			if FacTyp=INTEGER then IAtom:= ITEMP+IAtom
			else RlAtom:= RTEMP+RlAtom;
			end;
		  ^-:	begin
			RAtom;
			CTERM;
			MIXTEST(SFacTyp);
			if FacTyp=INTEGER then IAtom:= ITEMP-IAtom
				else RlAtom:= RTEMP-RlAtom;
			end
		other	quit;
		end;
	end;	\CALGEXP


	proc	CLOGEXP;	\'not' and comparisons
	int	SFacTyp;
	int	ITEMP;
	real	RTEMP;
	begin
	if Atom=NOTSYM ! Atom=^~ then		\unary 'not' operator
		begin
		RAtom;
		CLOGEXP;
		INTTEST;
		IAtom:= ~IAtom;
		end
	else	begin
		CALGEXP;
		SFacTyp:= FacTyp;
		ITEMP:= IAtom;  RTEMP:= RlAtom;
		case Atom of
		 ^=:	[RAtom;
			CALGEXP;
			MIXTEST(SFacTyp);
			if FacTyp=INTEGER then IAtom:= ITEMP = IAtom
			else [IAtom:= RTEMP = RlAtom;  WARNING(2)];
			FacTyp:= INTEGER];
		 ^#:	[RAtom;
			CALGEXP;
			MIXTEST(SFacTyp);
			if FacTyp=INTEGER then IAtom:= ITEMP # IAtom
			else [IAtom:= RTEMP # RlAtom;  WARNING(2)];
			FacTyp:= INTEGER];
		 ^>:	[RAtom;
			CALGEXP;
			MIXTEST(SFacTyp);
			if FacTyp=INTEGER then IAtom:= ITEMP > IAtom
			else IAtom:= RTEMP > RlAtom;
			FacTyp:= INTEGER];
		 ^<:	[RAtom;
			CALGEXP;
			MIXTEST(SFacTyp);
			if FacTyp=INTEGER then IAtom:= ITEMP < IAtom
			else IAtom:= RTEMP < RlAtom;
			FacTyp:= INTEGER];
		 GESYM:	[RAtom;
			CALGEXP;
			MIXTEST(SFacTyp);
			if FacTyp=INTEGER then IAtom:= ITEMP >= IAtom
			else IAtom:= RTEMP >= RlAtom;
			FacTyp:= INTEGER];
		 LESYM:	[RAtom;
			CALGEXP;
			MIXTEST(SFacTyp);
			if FacTyp=INTEGER then IAtom:= ITEMP <= IAtom
			else IAtom:= RTEMP <= RlAtom;
			FacTyp:= INTEGER]
		other	[];
		end;
	end;	\CLOGEXP


	proc	CBOOLTERM;	\Boolean "&" expressions
	int	ITEMP;
	begin
	CLOGEXP;
	loop	begin
		ITEMP:= IAtom;
		if Atom=^& ! Atom=ANDSYM then
			begin
			INTTEST;
			RAtom;
			CLOGEXP;
			INTTEST;
			IAtom:= ITEMP & IAtom;
			end
		else quit;
		INTTEST;
		end;
	end;	\CBOOLTERM


begin	\CONEXPRESS
Trap(false);			\don't abort on div by 0 error
if Atom=IFSYM then		\'if' expression
	begin
	RAtom;
	CONEXPRESS;
	INTTEST;
	IFVAR:= IAtom;
	if Atom#THENYM then ERROR(22);
	RAtom;
	CONEXPRESS;
	SFacTyp:= FacTyp;
	ITEMP:= IAtom;  RTEMP:= RlAtom;
	if Atom#ELSEYM then ERROR(30);
	RAtom;
	CONEXPRESS;
	MIXTEST(SFacTyp);
	if IFVAR then
		if FacTyp=INTEGER then IAtom:= ITEMP
		else RlAtom:= RTEMP;
	end
else	begin
	CBOOLTERM;
	loop	begin
		ITEMP:= IAtom;
		case Atom of
		  ^!, ORSYM:
			begin
			INTTEST;
			RAtom;
			CBOOLTERM;
			INTTEST;
			IAtom:= ITEMP ! IAtom;
			end;
		  ^|, XORSYM:
			begin
			INTTEST;
			RAtom;
			CBOOLTERM;
			INTTEST;
			IAtom:= ITEMP | IAtom;
			end
		other	quit;
		end;
	end;
Trap(true);
if GetErr#0 then ERROR(74);	\general math error
end;	\CONEXPRESS

\-------------------------------------------------------------------------------

fproc	BOOLEXP;



proc	PROCAL(FUNC);
int	FUNC;	\true if function vs. procedure
int	SVAL, ARGCTR, BYTES, SID, CURSYM;
begin
SVAL:= VAL;  SID:= IdType;  CURSYM:= SymNum;
RAtom;
ARGCTR:= 0;
BYTES:= 0;
GenOp($ED\CLEAN\);
if Atom=^( then
	begin
	loop	begin
		RAtom;
		BOOLEXP;
		ARGCTR:= ARGCTR+1;
		BYTES:= BYTES + (if FacTyp=INTEGER then IntSize else RealSize);
		if FacTyp=REAL & SID#ININT & SID#RLINT then GenOp(\FARG\$E6);
		if Atom # ^, then quit;
		if SID>=INPROC & SID<=RLFPROC then []	\virtual stack for procs
		else if FacTyp=INTEGER then GenOp($EC\STK\); \h/w stack for rest
		end;
	if Atom#^) then ERROR(44) else RAtom;
	end;
case of
  SID>=INPROC & SID<=RLFPROC:				\normal procedure call
	[if ARGCTR>0 then GenARG(BYTES);
	GenCAL(SVAL, false)]

other	case SID of
	  ININT, RLINT:					\intrinsic call
		GenCML(SVAL, FacTyp, SID, FUNC, ARGCTR, BYTES);
	  INOPT, RLOPT:					\optimized proc call
		[if ARGCTR>0 then ERROR(51);		\no arg declared
		GenJSR(SVAL)];
	  INEXT, RLEXT:	GenCEXT(CURSYM, FacTyp, SID, FUNC, ARGCTR);\ext asm call
	  INEPRO, RLEPRO:					   \ext xpl call
		[if ARGCTR>0 then GenARG(BYTES);
		GenCAL(CURSYM, true)]
	other	[];
end;	\PROCAL



proc	FACTOR;



func	STRCON;	\Generate code for a string constant and return its address
int	SPC,	\label number of starting address of string
	CTR,	\count of characters on current line of output
	NChar,	\next character (one character look ahead)
	DONE;	\flag: terminating quote mark has been read in


	proc	GetNextCh;	\Get next chararacter
	begin
	Char:= NChar;  NChar:= ChIn(SrcDev);
	if NChar=EOF then [ERROR(63);  exit 1];
	ChOut(LstDev, NChar);
	if NChar=^^ then
		begin		\convert to control characters, except ^ and Del
		NChar:= ChIn(SrcDev);
		if NChar=EOF then [ERROR(63);  exit 1];
		ChOut(LstDev, NChar);
		if NChar>=^@ & NChar<=^_ & NChar#^^ then NChar:= NChar-^@;
		if NChar>=^` & NChar<=^~ then NChar:= NChar-^`;
		end
	else if NChar=^" then	\terminating quote mark
		begin
		if StrTerm \#0\ then Char:= Char!$80;	\terminate with MSB set
		DONE:= true;
		end;
	end;	\GetNextCh


	proc	OctOut(N);	\Output 3-digit octal number
	int	N;
	begin
	ChOut(BinDev, ^\);
	ChOut(BinDev, (N>>6&7)+^0);
	ChOut(BinDev, (N>>3&7)+^0);
	ChOut(BinDev, (N&7)+^0);
	end;	\OctOut


begin	\STRCON		Enter with Char = first character in string (or close ")
SPC:= NewLabel;		\make a label at the starting address of the string
LabelData(SPC);
if Char#^" then		\in case of null string (i.e: ""; must be 0 terminated)
	begin
	if Char=^^ then
		begin		\convert to control characters, except ^ and Del
		Char:= ChIn(SrcDev);
		if Char=EOF then [ERROR(63);  exit 1];
		ChOut(LstDev, Char);
		if Char>=^@ & Char<=^_ & Char#^^ then Char:= Char-^@;
		if Char>=^` & Char<=^~ then Char:= Char-^`;
		end;
	NChar:= Char;			\so GetNextCh restores Char
	DONE:= false;
	CTR:= 0;
	loop	begin
		GetNextCh;
		if CTR=0 then TTxt("FB ^"");			\.ascii
		case of
		  Char=^":   [OctOut(Char);  CTR:= CTR+4];	\asm delimiter
		  Char=^\:   [OctOut(Char);  CTR:= CTR+4];	\asm meta char
		  Char>=$20: [ChOut(BinDev, Char);  CTR:= CTR+1];
		  Char=$09:  [ChOut(BinDev, Char);  CTR:= CTR+1] \show tabs
		other	     [OctOut(Char);  CTR:= CTR+4];
		if DONE then [ChOut(BinDev, ^");  quit];
		if CTR >= 40 then
			begin
			ChOut(BinDev, ^");  CrLf(BinDev);
			CTR:= 0;
			end;
		end;	\loop
	CrLf(BinDev);
	end;
if StrTerm = 0 then TTxt("FA 0|");	\terminate string with a null character
GETCH;
FacTyp:= INTEGER;
return SPC;		\return label number for starting address of string
end;	\STRCON



func	ARRAYCON;	\Constant arrays
int	THISEL, NEXTEL, PTR, SPC, I, INDIRECT, SFacTyp;
def	NULL=$FFFFFFFF;
char	ENTRY, R;

	proc	ARRAYX;	\(WARNING: This must be an optimized procedure
	begin		\ for the Reserve to work properly - i.e. no locals.)
	RAtom;
	INDIRECT:= true;
	case Atom of
	  ^[:	[ENTRY:= ARRAYCON;  RAtom];
	  ^":	[ENTRY:= STRCON;  RAtom]
	other	begin
		INDIRECT:= false;
		CONEXPRESS;
		if FacTyp=INTEGER then ENTRY:= IAtom
		else	[ENTRY:= Reserve(RealSize);  	\FacTyp=REAL
			R:= addr RlAtom;
			for I:= 0 to RealSize-1 do ENTRY(I):= R(I)];
		end;
	NEXTEL:= Reserve(3*IntSize);
	THISEL(1):= ENTRY;
	THISEL(2):= INDIRECT;
	THISEL(0):= NEXTEL;
	NEXTEL(0):= NULL;
	THISEL:= NEXTEL;
	end;	\ARRAYX


begin	\ARRAYCON
PTR:= Reserve(3*IntSize);
THISEL:= PTR;
THISEL(0):= NULL;
ARRAYX;
while Atom=^, do
	[SFacTyp:= FacTyp;
	ARRAYX;
	if FacTyp#SFacTyp then \mixed mode\ ERROR(46)];
if Atom#^] then ERROR(50);

SPC:= NewLabel;
LabelData(SPC);
while PTR(0)#NULL do				\dump list
	begin
	ENTRY:= PTR(1);
	if FacTyp=INTEGER then
		begin
		TTxt("F9 ");			\.word
		if PTR(2) \indirect\ then ChOut(BinDev, ^L);
		IntOut(BinDev, ENTRY);
		end
	else	begin				\(FacTyp=REAL)
		if PTR(2) \indirect\ then
			begin
			TTxt("F9 ");		\.word
			if PTR(2) \indirect\ then ChOut(BinDev, ^L);
			IntOut(BinDev, ENTRY);  ChOut(BinDev, ^ );
			IntOut(BinDev, $3FF00000);	\(iil expects decimal)
			end
		else	begin
			TTxt("FA");		\.byte
			for I:= 0 to 7 do
				[ChOut(BinDev, ^ );
				Hex2Out(BinDev, ENTRY(I));
				];
			end;
		end;
	PTR:= PTR(0);
	CrLf(BinDev);
	end;
return SPC;	\return starting address of array
end;	\ARRAYCON



proc	SPECFAC;	\Special character factor
int	SVAL, SID, SAtom, I;
begin
case Atom of
  ^(:	[RAtom;					\parenthesized expression
	BOOLEXP;				\(factor type is unchanged)
	if Atom#^) then ERROR(44);
	RAtom];
  ^":	[GenOp($FC\DSTART\);			\string constant
	SVAL:= STRCON;
	GenOp($FD\DEND\);
	GenIMM(^L, SVAL);
	RAtom];
  ^[:	[GenOp($FC\DSTART\);			\constant array
	SVAL:= ARRAYCON;
	GenOp($FD\DEND\);
	if FacTyp=INTEGER then GenIMM(^L, SVAL)
	else GenFIMM(^L, SVAL);			\FacTyp=REAL
	RAtom];
  ADRSYM, ^@:
	begin					\get absolute heap address
	SAtom:= Atom;
	RAtom;
	if AType#Identifier then ERROR(45);
	LOOKUP;
	if IdType#UNDEF then SYMTAG(SymNum):= SYMTAG(SymNum)!$01;
	case IdType of
	  INVAR, RLVAR, ADDRVAR:
		begin
		SID:= IdType;
		RAtom;
		if Atom=^( then			\indexed
			begin
			GenLOD(LEV, VAL);	\(even for reals)
			RAtom;
			BOOLEXP;		\1st index
			if FacTyp#INTEGER then ERROR(47);
			while Atom=^, do	\multiple indexing
				begin
				case SID of
				  INVAR, ADDRVAR:
				  	 GenOp(\DBX\$20); \TOS:= @(TOS*4+NOS)
				  RLVAR: GenOp(\TRX\$39)  \TOS:= @(TOS*8+NOS)
				other	 [];
				RAtom;
				BOOLEXP;
				if FacTyp#INTEGER then ERROR(47);
				end;
			case SID of
			  INVAR: GenOp(\DBA\$1E);	\TOS:= TOS*4 + NOS
			  RLVAR: begin
				 FacTyp:= INTEGER;
				 if SAtom = ^@ then
					[FacTyp:= REAL;
					for I:= 1 to RealSize/IntSize-1 do
						GenIMM(^C, 0);
					];
				 GenOp(\TRA\$38);	\TOS:= TOS*8 + NOS
				 end;
			  ADDRVAR: GenOp(\ADD\$0D)
			other	 [];
			if Atom#^) then ERROR(44) else RAtom;
			end
		else	begin
			if SID=RLVAR & SAtom=^@ then
				[FacTyp:= REAL;    GenFADR(LEV, VAL)]
			else	[FacTyp:= INTEGER;  GenADR(LEV, VAL)];
			end;
		end;
	  UNDEF:	ERROR(10)		\(undeclared name)
	other		ERROR(43);		\(variable expected)
	end;
  ABSSYM:
	begin					\absolute value function
	RAtom;
	if Atom#^( then ERROR(39) else RAtom;
	BOOLEXP;
	if FacTyp=INTEGER then GenOp(\ABS\$56) else GenOp(\FABS\$57);
	if Atom#^) then ERROR(44) else RAtom;
	end;
  REMSYM:
	begin					\remainder of last divide
	RAtom;
	if Atom#^( then ERROR(39) else RAtom;
	BOOLEXP;
	if FacTyp#INTEGER then ERROR(47);
	GenOp(\REM\$4B);
	if Atom#^) then ERROR(44) else RAtom;
	end;
  SWAPYM:
	begin					\swap bytes function
	RAtom;
	if Atom#^( then ERROR(39) else RAtom;
	BOOLEXP;
	if FacTyp#INTEGER then ERROR(47);
	GenOp(\SWAP\$4C);
	if Atom#^) then ERROR(44) else RAtom;
	end;
  EXTSYM:
	begin					\sign extend function
	RAtom;
	if Atom#^( then ERROR(39) else RAtom;
	BOOLEXP;
	if FacTyp#INTEGER then ERROR(47);
	GenOp(\EXT\$4D);
	if Atom#^) then ERROR(44) else RAtom;
	end;
  PORTYM:
	begin					\read byte from port
	RAtom;
	if Atom#^( then ERROR(39) else RAtom;
	BOOLEXP;
	if FacTyp#INTEGER then ERROR(47);
	GenOp(\PIN\$4E);
	if Atom#^) then ERROR(44) else RAtom;
	end;
  FIXSYM:
	begin					\fix function
	RAtom;
	if Atom#^( then ERROR(39) else RAtom;
	BOOLEXP;
	if FacTyp#REAL then ERROR(37);
	GenOp(\FIX\$50);
	FacTyp:= INTEGER;
	if Atom#^) then ERROR(44) else RAtom;
	end;
  FLOSYM:
	begin					\float function
	RAtom;
	if Atom#^( then ERROR(39) else RAtom;
	BOOLEXP;
	if FacTyp#INTEGER then ERROR(47);
	GenOp(\Float\$51);
	FacTyp:= REAL;
	if Atom#^) then ERROR(44) else RAtom;
	end;
  SQRTYM:
	begin					\sqrt function
	RAtom;
	if Atom#^( then ERROR(39) else RAtom;
	BOOLEXP;
	if FacTyp=INTEGER then GenOp(\SQRT\$53) else GenOp(\FSQRT\$52);
	if Atom#^) then ERROR(44) else RAtom;
	end;
  SQSYM:
	begin					\square function
	RAtom;
	if Atom#^( then ERROR(39) else RAtom;
	BOOLEXP;
	if FacTyp=INTEGER then GenOp(\SQ\$55) else GenOp(\FSQ\$54);
	if Atom#^) then ERROR(44) else RAtom;
	end
other	\illegal factor\ ERROR(26);
end;	\SPECFAC



proc	IDFAC;		\Identifier factor
int	SID, SSN, DIMS;
begin
LOOKUP;
if IdType#UNDEF then SYMTAG(SymNum):= SYMTAG(SymNum)!$01;
SID:= IdType;
SSN:= SymNum;		\for warnings
case IdType of
 UNDEF:	ERROR(10);

 INVAR, RLVAR, ADDRVAR:				\variable
	begin
	if SID=RLVAR then GenFLOD(LEV, VAL) else GenLOD(LEV, VAL);
	RAtom;
	DIMS:= 0;				\count dimensions for warnings
	if Atom=^( then				\it is indexed
		begin
		loop	begin
			RAtom;
			BOOLEXP;
			if FacTyp#INTEGER then ERROR(47);
			DIMS:= DIMS+1;
			if Atom#^, then quit;
			if SID=RLVAR then GenOp(\TRI\$3A) else GenOp(\DBX\$20);
				\rlTOS:= @(TOS*8+rlNOS) else TOS:= @(TOS*4+NOS)
			end;
		if Atom#^) then ERROR(44) else RAtom;
		case SID of
		 INVAR:   GenOp(\DBX\$20);	\TOS:= @(TOS*4+NOS)
		 RLVAR:   GenOp(\TRI\$3A);	\rlTOS:= @(TOS*8+rlNOS);
		 				\e.g: A(3);  A=NOS, 3=TOS
		 ADDRVAR: GenOp(\LDX\$02) \TOS:= @((NOS)+TOS);  A(3) A=NOS 3=TOS
		other	[];

		if DIMS # SYMTAG(SSN)>>4 then
			begin			\DIMS is >= 1
			if SYMTAG(SSN)>>4#0 & DIMS#0 then WARNING(10);
			SYMTAG(SSN):= SYMTAG(SSN) & $0F ! DIMS<<4;  \use new num
			end;
		end;
	end;

 INCON:	begin					\integer constant identifier
	GenIMM(^C, VAL);
	RAtom;
	end;

 RLCON:	begin					\real constant identifier
	RlAtom:= RLTBL(VAL);  DoGenFIMM(^C, 0);
	RAtom;
	end

other	begin					\procedure used as a function
	PROCAL(true);
	if SID<ININT then
		if SID&1 then [GenLOD(0, 0);  GenOp($EB\REG\)]
			 else GenFLOD(0, 0);
	end;

FacTyp:= if SID & 1 then INTEGER else REAL;	\odd IDs are integer
end;	\IDFAC



begin	\FACTOR
while Atom=^+ do [RAtom;  if Atom=^+ then WARNING(7)];	\ignore unary "+"
if Atom=^- then					\unary "-"
	begin
	RAtom;
	if Atom=^- then WARNING(7);
	FACTOR;
	if FacTyp=INTEGER then GenOp(\NEG\$11) else GenOp(\FNEG\$31);
	end
else	case AType of
	  Special:	SPECFAC;
	  IntCon:	[FacTyp:= INTEGER;	\integer constant
			GenIMM(^C, IAtom);
			RAtom];
	  RealCon:	[FacTyp:= REAL;		\real constant
			DoGenFIMM(^C, 0);
			RAtom]
	other		IDFAC;			\AType = Identifier (by default)
end;	\FACTOR



proc	SHIFTEXP;

	proc	SHIFTX;
	begin
	if FacTyp # INTEGER then \integer expected\ ERROR(47);
	RAtom;  FACTOR;
	if FacTyp # INTEGER then ERROR(47);
	end;	\SHIFTX

begin	\SHIFTEXP
FACTOR;
case Atom of
  LSLSYM: [SHIFTX;  GenOp(\LSL\$3E)];	\ <<
  LSRSYM: [SHIFTX;  GenOp(\LSR\$3F)];	\ >>
  ASRSYM: [SHIFTX;  GenOp(\ASR\$3D)]	\->>
other	  [];
end;	\SHIFTEXP



proc	TERM;
int	SFacTyp;

	proc	TERMX(INOP, RLOP);
	int	INOP, RLOP;
	begin
	RAtom;  SHIFTEXP;
	if SFacTyp#FacTyp then \mixed mode\ ERROR(46);
	GenMATH(if FacTyp=INTEGER then INOP else RLOP);
	end;	\TERMX

begin	\TERM
SHIFTEXP;
SFacTyp:= FacTyp;
loop	case Atom of
	  ^*:	TERMX(\MUL\$0F, \MULF\$2F);
	  ^/:	TERMX(\DIV\$10, \DIVF\$30)
	other	quit;
end;	\TERM



proc	ALGEXP;		\Algebraic expression
int	SFacTyp;

	proc	ALGX(INOP, RLOP);
	int	INOP, RLOP;
	begin
	RAtom;  TERM;
	if SFacTyp#FacTyp then \mixed mode\ ERROR(46);
	GenMATH(if FacTyp=INTEGER then INOP else RLOP);
	end;	\ALGX

begin	\ALGEXP
TERM;
SFacTyp:= FacTyp;
loop	case Atom of
	  ^+:	ALGX(\ADD\$0D, \ADDF\$2D);
	  ^-:	ALGX(\SUB\$0E, \SUBF\$2E)
	other	quit;
end;	\ALGEXP


int	HaveCMP;	\flag: set by LOGEXP and used by SHORTER


proc	LOGEXP;		\Logical expression
int	SFacTyp;

	proc	LOGX(INOP, RLOP);
	int	INOP, RLOP;
	begin
	RAtom;  ALGEXP;
	if SFacTyp#FacTyp then \mixed mode\ ERROR(46);
	GenOp(\CMP $12-$17 or $32-$37\ if FacTyp=INTEGER then INOP else RLOP);
	FacTyp:= INTEGER;
	HaveCMP:= true;
	end;	\LOGX

begin	\LOGEXP
if Atom=NOTSYM ! Atom=^~ then			\unary 'not' operator
	begin
	RAtom;
	if Atom=NOTSYM ! Atom=^~ then WARNING(7);
	LOGEXP;
	if FacTyp#INTEGER then ERROR(47);
	GenOp(\NOT\$1C);
	end
else	begin
	ALGEXP;
	SFacTyp:= FacTyp;
	case Atom of
	  ^=:	[LOGX(\EQ\$12, \EQF\$32);  if FacTyp=REAL then WARNING(2)];
	  ^#:	[LOGX(\NE\$13, \NEF\$33);  if FacTyp=REAL then WARNING(2)];
	  ^>:	LOGX(\GT\$15, \GTF\$35);
	  ^<:	LOGX(\LT\$17, \LTF\$37);
	  GESYM:LOGX(\GE\$14, \GEF\$34);
	  LESYM:LOGX(\LE\$16, \LEF\$36)
	other	[HaveCMP:= false];
	end;
end;	\LOGEXP



proc	BOOLTERM;	\Boolean "&" expressions
begin
LOGEXP;
loop	begin
	if Atom=^& ! Atom=ANDSYM then
		[if FacTyp#INTEGER then ERROR(47);
		RAtom;  LOGEXP;  GenOp(\AND\$1B)]
	else	quit;
	if FacTyp#INTEGER then ERROR(47);
	end;
end;	\BOOLTERM



func	SHORTER(LT, LF);  \Short-circuit evaluate boolean expressions
int	LT, LF;	    \labels to jump to if boolean expression is true or false
int	LTUSED, LFUSED;	 \flags

\if LOGEXP then STATEMENT
\Labels:       ^LT       ^LF
\Example:
\if N=1  !  N=2  !  N=3 & N=4 & N=5  !  N=6  !  N=7 then ...
\
\		CMP	N, 1
\		JE	LT
\		CMP	N, 2
\		JE	LT
\
\		CMP	N, 3
\		JNE	LF0
\		CMP	N, 4
\		JNE	LF0
\		CMP	N, 5
\		JE	LT
\	LF0:				;initial false label
\		CMP	N, 6
\		JE	LT
\		CMP	N, 7
\		JNE	LF1
\	LT:				;there is only one true label
\		CALL	STATEMENT
\	LF1:				;final false label is returned

begin
LTUSED:= false;
LFUSED:= false;
loop	begin
	RAtom;
	LOGEXP;
	loop	begin
		if Atom=^& ! Atom=ANDSYM then
			begin		\beware of masking, e.g: if F & 3 then
			if HaveCMP then			\last op was a compare
				begin
				GenJPC(LF, false);	\jump to false label
				LFUSED:= true;		\label is used
				RAtom;  LOGEXP;
				end
			else
				[RAtom;  LOGEXP;  GenOp(\AND\$1B)];  \old way
			end
		else quit;
		end;
	case Atom of
	  ^!, ORSYM:
		begin
		GenJPC(LT, true);	\conditionally jump to true label
		LTUSED:= true;		\indicate that true label was used
		if LFUSED then		\if there is a conditional jump using
			begin		\ this label then...
			LabelCode(LF);	\make label for false destination
			LF:= NewLabel;	\make another false label
			LFUSED:= false;	\this one isn't used yet
			end;
		end;
	  ^|, XORSYM, IFSYM: \must use parentheses for xor and 'if' expressions
		ERROR(75)
	other	quit;
	end;
GenJPC(LF, false);
if LTUSED then LabelCode(LT);		\only make label if it is actually used
return LF;				\return (possibly new) false label
end;	\SHORTER



proc	BOOLEXP;	\Boolean expression. Outputs factor type (FacTyp).
int	P1, P2, P3, SFacTyp;


	proc	IFEXP;
	begin				\if BOOLEXP then BOOLEXP else BOOLEXP
	GenOp($ED\CLEAN\);
	if ShortBool then		\Labels:      P1^     P2^          P3^
		begin
		P1:= NewLabel;		\true label
		P2:= NewLabel;		\false label
		P2:= SHORTER(P1, P2);	\returns false label (may be different)
		end
	else	begin
		RAtom;
		BOOLEXP;
		P2:= NewLabel;		\false label
		GenJPC(P2, false);	\skip statement if BOOLEXP is false
		end;

	if Atom # THENYM then ERROR(22);
	RAtom;
	BOOLEXP;
	SFacTyp:= FacTyp;
	GenOp(\REG\$EB);		\used by iilo to move (int) TOS into r0
	GenOp(\VDRP\$F1);		\a lie that gets fixed below. TOS must
	if Atom # ELSEYM then ERROR(30);\ be in the same state for both paths.
	P3:= NewLabel;
	GenJMP(P3);
	LabelCode(P2);

	RAtom;
	BOOLEXP;
	if SFacTyp#FacTyp then \mixed mode\ ERROR(46);
	GenOp(\REG\$EB);		\used by iilo to move (int) TOS into r0
	LabelCode(P3);
	end;	\IFEXP



	proc	BEXPX;		\Common code for BOOLEXP
	begin
	if FacTyp # INTEGER then \integer expected\ ERROR(47);
	RAtom;  BOOLTERM;
	if FacTyp # INTEGER then ERROR(47);
	end;	\BEXPX


begin	\BOOLEXP
if Atom=IFSYM then IFEXP			\'if' expression
else	begin					\boolean "!" (or) expressions
	BOOLTERM;
	loop	case Atom of
		  ^!, ORSYM:	[BEXPX;  GenOp(\OR\$1A)];
		  ^|, XORSYM:	[BEXPX;  GenOp(\EOR\$1D)]
		other quit;
	end;
end;	\BOOLEXP

\-------------------------------------------------------------------------------

proc	SSTATEMENT(SSTK);	\(For 'quit's in 'case' statements)
int	SSTK;



proc	STATEMENT;
int	P1, P2, P3, SFIXS, SLEV, SVAL, SFacTyp, Downto;



proc	ASSIGN;		\Assignment statement (also includes procedure calls)
int	SID, SSN, DIMS;

	proc	ASSX;
	begin
	if Atom#GETSYM then ERROR(21);
	RAtom;
	BOOLEXP;	\right-hand side of assignment
	end;	\ASSX

begin	\ASSIGN
if Atom=PORTYM then	\port($123):= BOOLEXP
	begin
	RAtom;
	if Atom#^( then ERROR(39) else RAtom;
	BOOLEXP;
	if FacTyp#INTEGER then ERROR(47);
	if Atom#^) then ERROR(44) else RAtom;
	ASSX;
	GenOp(\POUT\$4F);
	if FacTyp#INTEGER then ERROR(47);
	return;
	end;

if AType#Identifier then			\illegal start of a statement
	[ERROR(20);  SKIPIT;  return];
LOOKUP;  if IdType=UNDEF then [ERROR(10);  SKIPIT;  return];
SLEV:= LEV;  SVAL:= VAL;		\save these for Gen. An interim
SID:= IdType;				\ BOOLEXP in ASSX changes LEV & VAL
SSN:= SymNum;

case of
  IdType>=INPROC & IdType<=RLEXT:
	[SYMTAG(SymNum):= SYMTAG(SymNum)!$01;  PROCAL(false)];

  IdType=INVAR ! IdType=RLVAR ! IdType=ADDRVAR:
	begin
	SFacTyp:= if IdType=RLVAR then REAL else INTEGER;
	RAtom;
	DIMS:= 0;				\initialize count of dimensions
	if Atom=^( then				\indexed
		begin
		SYMTAG(SymNum):= SYMTAG(SymNum)!$01;
		GenLOD(SLEV, SVAL);		\(even for reals)
		RAtom;
		BOOLEXP;			\1st index
		if FacTyp#INTEGER then ERROR(47);
		DIMS:= DIMS+1;
		while Atom=^, do		\multiple indexing
			begin
			if SFacTyp=INTEGER then
				GenOp(\DBX\$20) else GenOp(\TRX\$39);
				\TOS:= @(TOS*4+NOS) else TOS:= @(TOS*8+NOS)
			RAtom;
			BOOLEXP;
			if FacTyp#INTEGER then ERROR(47);
			DIMS:= DIMS+1;
			end;
		if Atom#^) then ERROR(44) else RAtom;
		case SID of
		 INVAR:   GenOp(\DBA\$1E);	\TOS:= TOS*4 + NOS
		 RLVAR:   GenOp(\TRA\$38);	\TOS:= TOS*8 + NOS
		 ADDRVAR: []
		other	  [];

		ASSX;				\TOS now points to array element
		if FacTyp#SFacTyp then \mixed mode\ ERROR(46);
		case SID of
		 INVAR:   GenOp(\STD\$1F);	\@(NOS):= (int)TOS
		 RLVAR:   GenOp(\STT\$3B);	\@(NOS):= (real)TOS
		 ADDRVAR: GenOp(\STX2\$E5)	\@(NOS2+NOS):= (char)TOS
		other	  [];
		end

	else	[ASSX;
		if FacTyp#SFacTyp then \mixed mode\ ERROR(46);
		if SFacTyp=INTEGER then GenSTO(SLEV, SVAL)
		else GenFSTO(SLEV, SVAL)];

	if DIMS # SYMTAG(SSN)>>4 then
		begin	\A:= Reserve(); and A:= [...]; will give false warning
		if SYMTAG(SSN)>>4#0 & DIMS#0 then WARNING(10);
		SYMTAG(SSN):= SYMTAG(SSN) & $0F ! DIMS<<4;	\use new number
		end;
	end

other	\statement starting with a constant\ [ERROR(27);  SKIPIT];
end;	\ASSIGN



proc	CASER(TYPE);
int	TYPE;
int	SPC1, SPC2, SPC3, MULTILABEL;
begin
if TYPE = $25\CJP\ then GenOp($EB\REG\);	\put TOS into r0
SPC2:= NewLabel;
repeat	MULTILABEL:= false;
	loop	begin
		RAtom;				\case label:
		BOOLEXP;
		if FacTyp#INTEGER then ERROR(47);
		if Atom#^, then quit;
		if ~MULTILABEL then
			[SPC3:= NewLabel;  MULTILABEL:= true];
		if TYPE=$08 then GenJPC(SPC3, true) else GenCJP(SPC3, true);
		end;
	SPC1:= NewLabel;
	if TYPE = $08\JPC\ then GenJPC(SPC1, false) else GenCJP(SPC1, false);
	if MULTILABEL then LabelCode(SPC3);
	if Atom#^: then [ERROR(49);  SKIPIT;  return];

	if TYPE = $25\CJP\ then GenOp($F1\VDRP\);	\no need to save r0
	RAtom;
	STATEMENT;					\labeled statement
	if TYPE = $25\CJP\ then GenOp($EF\VPSH\);	\restore r0 case value
	GenJMP(SPC2);				\skip out of case statement
	LabelCode(SPC1);
until Atom#^;;

if Atom#ELSEYM & Atom#OTHSYM then ERROR(29);
if Atom=ELSEYM then WARNING(4);

if TYPE = $25\CJP\ then GenOp($F1\VDRP\);	\no need to save r0
RAtom;
STATEMENT;					\'other' statement
if TYPE = $25\CJP\ then GenOp($EF\VPSH\);	\restore r0 case value
LabelCode(SPC2);
end;	\CASER



begin	\STATEMENT
case Atom of
BEGSYM, ^[:
	begin
	RAtom;
	loop	begin
		if Atom=ELSEYM then [ERROR(52);  RAtom];
		if Atom=OTHSYM then [ERROR(53);  RAtom];
		STATEMENT;
		case Atom of
		  ^;:	RAtom;
		  ENDSYM, ^]:
			quit;
		  EOF:	[ERROR(62);  exit 1]
		other	\semi expected\ ERROR(41);
		end;
	RAtom;		\read past the 'end'
	end;

CASEYM:	begin					\case statement
	RAtom;
	if Atom=OFSYM then CASER(\JPC\$08)
	else	begin
		GenOp($F0\VPSHADR\);	\kludge to avoid problem with returns
		BOOLEXP;
		if FacTyp#INTEGER then ERROR(47);
		if Atom#OFSYM then [ERROR(48);  SKIPIT;  return];
		StkLoad:= StkLoad+1;
		CASER(\CJP\$25);
		GenDRP(1);		\balance hardware stack
		StkLoad:= StkLoad-1;
		GenOp($F1\VDRP\);	\balance iilo's virtual stack
		GenOp($F1\VDRP\);
		end;
	end;

QUITYM:	begin
	GenDRP(StkLoad-SSTK);
	if FIXCTR>=QuitMax then [ERROR(4);  FIXCTR:= QuitMax-1];
	FIXES(FIXCTR):= NewLabel;		\'quit' statement
	GenJMP(FIXES(FIXCTR));   	\(will be "fixed" at end of 'loop')
	FIXCTR:= FIXCTR+1;
	RAtom;
	end;

IFSYM:	begin				\if BOOLEXP then STATEMENT
	if ShortBool then		\Labels:      P1^       P2^
		begin
		P1:= NewLabel;		\true label
		P2:= NewLabel;		\false label
		P2:= SHORTER(P1, P2);	\returns false label (may be different)
		end
	else	begin
		RAtom;
		BOOLEXP;
		P2:= NewLabel;		\false label
		GenJPC(P2, false);	\skip statement if BOOLEXP is false
		end;
	if Atom # THENYM then [ERROR(22);  SKIPIT;  return];
	RAtom;
	STATEMENT;
	if Atom = ELSEYM then
		begin		      \if BOOLEXP then STATEMENT else STATEMENT
		P3:= NewLabel;	      \Labels:      P1^       P2^            P3^
		GenJMP(P3);
		LabelCode(P2);
		P2:= P3;		\change name of P2 exit label to be P3
		RAtom;
		STATEMENT;
		end;
	LabelCode(P2);
	end;

REPSYM:	begin
	P2:= NewLabel;			\repeat statement
	LabelCode(P2);
	repeat RAtom;  STATEMENT until Atom#^;;
	if Atom#UNTSYM then [ERROR(28);  SKIPIT;  return];
	RAtom;
	BOOLEXP;
	GenJPC(P2, false);
	end;

WHILYM:	begin				\     while BOOLEXP do STATEMENT
	P1:= NewLabel;			\Labels: P1^        P2^       P3^
	LabelCode(P1);
	if ShortBool then
		begin
		P2:= NewLabel;		\true label
		P3:= NewLabel;		\false label
		P3:= SHORTER(P2, P3);	\returns false label
		end
	else	begin
		RAtom;
		BOOLEXP;
		P3:= NewLabel;
		GenJPC(P3, false);
		end;
	if Atom # DOSYM then [ERROR(23);  SKIPIT;  return];
	RAtom;
	STATEMENT;
	GenJMP(P1);
	LabelCode(P3);
	end;

RETSYM:	begin				\return statement
	RAtom;
	GenDRP(StkLoad);
	if Atom#ELSEYM & Atom#OTHSYM & Atom#^; & Atom#^] &
	    Atom#ENDSYM & Atom#UNTSYM then	\store the returned
		[BOOLEXP;			\ value in global 0
		if FacTyp=INTEGER then GenSTO(0, 0) else GenFSTO(0, 0);
		];
	if OptProc then GenOp(\RTS\$27) else GenRET(LEVEL);
	end;

LOOPYM:	begin				\loop statement
	SFIXS:= FIXCTR;
	RAtom;
	P2:= NewLabel;
	LabelCode(P2);
	SSTATEMENT(StkLoad);
	GenJMP(P2);
	while FIXCTR>SFIXS do		\fix the jumps for the 'quit's
		[FIXCTR:= FIXCTR-1;  LabelCode(FIXES(FIXCTR))];
	GenOp(\XR7\$E9);		\bomb iilo's r7 tracking
	end;

FORSYM:	begin				\for statement
	RAtom;
	if AType#Identifier then [ERROR(33);  SKIPIT;  return];
	LOOKUP;				\control variable
	if IdType=UNDEF then ERROR(10)
	else	[if IdType#INVAR & IdType#ADDRVAR then ERROR(33);
		SYMTAG(SymNum):= SYMTAG(SymNum)!$01];	\mark control var used
	SLEV:= LEV;  SVAL:= VAL;
	RAtom;
	if Atom#GETSYM then [ERROR(21);  SKIPIT;  return];
	RAtom;				\initial value
	BOOLEXP;
	if FacTyp#INTEGER then ERROR(47);
	GenSTO(SLEV, SVAL);

	Downto:= false;
	if Atom=TOSYM ! Atom=^, then []
	else if Atom=DOWNYM then Downto:= true
	else [ERROR(24);  SKIPIT;  return];

	RAtom;				\limit value
	BOOLEXP;
	if FacTyp#INTEGER then ERROR(47);
	if Atom#DOSYM then [ERROR(23);  SKIPIT;  return];

	GenLOD(SLEV, SVAL);		\load control variable
	GenOp($E8\FORSET\);		\used by iilo; ignored by iil 
	P2:= NewLabel;
	GenJMP(P2);			\jump to FOR op

	P3:= NewLabel;
	LabelCode(P3);			\top of 'for' loop
	RAtom;
	StkLoad:= StkLoad+1;
	STATEMENT;
	StkLoad:= StkLoad-1;
	GenINP(SLEV, SVAL, Downto);
	LabelCode(P2);
	GenFOR(P3, SLEV, SVAL, Downto);
	end;

EXITYM:	[RAtom;					\exit statement
	if Atom#ELSEYM & Atom#OTHSYM & Atom#^; & Atom#^] &
	    Atom#ENDSYM & Atom#UNTSYM then	\store the returned
		[BOOLEXP;			\ value in global 0
		if FacTyp=INTEGER then GenSTO(0, 0) else GenFSTO(0, 0)];
	GenOp(\EXIT\$00)];

ELSEYM, OTHSYM, ^;, ^], ENDSYM, UNTSYM:	[];

EOF:	[]					\(this is mostly academic)
other	ASSIGN;
end;	\STATEMENT



begin	\SSTATEMENT
\Trick to adjust stack (with DRP's) when a 'quit' is in a 'case' statement.
STATEMENT;
end;	\SSTATEMENT

\-------------------------------------------------------------------------------

proc	PROCEDURE; int SSNOX;	\SSNO from PROCDEC for optimized procedures
int	SLEVEL,		\save level (complicated by optimized procedures)
	P1,
	HEAPSPOff,	\variable's offset from base (= heap space)
	HaveGenBASE,	\flag: have generated "set-base" code for procedure
	OldCode,	\determines if code is in the Main procedure
	FPBASE,		\LabelNum at end of declarations
	FPROCTR,	\count of pending forward procedures
	AryCnt;		\count of declared arrays



proc	EATARGS;	\Skip arguments in parentheses
begin
if Atom=^( then
	begin
	loop	[if Char=^) then quit;
		if Char=EOL then [ERROR(44);  quit];
		GETCH];
	GETCH;  RAtom;
	end;
end;	\EATARGS



proc	CODDEC;		\Declare intrinsic names
int	SID;
begin
SID:= ININT;		\default is integer intrinsic
RAtom;
if Atom=REALYM then [SID:= RLINT;  RAtom]
else if Atom=INTSYM then RAtom;
if AType#Identifier then ERROR(45);
while AType=Identifier do
	[RAtom;
	EATARGS;
	if Atom#^= then ERROR(40);
	RAtom;
	GETCON;  if FacTyp#INTEGER then ERROR(47);
	if IAtom<0 ! IAtom>127 then ERROR(7);
	INSERT(SID, LEVEL, IAtom);
	RAtom;
	if Atom=^, then RAtom];
if Atom#^; then ERROR(41) else RAtom;
end;	\CODDEC



proc	CONDEC;		\Declare constant names
int	CTR, SSNO;
begin
RAtom;
CTR:= 0;
if AType#Identifier then ERROR(45);
while AType=Identifier do
	begin
	RAtom;
	if Atom#^= then [INSERT(INCON, LEVEL, CTR);  CTR:= CTR+1]
	else	begin
		SSNO:= NOSYM;
		INSERT(INCON, LEVEL, NORLSY);	\insert ID now; fix up the rest
		RAtom;				\ of the parameters later
		CONEXPRESS;
		if FacTyp=INTEGER then [SYMVAL(SSNO):= IAtom;  CTR:= IAtom+1]
		else	[SYMTYP(SSNO):= RLCON;	\FacTyp=REAL
			if NORLSY>=RealMax then
				[ERROR(2);  NORLSY:= RealMax-1];
			RLTBL(NORLSY):= RlAtom;
			NORLSY:= NORLSY+1];
		end;
	if Atom=^, then RAtom else if Atom#^; then WARNING(5);
	end;
if Atom#^; then ERROR(41) else RAtom;
end;	\CONDEC



proc	VARDEC(TYPE);	\Declare variables: int, real, and char
int	TYPE;
int	DIMS, T, ST, SOff, SNS;
begin
RAtom;
if AType#Identifier then ERROR(45);
while AType=Identifier do
	begin
	SNS:= NOSYM;		\save array variable location for warning check
	INSERT(TYPE, LEVEL, HEAPSPOff);
	SOff:= HEAPSPOff;	\save address of possible array declaration
	HEAPSPOff:= HEAPSPOff + (if TYPE=RLVAR then RealSize else IntSize);
	T:= if TYPE=RLVAR then RealSize else IntSize;
	ST:= T;
	if TYPE=ADDRVAR then ST:= 1;
	RAtom;
	if Atom=^( then				\get dimension(s) of an array
		begin
		DIMS:= 0;
		loop	begin
			RAtom;
			CONEXPRESS;
			if FacTyp#INTEGER then ERROR(47);
			\Push sizes of each dimension onto stack
			GenIMM(^C, IAtom);  GenOp($EC\STK\);
			DIMS:= DIMS+1;		\count number of dimensions
			if Atom # ^, then	\last dimension of char array is
				begin		\ only a single byte per entry
				if ST=1 then T:= T/IntSize;
				T:= T*IAtom;
				if ST=1 then T:= T+3 & $FFFFFFFC;  \(IntSize=4)
						\keep aligned on 4-byte boundary
				quit;
				end;
			end;
		if Atom#^) then ERROR(44) else RAtom;

		\Generate code to set up the array at run time, for example:
		\MakeArray( (3, 5, 7), 3, IntSize);
		GenIMM(^C, DIMS);  GenOp($EC\STK\);    \number of dimensions (3)
		GenIMM(^C, ST);    GenOp($EC\STK\);    \bytes in each element
		GenIMM(^C, SOff);  GenOp($EC\STK\);
		GenREGARY(LEVEL, SOff);
		AryCnt:= AryCnt+1;
		SYMTAG(SNS):= DIMS<<4;	\save dimensions for the warning check
		end;
	if Atom=^, then RAtom;
	end;
if Atom#^; then ERROR(41) else RAtom;
end;	\VARDEC



proc	EXTDEC(XPL);	\Declare external procedures (both eproc and ext)
int	XPL;		\flag: XPL-type external (eproc), not assembly (ext)
int	SID, D;
begin
SID:= if XPL then INEPRO else INEXT;	\default is integer external

RAtom;					\handle real vs. integer procedure
if Atom=REALYM then [SID:= if XPL then RLEPRO else RLEXT;  RAtom]
else if Atom=INTSYM then RAtom;
if AType#Identifier then ERROR(45);

D:= 0;
while AType=Identifier do
	begin
	INSERT(SID, LEVEL, IAtom);
	RAtom;
	EATARGS;
	if Atom=^, then RAtom;
	TTxt("	EXTRN	");
	if XPL then ChOut(BinDev, ^_);
	SYMOUT(NOSYM-1);  TTxt(":NEAR|");
	D:= D+1;
	end;
if Atom#^; then ERROR(41) else RAtom;
end;	\EXTDEC



proc	FPRDEC;		\Declare forward-referenced procedures
int	SID, I;
begin
SID:= INFPROC;		\default type
RAtom;
if Atom=REALYM then [SID:= RLFPROC;  RAtom]
else if Atom=INTSYM then RAtom;
if AType#Identifier then ERROR(45);
while AType=Identifier do
	begin
	RAtom;
	I:= NewLabel;
	INSERT(SID, LEVEL, I);
	LabelCode(I);
	GenJMP(NewLabel);
	FPROCTR:= FPROCTR+1;
	EATARGS;
	if Atom=^, then RAtom;
	end;
if Atom#^; then ERROR(41) else RAtom;
end;	\FPRDEC



proc	PROCDEC(CANOPT, PUBLIC);	\Declare procedure names
int	CANOPT, PUBLIC;
int	SNOSYM, Hash, I, K, SID, SSNO, SNORL;
begin
SID:= INPROC;				\typed procedure (for functions)
RAtom;
if Atom=REALYM then [SID:= RLPROC;  RAtom]
else if Atom=INTSYM then RAtom;
if AType#Identifier then ERROR(45) else LOOKUP;

if IdType=INFPROC ! IdType=RLFPROC then
	\Procedure has been previously declared by a 'fproc' or 'ffunct'
	begin
	if LEVEL#LEV then ERROR(65);	\('fproc' & 'proc' must be same scope)
	if PUBLIC then			\handle public procedures
		begin
		TTxt("	PUBLIC	_");
		SYMOUT(SymNum);
		TTxt("|_");
		SYMOUT(SymNum);
		TTxt(":|");
		end;
	LabelCode(VAL+1);
	SYMVAL(SymNum):= VAL+1;
	SYMTYP(SymNum):= if IdType=INFPROC then INPROC else RLPROC;
	if SID#SYMTYP(SymNum) then \mixed mode\ ERROR(46);
	if VAL>=FPBASE then FPROCTR:= FPROCTR-1;
	OptProc:= false;
	end
else	begin
	SSNO:= NOSYM;
	I:= NewLabel;
	INSERT(SID, LEVEL, I);
	if PUBLIC then			\handle public procedures
		begin
		TTxt("	PUBLIC	_");
		SYMOUT(NOSYM-1);
		TTxt("|_");
		SYMOUT(NOSYM-1);
		TTxt(":|");
		end;
	LabelCode(I);
	OptProc:= CANOPT;
	end;

\Assume for now that procedure is not optimized and move down a static level
SLEVEL:= LEVEL;
LEVEL:= LEVEL+1;  if LEVEL >= LevelMax then ERROR(5);
\Eat the argument list as a comment. This special comment stops at end of line.
while Char#^; & Char#EOL do GETCH;
if Char#^; then ERROR(41);
GETCH;  RAtom;

SNOSYM:= NOSYM;  SNORL:= NORLSY;
PROCEDURE(SSNO);	\pass location of proc name in case it's optimized
CHKUSE(SNOSYM);
if Atom#^; then ERROR(41) else RAtom;
while NOSYM>SNOSYM do	\restore symbol table to previous level
	begin		\i.e. remove identifiers which were local to this proc
	NOSYM:= NOSYM-1;
	Hash:= 0;  K:= NOSYM;
	for I:= 0 to SigChar-1 do
		[Hash:= Hash+SYMBOL(K);  K:= K+SymMax];
	BOX(Hash&HashMask):= SYMPTR(NOSYM);
	end;
NORLSY:= SNORL;
LEVEL:= SLEVEL;
end;	\PROCDEC



begin	\PROCEDURE
HEAPSPOff:= if LEVEL<=0 then RealSize else 0;	\save heap space for return
HaveGenBASE:= false;
AryCnt:= 0;
FPROCTR:= 0;
FPBASE:= LabelNum;

repeat
  loop	begin
	case Atom of
	  INTSYM: VARDEC(INVAR);
	  ADRSYM: VARDEC(ADDRVAR);
	  CHARYM: VARDEC(ADDRVAR);
	  REALYM: VARDEC(RLVAR);
	  CODSYM: CODDEC;
	  EXTNYM: EXTDEC(false);
	  DEFSYM: CONDEC;
	  EPRSYM, EFUNYM:
		  if LEVEL=0 then EXTDEC(true) else [ERROR(68);  SKIPIT]
	other	  quit;
	end;

  \Process lower level procedures...
  case Atom of
    PUBSYM, PROCYM, FUNSYM, FPRSYM, FFUNYM:
	begin
	P1:= NewLabel;
	GenJMP(P1);
	end
  other P1:= 0 \null\;

  loop	begin
	case Atom of
	  PUBSYM:
		[if LEVEL#0 then ERROR(68);
		RAtom;
		case Atom of PROCYM, FUNSYM: PROCDEC(false, true)
		other ERROR(67)];
	  PROCYM, FUNSYM:
		PROCDEC(true, false);
	  FPRSYM, FFUNYM:
		FPRDEC			\'fproc' cannot precede a 'def'
	other	quit;
	end;

  if P1#0 then LabelCode(P1);

until	Atom#INTSYM & Atom#ADRSYM & Atom#CHARYM & Atom#REALYM & Atom#CODSYM &
	Atom#EXTNYM & Atom#DEFSYM & Atom#EPRSYM & Atom#EFUNYM;


if HEAPSPOff#0 then OptProc:= false;
if OptProc then
	begin
	SYMTYP(SSNOX):= if SYMTYP(SSNOX)=INPROC then INOPT else RLOPT;
	LEVEL:= LEVEL-1;	\same level as nesting procedure (tricky!)
	GenOPTBASE(LEVEL);
	end
else	begin			\reserve space for local variables
	GenOp($F5\BASEARY\);	\(required for lr even if no declared arrays)
	if HEAPSPOff>0 then GenHPI(HEAPSPOff);
	while AryCnt>0 do
		[GenARY(LEVEL);
		AryCnt:= AryCnt-1;
		];
	GenBASE(LEVEL);
	end;

SSTATEMENT(StkLoad);			\(StkLoad will always be zero here)

if OptProc then GenOp(\RTS\$27) else GenRET(LEVEL);

if FIXCTR#0 then \some 'quit's not in a 'loop'\ ERROR(60);
if FPROCTR#0 then \unresolved forward references\ ERROR(66);
end;	\PROCEDURE

\------------------------ ROUTINES TO OPEN DOS FILES ---------------------------

string 0;
proc	DOSOpen;	\Open input and output files
int	T, I, Ch;
char	CmdTail;

	func	GetSwitch;	\Find, remove, and return a command-line switch
	int	P, T;
	begin
	for P:= 1 to CmdTail(0) do
	    if CmdTail(P) = ^- then
		begin
		CmdTail(P):= $20;
		if P < CmdTail(0) then
			begin
			T:= CmdTail(P+1);
			if T>=^A & T<=^Z then T:= T+$20;  \make lowercase
			CmdTail(P+1):= $20;
			return T;
			end;
		end;
	return 0;
	end;	\GetSwitch


	proc	Parse;		\Parse command tail and set I/O handles
	char	ExtIn, ExtOut;
	int	P, ExtFlag, I;
	begin
	ExtIn:= ".xpl";   ExtOut:= ".iil";
	P:= 1;
	ExtFlag:= false;
	loop	begin			\Parse command tail for extension
		if CmdTail(P) = ^. then
			begin
			ExtFlag:= true;
			quit;
			end;
		if CmdTail(P) = ^; then quit;	\ignore semicolon
		if P > CmdTail(0) then quit;	\if quit then P points to 0
		P:= P+1;
		end;

	\Back up over any trailing spaces (caused by switches)
	repeat P:= P-1 until CmdTail(P) # ^ ;
	P:= P+1;
	if not ExtFlag then			\append input file extension
		for I:= 0 to 4 do CmdTail(P+I):= ExtIn(I);
	InHand:= FOpen(CmdTail+1, 0);
	for I:= 0 to 4 do CmdTail(P+I):= ExtOut(I);
	OutHand:= FOpen(CmdTail+1, 1);

	CopyMem(OutName, CmdTail+1, P+I);	\used to delete file if error
	I:= 0;					\skip mysterious leading spaces
	while OutName(I) = $20 do I:= I+1;
	OutName:= OutName+I;
	end;	\Parse


begin	\DOSOpen
CmdTail:= Reserve($80+4);
I:= 1;				\get file name from command line
repeat	Ch:= ChIn(8);
	CmdTail(I):= Ch;
	I:= I+1;
until	Ch=0 ! Ch=EOF;
CmdTail(0):= I-2;	\number of characters in CmdTail not including last 0

loop	begin				\handle switches
	T:= GetSwitch;
	case T of
	  ^a:	[BinDev:= 0;  LstDev:= 7];
	  ^b:	ShortBool:= true;	\short-circuit boolean evaluation
	  ^c:	CaseSensitive:= true;
	  ^d:	Debug:= true;
	  ^l:	LstDev:= 0;
	  ^w:	WarnFlag:= true;
	   0:	quit			\no more switches on command line
	other	begin
		Text(0, "Unrecognized switch: -");  ChOut(0, T);  CrLf(0);
		Text(0, "Usage: xpl0 [options] source(.xpl)
   -a: display iil codes
   -b: do short circuit Boolean evaluations
   -c: make identifer names Case-sensitive
   -d: include xpl0 source in output file (Debug)
   -l: display source code Listing
   -w: display Warning messages
");
		exit 1;
		end;
	end;
Parse;
FSet(InHand, ^I);
FSet(OutHand, ^O);
end;	\DOSOpen
string 1;

\-------------------------------------------------------------------------------

int	I;
begin	\Main
Ident:= Reserve(SigChar);
FIXES:= Reserve(QuitMax*IntSize);
SYMBOL:= Reserve(SigChar*SymMax);	\symbol table
SYMTYP:= Reserve(SymMax);
SYMVAL:= Reserve(SymMax*IntSize);
SYMLEV:= Reserve(SymMax);
SYMTAG:= Reserve(SymMax);
SYMPTR:= Reserve(SymMax*IntSize);
BOX:= Reserve(BoxNum*IntSize);		\hash table
RLTBL:= RlRes(RealMax);

OldHand:= Reserve(HandMax*IntSize);	\include arrays

Text(0, "
     -- XPL0 VER 2.2 --
COPYRIGHT 2018 P.J.R. BOYLE

XPL0 comes with ABSOLUTELY NO WARRANTY.
This is free software. You are welcome and encouraged to redistribute
it under certain conditions. For details see LICENSE.TXT.

");
ShortBool:= false;
Debug:= false;
CaseSensitive:= false;
WarnFlag:= false;
BinDev:= 3;  LstDev:= 8;  SrcDev:= 3;
DOSOpen;
OpenO(BinDev);  OpenO(LstDev);  OpenI(SrcDev);

LabelNum:= 0;  LEVEL:= 0;			\initialize some stuff
StkLoad:= 0;  NOSYM:= 0;  NORLSY:= 0;  FIXCTR:= 0;
for I:= 0 to BoxNum do BOX(I):= EmptyPtr;	\empty the symbol table
ErrCtr:= 0;
HandInx:= 0;
Conditional:= true;
StrTerm:= -1;	\default to MSB string termination (nonzero)
Remainder:= 0;

LEVEL:= -1;		\automatically include 'code' declarations
INCLCODE;		\ such that they can be overwritten by
GETCH;  RAtom;		\ explicit 'code' declarations

OptProc:= false;	\(for two reasons)
PROCEDURE(0);		\compile main procedure (the program)
CHKUSE(0);
while Atom=^; do RAtom;
if Atom#EOF then \more code after end\ [ERROR(61);  PROCEDURE(0)];

Close(BinDev);

CrLf(LstDev);
Text(LstDev, "ERRORS DETECTED: ");  IntOut(LstDev, ErrCtr);  CrLf(LstDev);
Close(LstDev);
CrLf(0);

FClose(OutHand);  FClose(InHand);
return if ErrCtr#0 then 1 else 0;
end;	\Main
