\xpllib.xpl	16-Mar-2018	Version 1.0
\
\BEWARE: This file can be included in an xpl program to provide these many
\ useful routines, but unlike intrinsics, these routines might change in later
\ versions. If you want to be certain that changes here don't break your
\ programs, it's best to copy and paste the routines you use into your code.

string	0;			\null-terminated strings are the standard here

def	IntSize = 4;		\number of bytes in an integer

def	Nul=$00, Bel=$07, BS=$08, Tab=$09, LF=$0A, FF=$0C,	\control chars
	CR=$0D, EOF=$1A, Esc=$1B, Sp=$20, Ctrl=$40;		\e.g: ^A-Ctrl

def	UpArrow=$48, DnArrow=$50, LtArrow=$4B, RtArrow=$4D,	\scan codes
	PageUp=$49, PageDn=$51, Home=$47, End=$4F, Insert=$52, Delete=$53,
	Func=$3A;						\e.g: Func+1

def	Black, Blue, Green, Cyan, Red, Magenta, Brown, White,  \attribute colors
	Gray, LBlue, LGreen, LCyan, LRed, LMagenta, Yellow, BWhite; \EGA palette

def	Pi = 3.14159265358979323846;
def	Deg2Rad = Pi/180.0,	\multiplier to convert degrees to radians
	Rad2Deg = 1.0/Deg2Rad;	\and vice versa


\func	AtoI(Str);		Convert a string of ASCII digits to an integer
\func	Bin2Gray(N);		Convert N from binary to equivalent Gray code
\func	CommandLine(Index, String, MaxLength);
\func	Extend16(N);		Sign extend 16-bit value to 32-bit word
\func	FtoA(F, Str);		Convert real number F to string of ASCII digits
\func	GCD(N, D);		Return the greatest common divisor of N and D
\func	GetDosDate;		Return the current date in MS-DOS packed format
\func	GetDosTime;		Return the current time in MS-DOS packed format
\func	Gray2Bin(N);		Convert N from Gray code to equivalent binary
\func	IntLen(N);		Return number of digits in N, a decimal integer
\func	ItoA(I, Str);		Convert a number I to a string of ASCII digits
\func	ListAdd(Ptr, Data...);	Prepend Data to linked list at Ptr
\func	ListDel(Ptr);		Release all memory occupied by a list
\func	ListFind(Ptr, Data);	Return pointer to list element matching Data
\func	ListLen(Ptr);		Return the number of elements in a list
\func	ListRev(Ptr);		Reverse the order of the elements in a list
\func	ListSort(Ptr);		Sort data (in ascending order) in a linked list
\func	LoadBmp(FileName);	Load specified .bmp file into 2nd graphic page
\func	Max(A, B);		Return the larger of the arguments
\func	Min(A, B);		Return the smaller of the arguments
\func	OpenInFile(FileName);	Open file for input; return 'true' if success
\func	OpenOutFile(FileName);	Open file for output; return 'true' if success
\func real ALog(X);		Antilog (or 10**X)
\func real ATan(Y);		Arc tangent fuction, returns angle in radians
\func real AtoF(Str);		Convert string of ASCII digits to floating pt
\func real CAdd(A, B, C);	Return complex sum of two complex numbers
\func real CDiv(A, B, C);	Return complex quotient of two complex numbers
\func real CInv(A, B);		Return inversion (reciprical) of complex number
\func real CMag(A);		Return the magnitude (abs) of a complex number
\func real CMul(A, B, C);	Return complex product of two complex numbers
\func real CNeg(A, B);		Return negative of a complex number
\func real Conj(A, B);		Return conjugate of a complex number
\func real Cosh(X);		Hyperbolic cosine
\func real CSub(A, B, C);	Return difference of two complex numbers
\func real Fact(X);		Factorial
\func real Hms2Rl(Str, Size);	Convert HH:MM:SS.S string to equivalent hours
\func real HmsIn(Dev);		Input HH:MM:SS.S and return equivalent hours
\func real Ints2Real(I0, I1);	Make real value from two integers
\func real IPtr2RPtr(IPtr);	Convert integer pointer to real pointer
\func real Sinh(X);		Hyperbolic sine
\func real Tanh(X);		Hyperbolic tangent
\func real VAdd(A, B, C);	Add two 3D vectors
\func real VCross(A, B, C);	Return cross product of two 3D vectors in V3
\func real VDot(A, B);		Return the dot product of two 3D vectors
\func real VMag(A);		Return the magnitude (length) of a 3D vector
\func real VMul(A, B, S);	Multiply 3D vector by a scalar
\func real VNeg(A, B);		Return negative of a 3D vector
\func real VNorm(A, B);		Convert a 3D vector to its unit vector
\func real VRot(A, B, C);	Rotate vector V in 3 dimensions
\func real VSub(A, B, C);	Subtract two 3D vectors
\func	RevBits(N);		Return N with the order of its bits reversed
\func	Rol(N, C);		Rotate N left C bits
\func	Ror(N, C);		Rotate N right C bits
\func	StrAdd(A, B);		Multiprecision add: A:= A + B
\func	StrCat(A, B);		Concatenate ASCIIZ strings A:= A + B
\func	StrCmp(A, B);		Compare ASCIIZ string A to B
\func	StrCopy(A, B);		Copy ASCIIZ string: A <- B
\func	StrDiv(A, B);		Multiprecision divide A:= A / B (an integer)
\func	StrFind(A, B);		Search for ASCIIZ string B in string A
\func	StrLen(A);		Return number of characters in an ASCIIZ string
\func	StrMul(A, B);		Multiprecision multiply A:= A * B
\func	StrNCmp(A, B, N);	Compare string A to string B up to N bytes long
\func	StrNCopy(A, B, N);	Copy string that is N bytes long: A <- B
\func	StrNFill(Str, Pat, N);	Fill string (byte array) with pattern
\func	StrRev(Str);		Reverse the order of the characters in a string
\func	StrSub(A, B);		Multiprecision subtract: A:= A - B
\func	TextIn(Dev, Str, N);	Input a string
\func	ToLower(C);		Convert character to lowercase
\func	ToUpper(C);		Convert character to uppercase
\func	WeekDay(Year, Month, Day);	Return day of week (0=Sun 1=Mon..6=Sat)
\proc	Beep;			A not-too-obnoxious beep tone
\proc	BinOut(Dev, N); 	Output N in binary
\proc	Clear2;			Clear second graphics page
\proc	COut(Dev, A);		Output a complex number to specified device
\proc	DateOut(Dev, Date);	Output specified date, e.g: 03-Feb-2011
\proc	DrawChar(Font, Ch, Color);	Display a character at PenX,PenY
\proc	DrawCircle(X0, Y0, Radius, Color, Fill); Display a circle
\proc	DrawDot(X0, Y0, C, S);	Draw a dot centered at X0,Y0
\proc	DrawEllipse(X0, Y0, W, H, Color, Fill);	Display an ellipse
\proc	DrawInt(Font, N, Color);	Display an integer at PenX,PenY
\proc	DrawLine(X, Y, C);	Draw line from PenX,PenY to X,Y in color C
\proc	DrawPolyLine(Count, Points, Color);
\proc	DrawQuad(Quad, Color);	Draw a filled quadrilateral
\proc	DrawReal(Font, X, Color);	Display a real numbmer at PenX,PenY
\proc	DrawRectangle(X0, Y0, W, H, Color, Fill); Display a rectangle
\proc	DrawSpline(Spline, Color);	Draw cubic Bezier curve
\proc	DrawSprite(X0, Y0, Spr, Trans);	Display a sprite image
\proc	DrawText(Font, Str, Color);	Display a text string at PenX,PenY
\proc	DrawTriangle(Tri, Color); Draw a filled triangle
\proc	DrawVectChar(Ch, Color);	Draw a vector character
\proc	Exit(Str);		Display (error) message and exit program
\proc	FillArea(X, Y, C0, C);	Replace area colored C0 with color C
\proc	GetSprite(X0, Y0, W, H, Spr);	Load sprite array from screen image
\proc	HalfOut(Dev, Half);	Output 16-bit half word in binary
\proc	HmsOut(Dev, HMS);	Output HMS (<100) as HH:MM:SS.S
\proc	InitDraw;		Initialize variables for drawing routines
\proc	Int2Out(Dev, N);	Output 2-digit integer
\proc	JustOut(Dev, N, Places, Fill); Output a right-justified integer
\proc	MovePen(X, Y);		Position drawing pen
\proc	Polar2Rect(@X, @Y, Ang, Dist);	Return rectangular coordinates
\proc	Rect2Polar(@Ang, @Dist, X, Y);	Return polar coordinates
\proc	RlOutComma(Dev, X);	Output a real with commas, e.g: 12,345,678.90
\proc	SaveBmp(FileName);	Save graphic screen to specified .bmp file
\proc	SpOut(Dev, N);		Output N spaces to specified device
\proc	StrInc(A);		Multiprecision increment A
\proc	TimeOut(Dev, Time);	Output specified Time, e.g: 5:43:03p
\proc	VOut(Dev, A);		Output a 3D vector number to specified device
\proc	WordOut(Dev, Word);	Output 32-bit word in binary

\--------------------------- BASIC INTEGER ROUTINES ----------------------------

proc	Exit(Str);		\Display (error) message and exit program
char	Str;
[SetVid($03);			\make sure screen is in normal text mode
Text(0, Str);  CrLf(0);
exit;
];	\Exit



proc	Beep;			\A not-too-obnoxious beep tone
[Sound(false, 1, 1000);		\synchronize with system timer to make tone a
 Sound(true, 1, 3000);		\ consistent duration and a consistent sound.
];	\Beep



func	IntLen(N);		\Return number of digits in N, a decimal integer
int	N;			\Adds 1 for a minus sign if N is negative
int	I;
for I:= if N>=0 then 1 else 2 to 20 do
	[N:= N/10;  if N=0 then return I];



func	Max(A, B);		\Return the larger of the arguments
int	A, B;
return if A > B then A else B;



func	Min(A, B);		\Return the smaller of the arguments
int	A, B;
return if A < B then A else B;



func	Extend16(N);		\Sign extend 16-bit value to 32-bit word
int	N;
return if N & $8000 then N ! $FFFF0000 else N & $0000FFFF;



func	Rol(N, C);		\Rotate N left C bits
int	N, C;
[C:= $1F & C;			\CPU's instruction limits shift to 0..31 bits
return N<<C ! N>>(IntSize*8-C);
];	\Rol



func	Ror(N, C);		\Rotate N right C bits
int	N, C;
[C:= $1F & C;			\CPU's instruction limits shift to 0..31 bits
return N>>C ! N<<(IntSize*8-C);
];	\Ror



func	RevBits(N);		\Return N with the order of its bits reversed
int	N;
[N:=	(N>>1 & $55555555) ! (N & $55555555)<<1;
 N:=	(N>>2 & $33333333) ! (N & $33333333)<<2;
 N:=	(N>>4 & $0F0F0F0F) ! (N & $0F0F0F0F)<<4;
 N:=	(N>>8 & $00FF00FF) ! (N & $00FF00FF)<<8;
return (N>>16 & $0000FFFF) ! (N & $0000FFFF)<<16;
];	\RevBits



func	GCD(N, D);		\Return the greatest common divisor of N and D
int	N, D;			\numerator and denominator
int	R;
[if D > N then
	[R:=D; D:=N; N:=R];	\swap D and N
while D > 0 do			\Eculid's method
	[R:= rem(N/D);
	N:= D;
	D:= R;
	];
return N;
];	\GCD



func	Bin2Gray(N);		\Convert N from binary to equivalent Gray code
int	N;
return N>>1 | N;



func	Gray2Bin(N);		\Convert N from Gray code to equivalent binary
int	N;
int	S;
[S:= 1;
repeat	N:= N>>S | N;
	S:= S<<1;
until	S = 8*IntSize;
return N;
];	\Gray2Bin

\----------------------------- BASIC REAL FUNCTIONS ----------------------------

func real ALog(X);		\Antilog (or 10**X)
real	X;			\10**X = e**(X ln(10)) = e**ln(10**X)
return Exp(X * 2.302585092994045684018);	\Ln(10) = 2.3025...



func real ATan(Y);		\Arc tangent fuction, returns angle in radians
real	Y;
return ATan2(Y, 1.0);



func real Sinh(X);		\Hyperbolic sine
real	X;
return (Exp(X) - Exp(-X)) / 2.0;



func real Cosh(X);		\Hyperbolic cosine
real	X;
return (Exp(X) + Exp(-X)) / 2.0;



func real Tanh(X);		\Hyperbolic tangent
real	X;
real	A, B;
[A:= Exp(X);  B:= Exp(-X);
return (A-B) / (A+B);
];	\Tanh



func real Fact(X);		\Factorial
real	X;
real	F;
int	I;
[F:= 1.0;
for I:= 2 to fix(X) do F:= F*float(I);
return F;
];	\Fact



func real Ints2Real(I0, I1);	\Make real value from two integers
real	R;
return R;



func real IPtr2RPtr(IPtr);	\Convert integer pointer to real pointer
int	IPtr;
return Ints2Real(IPtr, $3FF0_0000);

\------------------------------- OUTPUT ROUTINES -------------------------------

proc	SpOut(Dev, N);		\Output N spaces to specified device
int	Dev, N;
int	I;
for I:= 1 to N do ChOut(Dev, ^ );



proc	Int2Out(Dev, N);	\Output 2-digit integer
int	Dev, N;			\e.g: 03
[if N < 10 then ChOut(Dev, ^0);
IntOut(Dev, N);
];



proc	BinOut(Dev, N); 	\Output N in binary
int	Dev, N;
int	R;
[R:= N&1;
N:= N>>1;
if N then BinOut(Dev, N);
ChOut(Dev, R+^0);
];	\BinOut



proc	JustOut(Dev, N, Places, Fill); \Output a right-justified integer
\Always outputs correct value of N regardless of Places
int	Dev,	\output device number
	N,	\integer to output
	Places,	\size of field in characters (right-justifies)
	Fill;	\character to fill background of field. Usually space (Sp) or ^0
int	I;	\ Negative numbers should be filled with spaces.
[for I:= 1 to Places-IntLen(N) do ChOut(Dev, Fill);
IntOut(Dev, N);
];	\JustOut



proc	RlOutComma(Dev, X);	\Output a real with commas, e.g: 12,345,678.90
\ Some negative numbers have a space after the minus sign, e.g: - 123,456.1234
int	Dev;			\NOTE: Device 8 is used
real	X;			\integer part of real to output
int	I, J, K, C;
[OpenO(8);			\convert real to ASCII string in device 8 buffer
RlOut(8, X);
OpenI(8);			\find index of "." or ":"
I:= 0;
loop	[C:= ChIn(8);
	if C=^. ! C=EOF then quit;
	I:= I+1;
	];
J:= rem(I/3);			\places in front of first comma (0=3)
OpenI(8);			\output digits ahead of "." or ":" with commas
K:= 0;
loop	[C:= ChIn(8);
	ChOut(Dev, C);
	K:= K+1;
	if K >= I then quit;
	if rem(K/3)=J \& C#^-\ then
		ChOut(Dev, if C>=^0 & C<=^9 then ^, else ^ );
	];
loop	[C:= ChIn(8);		\output rest of number
	if C=EOF then quit;
	ChOut(Dev, C);
	];
];	\RlOutComma

\---------------------------- TIME & DATE ROUTINES -----------------------------

func	GetDosDate;		\Return the current date in MS-DOS packed format
\Bits: 9-F = year (relative to 1980); 5-8 = month (1-12); 0-4 = day (1-31)
char	A;
[A:= GetDateTime;
return (A(0)-80)<<9 ! A(1)<<5 ! A(2);
];	\GetDosDate



func	GetDosTime;		\Return the current time in MS-DOS packed format
\Bits: B-F = hour (0-23); 5-A = minute (0-59); 0-4 = second/2 (0-29)
char	A;
[A:= GetDateTime;
return A(3)<<$B ! A(4)<<5 ! A(5)>>1;
];	\GetDosTime



proc	DateOut(Dev, Date);	\Output specified date, e.g: 03-Feb-2011
int	Dev, Date;		\date in MS-DOS packed format
int	D, M, Y, I, J;
char	Str;
[D:= Date & $001F;		\1..31
M:= Date>>5 & $000F;		\1..12
Y:= (Date>>9 & $007F) + 1980;	\1980..2107
if D < 10 then ChOut(Dev, ^0);
IntOut(Dev, D);
ChOut(Dev, ^-);
Str:= "JanFebMarAprMayJunJulAugSepOctNovDec ";
J:= 3*(M-1);
for I:= 0 to 2 do ChOut(Dev, Str(I+J));
ChOut(Dev, ^-);
IntOut(Dev, Y);
];	\DateOut



proc	TimeOut(Dev, Time);	\Output specified Time, e.g: 5:43:03p
int	Dev, Time;		\time in DOS packed format
int	HH, MM, SS,		\hours, minutes, seconds
	PM;			\Post Meridiem
[SS:= (Time & $001F) * 2;	\extract seconds, minutes, hours
MM:= Time>>5 & $003F;
HH:= Time>>11;
PM:= HH >= 12;
if HH > 12 then HH:= HH - 12;
if HH = 0 then HH:= 12;
if HH <= 9 then ChOut(Dev, Sp);
IntOut(Dev, HH);
ChOut(Dev, ^:);
Int2Out(Dev, MM);
ChOut(Dev, ^:);
Int2Out(Dev, SS);
ChOut(Dev, if PM then ^p else ^a);
];	\TimeOut



func	WeekDay(Year, Month, Day);	\Return day of week (0=Sun 1=Mon..6=Sat)
int	Year, Month, Day;		\Works for years from 1583 onward
[if	Month<=2 then [Month:= Month+12;  Year:= Year-1];
return rem((Day-1 + (Month+1)*26/10 + Year + Year/4 + Year/100*6 + Year/400)/7);
];	\WeekDay



func real HmsIn(Dev);		\Input HH:MM:SS.S and return equivalent hours
int	Dev;	\device number
int	Neg,	\flag: minus sign seen
	CrFlag,	\flag: carriage return seen
	N,	\integer value after the decimal point (if any)
	Dem;	\denominator for correcting fractional values
real	Hours;	\value returned

	func	ChInX(Dev);
	int	Dev;
	int	Ch;
	[if CrFlag then return ^0;
	Ch:= ChIn(0);
	if Ch = CR then CrFlag:= true;
	return Ch;
	];	\ChInX


	func	GetNum;		\Get number from device, look for minus signs
	int	Ch, Num;
	[repeat	Ch:= ChInX(Dev) until Ch>=^0 & Ch<=^9 ! Ch=^-;	\skip garbage
	if Ch=^- then [Neg:= true;  Ch:= ChInX(Dev)];
	Num:= Ch - ^0;
	loop	[Ch:= ChInX(Dev);
		if Ch<^0 ! Ch>^9 ! CrFlag then quit;
		Num:= Num*10 + Ch-^0;
		];
	return Num;
	];	\GetNum

[Neg:= false;
CrFlag:= false;
Hours:= float(GetNum) + float(GetNum)/60.0 + float(GetNum)/3600.0;
N:= GetNum;	\deal with wise guys who put more than one digit after the D.P.
Dem:= 1;
while N/Dem >= 10 do Dem:= Dem*10;
Hours:= Hours + float(N)/36000.0/float(Dem);
return if Neg then -Hours else Hours;
];	\HmsIn



proc	HmsOut(Dev, HMS);	\Output HMS (<100) as HH:MM:SS.S
int	Dev;	\output device number
real	HMS;	\value to output
int	Tenths;	\flag to display tenths of a second
char	A;
int	HH, MM, SS;

	func	Trunc(X);	\Truncate X to integer
	real	X;
	int	I;
	[I:= fix(X-.5);		\(beware of numbers like 51.9999999)
	if I < 0 then I:= 0;	\(beware of 0.999999999)
	return I;
	];	\Trunc


	proc	NumOut(N);
	\Output a positive 2-digit integer with leading zeros
	int	N;
	[ChOut(Dev, N/10 + ^0);
	 ChOut(Dev, rem(0) + ^0);
	];	\NumOut

[Tenths:= true;
if HMS < 0.0 then
	[ChOut(Dev, ^-);  HMS:= -HMS]
else	 ChOut(Dev, ^ );

HMS:= HMS + (if Tenths then 1.39E-5 else 1.39E-4);	\round
A:= addr HMS;			\make HMS a nice number that won't
A(0):= 0;			\ give rounding problems

HH:= Trunc(HMS);
NumOut(HH);
ChOut(Dev, ^:);

HMS:= (HMS - float(HH)) * 60.0;
MM:= Trunc(HMS);
NumOut(MM);
ChOut(Dev, ^:);

HMS:= (HMS - float(MM)) * 60.0;
SS:= Trunc(HMS);
NumOut(SS);

if Tenths then			\show tenths of seconds
	[ChOut(Dev, ^.);
	HMS:= (HMS - float(SS)) * 10.0;
	ChOut(Dev, Trunc(HMS) +^0);
	];
ChOut(Dev, CR);
];	\HmsOut



func real Hms2Rl(Str, Size);	\Convert HH:MM:SS.S string to equivalent hours
char	Str;	\string containing HH MM SS.S
int	Size;	\length of Str
int	Inx,	\index into Str array
	Neg; 	\flag: minus sign seen
real	Num;	\hours * 360000.0

	func	GetCh;		\Get next character from Str
	int	Ch;
	[if Inx >= Size then return ^0;
	Ch:= Str(Inx);
	Inx:= Inx+1;
	return Ch;
	];	\GetCh


	func real GetNum;	\Get number, look for minus signs
	int	Ch, N;
	[		\Ignore leading garbage (i.e: non-numerics)
	loop	[
		Ch:= GetCh;
		if Ch>=^0 & Ch<=^9 ! Ch=^- then quit;
		if Ch=^. ! Ch=^: then return 0;
		];
	if Ch=^- then [Neg:= true;  Ch:= GetCh];

	N:= Ch - ^0;
	loop	[if Inx >= Size then quit;
		Ch:= GetCh;
		if Ch<^0 ! Ch>^9 then quit;
		N:= N*10 + Ch - ^0;
		];

	return float(N);
	];	\GetNum

[Inx:= 0;
Neg:= false;
Num:= GetNum*36000.0 + GetNum*600.0 + GetNum*10.0 + GetNum;
if Neg then Num:= -Num;
return Num / 36000.0;
];	\Hms2Rl

\-------------------------------- FILE ROUTINES --------------------------------

func	OpenInFile(FileName);	\Open file for input; return 'true' if success
char	FileName;
int	H;	\handle
[Trap(false);
H:= FOpen(FileName, 0);
FSet(H, ^i);			\small buffer allows multiple files
OpenI(3);
if GetErr then return false;
Trap(true);
return true;
];	\OpenInFile



func	OpenOutFile(FileName);	\Open file for output; return 'true' if success
char	FileName;
int	H;	\handle
[Trap(false);
H:= FOpen(FileName, 1);
FSet(H, ^o);			\small buffer allows multiple files, and it is
OpenO(3);			\ closed automatically when the program exits
if GetErr then return false;
Trap(true);
return true;
];	\OpenOutFile



func	CommandLine(Index, String, MaxLength);
\String gets specified command-line argument.
\Returns 'false' if specified argument doesn't exist.
int	Index;			\specifies argument: 1=first, after program name
char	String;			\address that gets argument
int	MaxLength;		\maximum length of String
int	Ch, I;
[OpenI(8);			\NOTE: Device 8 is used
while	Index > 1 do		\skip command line argument
	[Index:= Index-1;
	loop	[Ch:= ChIn(8);
		if Ch = $20 then quit;
		if Ch = $1A then return false;
		];
	];
I:= 0;
loop	[Ch:= ChIn(8);
	if Ch = $20 then quit;
	if Ch = $1A then return false;
	if I >= MaxLength then quit;
	String(I):= Ch;
	if I < MaxLength-1 then I:= I+1;
	];
String(I):= 0;
return true;
];	\GetCmdLine

\------------------------------ COMPLEX ROUTINES -------------------------------

func real CAdd(A, B, C);	\Return complex sum of two complex numbers
real	A, B, C;		\A:= B + C
[A(0):= B(0) + C(0);		\CAdd(A, A, C) => A:= A + C
 A(1):= B(1) + C(1);
return A;
];	\CAdd



func real CSub(A, B, C);	\Return difference of two complex numbers
real	A, B, C;		\A:= B - C
[A(0):= B(0) - C(0);		\CSub(A, A, C) => A:= A - C
 A(1):= B(1) - C(1);
return A;
];	\CSub



func real CMul(A, B, C);	\Return complex product of two complex numbers
real	A, B, C;		\A:= B * C
real	T;			\enables CMul(A, A, C) => A:= A * C
[  T:= B(0)*C(0) - B(1)*C(1);
A(1):= B(1)*C(0) + B(0)*C(1);
A(0):= T;
return A;
];	\CMul



func real CDiv(A, B, C);	\Return complex quotient of two complex numbers
real	A, B, C;		\A:= B / C
real	D, T;			\T enables CDiv(A, A, C) => A:= A / C
[D:= C(0)*C(0) + C(1)*C(1);
   T:= (B(0)*C(0) + B(1)*C(1)) / D;
A(1):= (B(1)*C(0) - B(0)*C(1)) / D;
A(0):= T;
return A;
];	\CDiv



func real CInv(A, B);		\Return inversion (reciprical) of complex number
real	A, B;			\A:= 1 / B
real	D;			\CInv(A, A) => A:= 1 / A
[D:= sq(B(0)) + sq(B(1));
A(0):= B(0)/D;
A(1):=-B(1)/D;
return A;
];	\CInv



func real Conj(A, B);		\Return conjugate of a complex number
real	A, B;			\A:= conj(B)
[A(0):= B(0);			\Conj(A, A) => A:= conj(A)
 A(1):=-B(1);
return A;
];	\Conj



func real CNeg(A, B);		\Return negative of a complex number
real	A, B;			\A:= -B
[A(0):= -B(0);			\CNeg(A, A) => A:= -A
 A(1):= -B(1);
return A;
];	\CNeg



func real CMag(A);		\Return the magnitude (abs) of a complex number
real	A;			\Mag:= |A|
return sqrt(A(0)*A(0) + A(1)*A(1));



proc	COut(Dev, A);		\Output a complex number to specified device
int	Dev; real A;		\e.g: -1.5 + 0.3i
[RlOut(Dev, A(0));
  Text(Dev, if A(1)>=0.0 then " + " else " - ");
 RlOut(Dev, abs(A(1)));
ChOut(Dev, ^i);
];	\COut



proc	Rect2Polar(@Ang, @Dist, X, Y);	\Return polar coordinates
real    Ang, Dist, X, Y;
[Ang(0):= ATan2(Y, X);
Dist(0):= sqrt(X*X + Y*Y);
];	\Rect2Polar



proc	Polar2Rect(@X, @Y, Ang, Dist);	\Return rectangular coordinates
real    X, Y, Ang, Dist;
[X(0):= Dist*Cos(Ang);
 Y(0):= Dist*Sin(Ang);
];	\Polar2Rect

\----------------------------- 3D VECTOR ROUTINES ------------------------------

func real VAdd(A, B, C);	\Add two 3D vectors
real	A, B, C;		\A:= B + C
[A(0):= B(0) + C(0);		\VAdd(A, A, C) => A:= A + C
 A(1):= B(1) + C(1);
 A(2):= B(2) + C(2);
return A;
];	\VAdd



func real VSub(A, B, C);	\Subtract two 3D vectors
real	A, B, C;		\A:= B - C
[A(0):= B(0) - C(0);		\VSub(A, A, C) => A:= A - C
 A(1):= B(1) - C(1);
 A(2):= B(2) - C(2);
return A;
];	\VSub



func real VMul(A, B, S);	\Multiply 3D vector by a scalar
real	A, B, S;		\A:= B * S
[A(0):= B(0) * S;		\VMul(A, A, S) => A:= A * S
 A(1):= B(1) * S;
 A(2):= B(2) * S;
return A;
];	\VMul



func real VNeg(A, B);		\Return negative of a 3D vector
real	A, B;			\A:= -B
[A(0):= -B(0);			\VNeg(A, A) => A:= -A
 A(1):= -B(1);
 A(2):= -B(2);
return A;
];	\VNeg



func real VDot(A, B);		\Return the dot product of two 3D vectors
real	A, B;			\A  B
return A(0)*B(0) + A(1)*B(1) + A(2)*B(2);



func real VCross(A, B, C);	\Return cross product of two 3D vectors in V3
real	A, B, C;		\A:= B x C
real	T0, T1;			\enables VCross(A, A, C) => A:= A x C
[  T0:= B(1)*C(2) - B(2)*C(1);
   T1:= B(2)*C(0) - B(0)*C(2);
 A(2):= B(0)*C(1) - B(1)*C(0);
A(0):= T0;
A(1):= T1;
return A;
];	\VCross



func real VMag(A);		\Return the magnitude (length) of a 3D vector
real	A;			\Mag:= |A|
return sqrt(A(0)*A(0) + A(1)*A(1) + A(2)*A(2));



func real VNorm(A, B);		\Convert a 3D vector to its unit vector
real	A, B;			\A:= |B|
real	M;			\VNorm(A, A) => A:= |A|
[M:= VMag(B);
if M > 0.0 then
	[A(0):= B(0) / M;
	 A(1):= B(1) / M;
	 A(2):= B(2) / M;
	];
return A;
];	\VNorm



func real VRot(A, B, C);	\Rotate vector V in 3 dimensions
real	A, B, C;		\A:= B rot C
real	P, Y, R,		\Pitch, Yaw and Roll angles in radians
	SP, SY, SR, CP, CY, CR, T; \VRot(A, A, C) => A:= A rot C
[P:= C(0);  Y:= C(1);  R:= C(2);
SP:= Sin(P);   SY:= Sin(Y);   SR:= Sin(R);
CP:= Cos(P);   CY:= Cos(Y);   CR:= Cos(R);
A(0):= B(0);  A(1):= B(1);  A(2):= B(2);

\Rotate about X axis (Pitch):
T:=    A(1)*CP - A(2)*SP;	\		       	 
A(2):= A(1)*SP + A(2)*CP;	\		      1   0   0 
A(1):= T;			\ [X Y Z]:= [X Y Z] * 0   CP  SP
				\		      0  -SP  CP
				\		       	 
\Rotate about Y axis (Yaw):
T:=    A(0)*CY + A(2)*SY;	\		       	 
A(2):= A(2)*CY - A(0)*SY;	\		      CY  0  -SY
A(0):= T;			\ [X Y Z]:= [X Y Z] * 0   1   0 
				\		      SY  0   CY
				\		       	 
\Rotate about Z axis (Roll):
T:=    A(0)*CR - A(1)*SR;	\		       	  
A(1):= A(0)*SR + A(1)*CR;	\		       CR  SR	0 
A(0):= T;			\ [X Y Z]:= [X Y Z] * -SR  CR	0 
				\		       0   0	1 
return A;			\		       	  
];	\VRot



proc	VOut(Dev, A);		\Output a 3D vector number to specified device
int	Dev; real A;		\e.g: Format(1,1);  -1.5i + 0.3j - 3.7k
[RlOut(Dev, A(0));
 ChOut(Dev, ^i);
  Text(Dev, if A(1)>=0.0 then " + " else " - ");
 RlOut(Dev, abs(A(1)));
 ChOut(Dev, ^j);
  Text(Dev, if A(2)>=0.0 then " + " else " - ");
 RlOut(Dev, abs(A(2)));
 ChOut(Dev, ^k);
];	\VOut

\------------------------------- STRING ROUTINES -------------------------------

func	StrCat(A, B);		\Concatenate ASCIIZ strings A:= A + B
char	A, B;			\WARNING: Make sure string A has adequate space
int	I, J;
[I:= 0;
while A(I) do I:= I+1;		\move index to the zero in the first string
J:= 0;
while B(J) do [A(I):= B(J);  I:= I+1;  J:= J+1];
A(I):= 0;
return	A;
];	\StrCat



func	StrCmp(A, B);		\Compare ASCIIZ string A to B
\This returns:
\	>0 if A > B
\	=0 if A = B
\	<0 if A < B
\This provides a general string compare, for example:
\ if StrCmp(A, B) >= 0 then...	(if A >= B then...)
char	A, B;	\strings to be compared
int	I;
[for I:= 0 to -1>>1 -1 do
	[if A(I) # B(I) then return A(I) - B(I);
	 if A(I) = 0 then return 0;
	];
];	\StrCmp



func	StrNCmp(A, B, N);	\Compare string A to string B up to N bytes long
\This returns:
\	>0 if A > B
\	=0 if A = B
\	<0 if A < B
\This provides a general string compare, for example:
\ if StrNCmp(A, B, N) >= 0 then...	(if A >= B then...)
char	A, B;	\strings to be compared (must be right justified)
int	N;	\number of bytes to compare
int	I;
[for I:= 0 to N-1 do
	if A(I) # B(I) then return A(I) - B(I);
return 0;			\they're equal
];	\StrNCmp



func	StrCopy(A, B);		\Copy ASCIIZ string: A <- B
char	A, B;			\WARNING: Make sure string A has adequate space
int	I;
[for I:= 0 to -1>>1 -1 do
	[A(I):= B(I);
	if B(I) = 0 then return A;
	];
];	\StrCopy



func	StrNCopy(A, B, N);	\Copy string that is N bytes long: A <- B
char	A, B;			\WARNING: Make sure string A has adequate size
int	N;			\number of bytes to copy
int	I;			\[works anywhere; faster: CopyMem(A, B, N)]
[for I:= 0 to N-1 do A(I):= B(I);
return A;
];	\StrNCopy



func	StrNFill(Str, Pat, N);	\Fill string (byte array) with pattern
char	Str;			\string
int	Pat,			\pattern
	N;			\number of bytes to fill
int	I;			\[works anywhere; faster: FillMem(Str, Pat, N)]
[for I:= 0 to N-1 do Str(I):= Pat;
return Str;
];	\StrNFill



func	StrLen(A);		\Return number of characters in an ASCIIZ string
char	A;
int	I;
for I:= 0 to -1>>1 -1 do
	if A(I) = 0 then return I;



func	StrFind(A, B);		\Search for ASCIIZ string B in string A
\Returns address of first occurrence of string B in A, or zero if B is not found
char	A, B;			\strings to be compared
int	LA, LB, I, J;
[LA:= StrLen(A);
 LB:= StrLen(B);
 for I:= 0 to LA-LB do
    [for J:= 0 to LB-1 do
	if B(J) # A(J+I) then J:= LB+1;
    if J = LB then return A+I;	\found
    ];
return 0;
];	\StrFind



func	StrRev(Str);		\Reverse the order of the characters in a string
char	Str;
int	I, J, T;
[I:= 0;  J:= StrLen(Str)-1;
while I < J do
	[T:= Str(I);  Str(I):= Str(J);  Str(J):= T;
	I:= I+1;  J:= J-1;
	];
return Str;
];



func	StrAdd(A, B);		\Multiprecision add: A:= A + B
\These number strings must be right justified.
\Each byte contains one ASCII digit in the range 0..9.
\Most significant digit first (lowest memory address).
char	A, B;	\ASCIIZ strings containing numbers to be added
int	Sum, Carry, I;
[Carry:= 0;
for I:= StrLen(A)-1 downto 0 do
	[Sum:= A(I) + B(I) - ^0 + Carry;
	if Sum > ^9 then [Sum:= Sum - 10;  Carry:= 1]
	else Carry:= 0;
	A(I):= Sum;
	];
return A;
];	\StrAdd



func	StrSub(A, B);		\Multiprecision subtract: A:= A - B
\These number strings must be right justified.
\Each byte contains one ASCII digit in the range 0..9.
\Most significant digit first (lowest memory address).
char	A, B;	\ASCIIZ strings containing numbers to be subtracted
int	Dif, Borrow, I;
[Borrow:= 0;
for I:= StrLen(A)-1 downto 0 do
	[Dif:= A(I) - B(I) - Borrow;
	if Dif < 0 then [Dif:= Dif + 10;  Borrow:= 1]
	else Borrow:= 0;
	A(I):= Dif + ^0;
	];
return A;
];	\StrSub



func	StrMul(A, B);		\Multiprecision multiply A:= A * B
\These number strings must be right justified.
\Each byte contains one ASCII digit in the range 0..9.
\Most significant digit first (lowest memory address).
char	A, B;	\ASCIIZ strings containing numbers to be multiplied
char	C;	\temporary string to hold product
int	NA, NB,	\indexes to first digit, skipping any leading zeros
	N, I, J, K, Carry;
[N:= StrLen(A);
C:= Reserve(N*2);
NA:= -1;  NB:= -1;
for I:= 0 to N-1 do		\convert ASCII to binary
	[A(I):= A(I) & $0F;  if A(I) then if NA<0 then NA:= I;
	 B(I):= B(I) & $0F;  if B(I) then if NB<0 then NB:= I;
	 C(I):= 0;		\initialize product to 0000...
	];
for I:= N to N*2-1 do C(I):= 0;	\initialize rest of product to 0000...

for I:= N-1 downto NA do	\multiply like in grade school
	[Carry:= 0;
	K:= N+I;
	for J:= N-1 downto NB do
		[Carry:= (A(I)*B(J) + C(K) + Carry) / 10;
		C(K):= rem(0);
		K:= K-1;
		];
	C(K):= Carry;
	];
for I:= 0 to N-1 do
	 [A(I):= C(I+N) ! $30;	\copy product back to A, and
	  B(I):= B(I) ! $30;	\ convert binary back to ASCII
	 ];
return A;
];	\StrMul



func	StrDiv(A, B);		\Multiprecision divide A:= A / B (an integer)
char	A;	\ASCII string containing dividend
		\Must be right-justified. Fill with leading zeros if necessary.
int	B;	\Integer divisor range: 1 to 2^31/10 = 214,748,364
int	N, D, I;
[N:= StrLen(A);
D:= 0;
for I:= 0 to N-1 do
	[D:= D + A(I) - ^0;	\get digit (converted to binary)
	A(I):= D/B + ^0;	\divide and convert to ASCII
	D:= rem(0)*10;
	];
return A;
];	\StrDiv



proc	StrInc(A);		\Multiprecision increment A
char	A;
int	I;
[for I:= StrLen(A)-1 downto 0 do
	[A(I):= A(I)+1;
	if A(I) > ^9 then A(I):= A(I)-10 else return;
	];
];	\StrInc



func	AtoI(Str);		\Convert a string of ASCII digits to an integer
char	Str;			\Must be terminated with MSB set on last digit
[OpenO(8);			\NOTE: Device 8 is used
Text(8, Str);
Text(8, " 0");			\return 0 if Str does not contain a number
OpenI(8);
return IntIn(8);		\leading garbage is ignored
];	\AtoI



func	ItoA(I, Str);		\Convert a number I to a string of ASCII digits
int	I;			\NOTE: Device 8 is used
char	Str;			\WARNING: Make sure Str is of adequate size
int	C;
[OpenO(8);
IntOut(8, I);
OpenI(8);
I:= 0;				\read one line from file
repeat	C:= ChIn(8);
	if C=EOF then C:= 0;	\terminate string
	Str(I):= C;
	I:= I+1;
until	C = 0;
return Str;
];	\ItoA



func real AtoF(Str);		\Convert string of ASCII digits to floating pt
char	Str;			\Must be terminated with MSB set on last digit
[OpenO(8);			\NOTE: Device 8 is used
Text(8, Str);
Text(8, " 0");			\return 0.0 if Str does not contain a number
OpenI(8);
return RlIn(8);			\leading garbage is ignored
];	\AtoF



func	FtoA(F, Str);		\Convert real number F to string of ASCII digits
real	F;			\NOTE: Device 8 is used
char	Str;			\WARNING: Make sure Str is of adequate size
int	I, C;
[OpenO(8);
RlOut(8, F);			\length is determined by Format intrinsic
OpenI(8);
I:= 0;				\read one line from file
repeat	C:= ChIn(8);
	if C=EOF then C:= 0;	\terminate string
	Str(I):= C;
	I:= I+1;
until	C = 0;
return Str;
];	\FtoA



func	ToLower(C);		\Convert character to lowercase
int	C;
return if C>=^A & C<=^Z then C!$20 else C;



func	ToUpper(C);		\Convert character to uppercase
int	C;
return if C>=^a & C<=^z then C&$DF else C;



func	TextIn(Dev, Str, N);	\Input a string
int	Dev;	\device number to input from (Reserve N bytes)
char	Str;	\address of string to write to
int	N;	\maximum bytes allowed in string, including 0 terminator
int	I, Ch;
[I:= 0;
loop	[if I >= N-1 then quit;
	repeat Ch:= ChIn(Dev) until Ch # LF;	\ignore line feeds
	if Ch=CR ! Ch=EOF then quit;
	Str(I):= Ch;
	I:= I+1;
	];
Str(I):= 0;	\terminate ASCIIZ string
return I;	\return size of string (not including 0 terminator)
];	\TextIn

\-------------------------------- LIST ROUTINES --------------------------------

func	ListAdd(Ptr, Data...);	\Prepend Data to linked list at Ptr and
int	Ptr,			\ return updated list pointer
	Data1, Data2, Data3, Data4, Data5, Data6, Data7;
\Return updated list pointer
int	Node;
[Node:= MAlloc(8*IntSize);	\32 bytes
Node(0):= Ptr;			\point to existing list
Node(1):= Data1;		\key for Find or Sort
Node(2):= Data2;		\optional additional items (but no Find or Sort)
Node(3):= Data3;		\real values can be stored in pairs of Data
Node(4):= Data4;
Node(5):= Data5;
Node(6):= Data6;
Node(7):= Data7;
return Node;			\return list pointer including new node
];	\ListAdd



func	ListFind(Ptr, Data);	\Return pointer to list element matching Data
int	Ptr, Data;		\Returns 0 if not found
loop	[if Ptr = 0 then return 0;
	if Ptr(1) = Data then return Ptr;
	Ptr:= Ptr(0);
	];



func	ListLen(Ptr);		\Return the number of elements in a list
int	Ptr;
int	N;
[N:= 0;
while Ptr do [N:= N+1;  Ptr:= Ptr(0)];
return N;
];	\ListLen



func	ListDel(Ptr);		\Release all memory occupied by a list
int	Ptr;			\Return updated (null) list pointer
int	Next;
[while Ptr do [Next:= Ptr(0);  Release(Ptr);  Ptr:= Next];
return 0;
];



func	ListRev(Ptr);		\Reverse the order of the elements in a list
int	Ptr;			\Return updated list pointer
int	Len, Array, I, SPtr;
[Len:= ListLen(Ptr);
Array:= Reserve(Len*IntSize);	\make array of pointers to strings
for I:= 0 to Len-1 do
	[Array(I):= Ptr;  Ptr:= Ptr(0)];
SPtr:= 0;
for I:= 0 to Len-1 do
	[Ptr:= Array(I);
	Ptr(0):= SPtr;
	SPtr:= Ptr;
	];
return SPtr;
];	\ListRev



func	ListSort(Ptr);		\Sort data (in ascending order) in a linked list
int	Ptr;			\Return updated list pointer
int	Len, Array, SPtr, I;

	proc	QSort(Array, Len);	\Quick sort Array pointers
	int	Array, Len;
	int	I, J, Mid, Tmp;
	[I:= 0;			\first and last indexes into Array
	J:= Len-1;
	Mid:= Array(J>>1,1);	\point to data for middle element
	while I <= J do
		[while Array(I,1) < Mid do I:= I+1;
		 while Array(J,1) > Mid do J:= J-1;
		 if I <= J then
			[Tmp:= Array(I);  Array(I):= Array(J);  Array(J):= Tmp;
			I:= I+1;
			J:= J-1;
			];
		];
	if I < Len-1 then QSort(@Array(I), Len-I);  \recurse if at least 2 items
	if J > 0 then QSort(Array, J+1);
	];	\QSort

[Len:= ListLen(Ptr);
Array:= Reserve(Len*IntSize);	\make Array of pointers to strings
for I:= 0 to Len-1 do
	[Array(I):= Ptr;  Ptr:= Ptr(0)];

QSort(Array, Len);

SPtr:= 0;
for I:= Len-1 downto 0 do
	[Ptr:= Array(I);
	Ptr(0):= SPtr;
	SPtr:= Ptr;
	];
return SPtr;
];	\ListSort

\------------------------------ GRAPHICS ROUTINES ------------------------------

int	ScrWidth, ScrHeight;	\screen dimensions, used for clipping
int	PenX, PenY,		\pen pixel coordinates for DrawLine & DrawChar
	LineWidth,		\DrawLine thickness (0 or 1 for one-pixel width)
	DotDash,		\byte pattern for DrawLine: 0 = solid line
	ArcSegs,		\bit array for undrawn segments in DrawCircle
	CharDir;		\character direction: 0=hoiz; not 0 = vertical
real	FontSize;		\vector font (3) magnification factor


proc	InitDraw;		\Initialize variables for drawing routines
[ScrWidth:= 1280;  ScrHeight:= 1024;
PenX:= 0;  PenY:= 0;
LineWidth:= 0;
DotDash:= 0;
ArcSegs:= 0;
CharDir:= 0;
FontSize:= 1.0;
];	\InitDraw



proc	Clear2;			\Clear second graphics page
int	A, FB, W, H, D, S;
[A:= GetFB;
FB:= A(0);
W:= A(1);
H:= A(2);
D:= A(3);
S:= D>>3 * W * H;		\size in bytes
FillMem(FB+S, 0, S);
];	\Clear2



proc	MovePen(X, Y);		\Position drawing pen
int	X, Y;
[PenX:= X;  PenY:= Y];



proc	DrawDot(X0, Y0, C, S);	\Draw a dot centered at X0,Y0
int	X0, Y0, C, S;		\color, size
int	X, Y, X2, Y2, R2;
[if S <= 1 then [Point(X0, Y0, C);  return];
R2:= (S*S)>>1 - 1;
if R2 < 0 then R2:= 0;
for Y:= -S to +S do
	[Y2:= Y*Y;
	for X:= -S to +S do
		[X2:= X*X + Y2;
		if X2 <= R2 then
			Point(X+X0, Y+Y0, C);
		];
	];
];	\DrawDot



proc	DrawLine(X, Y, C);	\Draw line from PenX,PenY to X,Y in color C
int	X, Y, C;	\coordinates of end-of-line, color, width
int	DX, DY,		\delta X, delta Y
	IX, IY,		\plotting increments along X and Y axes
	SY,		\flag: step along Y direction
	D,		\decision variable: move straight or diagonally
	E, NE,		\East, Northeast (straight or diagonal)
	T, I;		\scratch
[DX:= X - PenX;				\delta X
if DX >= 0 then				\if positive then increment
	IX:= 1
else	[DX:= -DX;  IX:= -1];		\else absolute value and decrement

DY:= Y - PenY;				\same for Y direction
if DY >= 0 then
	IY:= 1
else	[DY:= -DY;  IY:= -1];

if DX >= DY then			\step along X direction
	SY:= false
else	[SY:= true;			\step along Y direction
	T:= DX;  DX:= DY;  DY:= T;	\swap DX and DY
	];

D:= 2*DY - DX;				\set up decision variable stuff
E:= 2*DY;
NE:= 2*(DY-DX);

DotDash:= DotDash<<1;			\rotate byte left
if DotDash & $100 then DotDash:= DotDash+1
else	DrawDot(PenX, PenY, C, LineWidth);
for I:= 1 to DX do
	[if D < 0 then
		[D:= D + E;
		if SY then PenY:= PenY + IY
		      else PenX:= PenX + IX;
		]
	else	[D:= D + NE;		\move diagonally
		PenX:= PenX + IX;
		PenY:= PenY + IY;
		];
	DotDash:= DotDash<<1;			\rotate byte left
	if DotDash & $100 then DotDash:= DotDash+1
	else	DrawDot(PenX, PenY, C, LineWidth);
	];
];	\DrawLine



proc	DrawPolyLine(Count, Points, Color);
int	Count, Points, Color;
int	I;
[MovePen(Points(0), Points(1));
for I:= 2 to 2*Count-1 do
	[DrawLine(Points(I), Points(I+1), Color);
	I:= I+1;
	];
];	\DrawPolyLine



proc	DrawRectangle(X0, Y0, W, H, Color, Fill); \Display a rectangle
int	X0, Y0,		\coordinates of upper-left corner
	W, H,		\width and height (including outlines)
	Color, Fill;	\flag: solid fill vs. outlined
int	I, J, X, Y;
[W:= W-1;  H:= H-1;	\dimensions include outline borders
if not Fill then
	[MovePen(X0, Y0);
	DrawLine(X0+W, Y0, Color);
	DrawLine(X0+W, Y0+H, Color);
	DrawLine(X0, Y0+H, Color);
	DrawLine(X0, Y0, Color);
	]
else	[if W < 16 then				\if fill with tall and skinny
		for I:= X0 to X0+W do		\ then use vertical lines
			[Move(I, Y0);  Line(I, Y0+H, Color)]
	else	for J:= Y0 to Y0+H do		\ else use fast horizontal lines
			[Move(X0, J);  Line(X0+W, J, Color)];
	];
];	\DrawRectangle



proc	DrawEllipse(X0, Y0, W, H, Color, Fill);	\Display an ellipse
int	X0, Y0,		\coordinates of center
	W, H,		\width, height in pixels, result rounds up to odd number
	Color, Fill;	\flag: solid fill or outline
int	A, B, X, Y,
	T1, T2, T3, T4, T5, T6, T7, T8, T9,
	D1, D2;
int	I, J;

	proc	Set4Pts;	\(optimized procedure has no local variables)
	[if Fill then
		[J:= Y0-Y;
		Move(X0-X, J);  Line(X0+X, J, Color);
		J:= Y0+Y;
		Move(X0-X, J);  Line(X0+X, J, Color);
		]
	else	[DotDash:= DotDash<<1;			\rotate byte left
		if DotDash & $100 then DotDash:= DotDash+1
		else	[DrawDot(X0+X, Y0+Y, Color, LineWidth);
			 DrawDot(X0+X, Y0-Y, Color, LineWidth);
			 DrawDot(X0-X, Y0+Y, Color, LineWidth);
			 DrawDot(X0-X, Y0-Y, Color, LineWidth);
			 ];
		];
	];	\Set4Pts

[A:= W>>1;  B:= H>>1;
X:= A;
Y:= 0;
T1:= A*A;
T2:= T1+T1;
T3:= T2+T2;
T4:= B*B;
T5:= T4+T4;
T6:= T5+T5;
T7:= A*T5;
T8:= T7+T7;
T9:= 0;
D1:= T2 - T7 + T4>>1;
D2:= T1>>1 - T8 + T5;

\Do region 1 of quadrant
while D2 < 0 do
	[Set4Pts;
	Y:= Y+1;
	T9:= T9+T3;
	if D1 < 0 then
		[D1:= D1 + T9 + T2;
		D2:= D2 + T9;
		]
	else	[X:= X-1;
		T8:= T8 - T6;
		D1:= D1 + T9 + T2 - T8;
		D2:= D2 + T9 + T5 - T8;
		];
	];
\Do region 2 of quadrant
repeat	Set4Pts;
	X:= X-1;
	T8:= T8-T6;
	if D2 < 0 then
		[Y:= Y+1;
		T9:= T9 + T3;
		D2:= D2 + T5 + T9 - T8;
		]
	else	D2:= D2 + T5 - T8;
until	X < 0;
];	\DrawEllipse



proc	DrawCircle(X0, Y0, Radius, Color, Fill); \Display a circle
int	X0, Y0,		\coordinates of center
 	Radius,		\radius in pixels, diameter rounds up to odd number
	Color, Fill;	\flag: solid fill vs. circumference only
int	X, Y, E, U, V, I, J;

	proc	DrawOctants;			\\		     56
	[if Fill then				\\Segment	  4 /  \ 7
		[J:= Y0-Y;			\\ 5 6		  3 \__/ 0
		Move(X0-X, J);  Line(X0+X, J, Color);	    \\       21
		J:= Y0-X;			\ 4 7
		Move(X0-Y, J);  Line(X0+Y, J, Color);
		J:= Y0+X;			\ 3 0
		Move(X0-Y, J);  Line(X0+Y, J, Color);
		J:= Y0+Y;			\ 2 1
		Move(X0-X, J);  Line(X0+X, J, Color);
		]
	else	[DotDash:= DotDash<<1;			\rotate byte left
		if DotDash & $100 then DotDash:= DotDash+1
		else	[if (ArcSegs&$01) = 0 then
				DrawDot(X0+Y, Y0+X, Color, LineWidth);	\ 0
			 if (ArcSegs&$02) = 0 then
			 	DrawDot(X0+X, Y0+Y, Color, LineWidth);	\ 1
			 if (ArcSegs&$04) = 0 then
			 	DrawDot(X0-X, Y0+Y, Color, LineWidth);	\ 2
			 if (ArcSegs&$08) = 0 then
			 	DrawDot(X0-Y, Y0+X, Color, LineWidth);	\ 3
			 if (ArcSegs&$10) = 0 then
			 	DrawDot(X0-Y, Y0-X, Color, LineWidth);	\ 4
			 if (ArcSegs&$20) = 0 then
			 	DrawDot(X0-X, Y0-Y, Color, LineWidth);	\ 5
			 if (ArcSegs&$40) = 0 then
			 	DrawDot(X0+X, Y0-Y, Color, LineWidth);	\ 6
			 if (ArcSegs&$80) = 0 then
			 	DrawDot(X0+Y, Y0-X, Color, LineWidth);	\ 7
			];
		];
	];	\DrawOctants

[X:= 0;
Y:= Radius;
U:= 1;
V:= 1 - Radius - Radius;
E:= 1 - Radius;
while X < Y do
	[DrawOctants;
	if E < 0 then
		[U:= U+2;  V:= V+2;  E:= E+U]
	else	[U:= U+2;  V:= V+4;  E:= E+V;  Y:= Y-1];
	X:= X+1;
	];
if X = Y then DrawOctants;
];	\DrawCircle



proc	DrawTriangle(Tri, Color); \Draw a filled triangle
int	Tri, Color;		\array of 3 points(x,y) and one 8-bit color
int	X0,Y0, X1,Y1, X2,Y2,
	Y, T,
	Top, Bot,		\top and bottom Y coordinates of triangle half
	Edge1, Edge2;		\X coordinates along edges of triangles
real	REdge1, REdge2, Slope1, Slope2;


  proc	DrawHalf;	\(optimized procedure has no local variables)
  [if Bot > ScrHeight then Bot:= ScrHeight-1;	\clip to bottom of screen
  for Y:= Top to Bot-1 do			\from top to bottom...
	[if Y >= 0 then				\clip to top of screen
		[Edge1:= fix(REdge1);  Edge2:= fix(REdge2);
		if Edge1 > Edge2 then		\order left to right
			[T:= Edge1;  Edge1:= Edge2;  Edge2:= T];
		if Edge1 < 0 then Edge1:= 0;	\clip to left side
		if Edge2 > ScrWidth then Edge2:= ScrWidth;\clip to right side
		Move(Edge1, Y);  Line(Edge2-1, Y, Color);
		];
	REdge1:= REdge1 + Slope1;		\adj X coords according
	REdge2:= REdge2 + Slope2;		\ to slopes
	];
  ];	\DrawHalf


[X0:= Tri(0,0);			\get vertices
 X1:= Tri(1,0);
 X2:= Tri(2,0);

if X0>=ScrWidth & X1>=ScrWidth & X2>=ScrWidth then return; \clip entire triangle
if X0<0 & X1<0 & X2<0 then return;

Y0:= Tri(0,1);
Y1:= Tri(1,1);
Y2:= Tri(2,1);

if Y0 > Y1 then			\sort vertices from top to bottom (Y0<=Y1<=Y2)
	[T:= Y1;  Y1:= Y0;  Y0:= T;
	 T:= X1;  X1:= X0;  X0:= T;
	];
if Y0 > Y2 then
	[T:= Y2;  Y2:= Y0;  Y0:= T;
	 T:= X2;  X2:= X0;  X0:= T;
	];
if Y0 >= ScrHeight then return;	\clip
if Y1 > Y2 then
	[T:= Y2;  Y2:= Y1;  Y1:= T;
	T:= X2;  X2:= X1;  X1:= T;
	];
if Y2 < 0 then return;		\clip

if Y1 # Y0 then Slope1:= float(X1-X0) / float(Y1-Y0);
if Y2 # Y0 then Slope2:= float(X2-X0) / float(Y2-Y0);
REdge1:= float(X0);  REdge2:= REdge1;
Top:= Y0;  Bot:= Y1;
DrawHalf;

if Y2 # Y1 then Slope1:= float(X2-X1) / float(Y2-Y1);
REdge1:= float(X1);
Top:= Y1;  Bot:= Y2;
DrawHalf;
];	\DrawTriangle



proc	DrawQuad(Quad, Color);	\Draw a filled quadrilateral
int	Quad, Color;		\array of 4 points(x,y)
int	Tri(3,2);
[
Tri(0,0):= Quad(0,0);
Tri(0,1):= Quad(0,1);
Tri(1,0):= Quad(1,0);
Tri(1,1):= Quad(1,1);
Tri(2,0):= Quad(2,0);
Tri(2,1):= Quad(2,1);
DrawTriangle(Tri, Color);

Tri(0,0):= Quad(0,0);
Tri(0,1):= Quad(0,1);
Tri(1,0):= Quad(2,0);
Tri(1,1):= Quad(2,1);
Tri(2,0):= Quad(3,0);
Tri(2,1):= Quad(3,1);
DrawTriangle(Tri, Color);
];	\DrawQuad



proc	DrawSpline(Spline, Color);	\Draw cubic Bezier curve
int	Spline, Color;
int	X0,Y0, X3,Y3,			\start and end points
	X1,Y1, X2,Y2,			\control knots
	X, Y, N;
real	T, A, B, C, D, E, F, G, H;
def	Segs = 150.0;			\number of line segments
[X0:=Spline(0,0);			\get points
X1:= Spline(1,0);
X2:= Spline(2,0);
X3:= Spline(3,0);
Y0:= Spline(0,1);
Y1:= Spline(1,1);
Y2:= Spline(2,1);
Y3:= Spline(3,1);

A:= float(X3 - 3*X2 + 3*X1 - X0);
B:= float(3*X2 - 6*X1 + 3*X0);
C:= float(3*X1 - 3*X0);
D:= float(X0);
E:= float(Y3 - 3*Y2 + 3*Y1 - Y0);
F:= float(3*Y2 - 6*Y1 + 3*Y0);
G:= float(3*Y1 - 3*Y0);
H:= float(Y0);

MovePen(X0, Y0);
for N:= 0 to fix(Segs) do
	[T:= float(N)/Segs;
	X:= fix(((A*T + B)*T + C)*T + D);
	Y:= fix(((E*T + F)*T + G)*T + H);
	DrawLine(X, Y, Color);
	];
];	\DrawSpline



proc	FillArea(X, Y, C0, C);	\Replace area colored C0 with color C
int	X, Y,	\starting coordinate for flood fill algorithm
	C0, C;	\initial color, and color to replace it with
def	S=8000;	\size of queue (must be an even number)
int	Q(S),	\queue (FIFO)
	F, E;	\fill and empty indexes

	proc	EnQ(X, Y);	\Enqueue coordinate
	int	X, Y;
	[Q(F):= X;
	F:= F+1;
	Q(F):= Y;
	F:= F+1;
	if F >= S then F:= 0;
	];	\EnQ

	proc	DeQ;		\Dequeue coordinate
	[X:= Q(E);
	E:= E+1;
	Y:= Q(E);
	E:= E+1;
	if E >= S then E:= 0;
	];	\DeQ

[if C0 = C then return;
F:= 0;  E:= 0;
EnQ(X, Y);
while E # F do
	[DeQ;
	if ReadPix(X, Y) = C0 then
		[Point(X, Y, C);
		EnQ(X+1, Y);	\enqueue adjacent pixels
		EnQ(X-1, Y);
		EnQ(X, Y+1);
		EnQ(X, Y-1);
		];
	];
];	\FillArea



proc	DrawSprite(X0, Y0, Spr, Trans);	\Display a sprite image
int	X0, Y0;	\coordinates of upper-left corner (pixels)
int	Spr;	\address of sprite data
int	Trans;	\flag: treat background (0=black) as transparent
int	X, Y, C, W, H;
[W:= Spr(0);			\get width and height (in pixels)
 H:= Spr(1);
Spr:= Spr + 2*IntSize;
if Trans then
  for Y:= Y0 to Y0+H-1 do
    for X:= X0 to X0+W-1 do
	[if Spr(0) then		\if not background (0) draw pixel
		Point(X, Y, Spr(0));
	Spr:= Spr + IntSize;
	]
else				\draw all pixels
  for Y:= Y0 to Y0+H-1 do
    for X:= X0 to X0+W-1 do
	[Point(X, Y, Spr(0));  Spr:= Spr + IntSize];
];	\DrawSprite



proc	GetSprite(X0, Y0, W, H, Spr);	\Load sprite array from screen image
int	X0, Y0,	\coordinates on screen of upper-left corner of image
	W, H;	\width and height of sprite image (pixels)
int	Spr;	\address of array in which to load sprite data: Spr(2+W*H)
int	I, X, Y;
[Spr(0):= W;
 Spr(1):= H;
I:= 2;
for Y:= Y0 to Y0+H-1 do
    for X:= X0 to X0+W-1 do
	[Spr(I):= ReadPix(X, Y);
	I:= I+1;
	];
];	\GetSprite



proc	DrawVectChar(Ch, Color);	\Draw a vector character
\Inputs: FontSize, LineWidth
int	Ch, Color;
int	PenX0, PenY0;		\initial pen position
int	I, X, Y;
char	Str;
int	VectFont;
[
PenX0:= PenX;  PenY0:= PenY;
VectFont:=
	["00",					\$20 space
	"3034 3738",				\ !
	"1012 4042",				\"
	"2028 4048 0363 0565",			\#
	"61110203145465665707 3038",		\$
	"1001122110 6107 5647586756",		\%
	"653818070642413010010268",		\&
	"2341403032",				\'
	"40222648",				\(
	"20424628",				\)
	"022406 3137 624466",			\*
	"3137 0464",				\+
	"1:38372729",				\,
	"0464",					\-
	"2737382827",				\.
	"0761",					\/

	"61070110506167581807",			\0
	"123038 1858",				\1
\\	"01105061624424060868",			\2
	"01105061620868",			\2
	"01105061635424 546567581807",		\3
	"5850050666",				\4
	"600003436566481807",			\5
	"50200207185867655404",			\6
	"010060612528",				\7
	"10506163541405071858676554 14030110",	\8
	"64140301105061664818",
	"2333342423 2737382827",		\:
	"2333342423 2737382827 1:38",		\;
	"400448",				\<
	"1353 1555",				\=
	"206428",				\>
	"12112050616354443536 3848493938",	\?

	"4542322325556461502002062858",		\@

\\	"080220406268 0565",			\A
\\	"0803306368 0565",			\A
	"083068 1555",				\A
\\	"0806306668 1555",			\A
\\	"08204068 1555",			\A

	"005061635414 5465675808 1018",		\B
	"6150200206285867",			\C
	"004062664808 1018",			\D
	"60000868 0434",			\E
	"600008 0434",				\F
	"61502002062858676535",			\G
	"0008 0464 6068",			\H
	"1050 3038 1858",			\I
	"2060 4047381807",			\J
	"0008 6006 2468",			\K
	"000868",				\L
	"0800336068 3334",			\M
	"08006668 6660",			\N
	"200206284866624020",			\O

	"08005061635404",			\P
	"200206284866624020 3568",		\Q
	"08005061635404 2468",			\R
	"615010010314546567581807",		\S
	"0060 3038",				\T
	"000718586760",				\U
	"0002386260",				\V
	"0008356860 3534",			\W
	"00016768 08076160",			\X
	"00013438 346160",			\Y
	"006061070868",				\Z
	"40101848",				\[
	"0167",					\/
	"10404818",				\]
	"033063",				\^
	"0868",					\_

	"432120303121",				\'
	"1343545768 55150607184857",		\a
	"0008 0523435457482806",		\b
	"5443130407184857",			\c
	"5058 5533130407183856",		\d
	"055554431304071848",			\e
	"5140302128 0444",			\f
\\	"535:4;1;0: 5533130406173755",		\g
	"535:4;1; 5533130406173755",		\g
	"0008 0523435458",			\h
	"233338 2848 2021313020",		\i
\\	"43535:4;2;1: 4041515040",		\j
\\	"43535:4;2; 4041515040",		\j
	"33434:3;1; 3031414030",		\j
	"0008 0743 2558",			\k
	"203038 2848",				\l
	"0803233438 3443536468",		\m
	"0308 0523435458",			\n
	"134354574818070413",			\o

	"030; 0523435457482806",		\p
	"535; 5533130407183857",		\q
	"0308 05234354",			\r
\\	"544313041525364657481807",		\s
\\	"54431304055657481807",			\s
	"54431304154657481807",			\s
	"2127384857 0343",			\t
	"0307183856 5358",			\u
\\	"0305386563",				\v
	"033863",				\v
\\	"030718283734 3748586763",		\w
\\	"0328354863",				\w
\\	"0318355863",				\w
\\	"0318345863",				\w
	"0307183634 36586763",			\w
	"0358 0853",				\x
\\	"030718385653 565:4;1;",		\y
	"0338 0;1;63",				\y
	"03530858",				\z
	"403021231425273848",			\{
	"3032 3537",				\|
\\	"303;",					\|
	"203041435445473828",			\}
	"011020425261",				\~
	"33086833"];				\del

if Ch<$20 or Ch>$7F then Ch:= $20;
Str:= VectFont(Ch-$20);
I:= 0;
X:= Str(I)-^0;  I:= I+1;	\move to starting coordinates
Y:= Str(I)-^0;  I:= I+1;	\ relative to upper-left corner
X:= fix(float(X)*FontSize) + PenX0;
Y:= fix(float(Y)*FontSize) + PenY0;
MovePen(X, Y);

loop	[X:= Str(I);  I:= I+1;
	 if X = 0 then quit;
	 if X = $20 then	\pen up
		[X:= Str(I)-^0;  I:= I+1;
		 Y:= Str(I)-^0;  I:= I+1;
		 X:= fix(float(X)*FontSize) + PenX0;
		 Y:= fix(float(Y)*FontSize) + PenY0;
		 MovePen(X, Y);
		]
	else	[X:= X - ^0;
		 Y:= Str(I)-^0;  I:= I+1;
		 X:= fix(float(X)*FontSize) + PenX0;
		 Y:= fix(float(Y)*FontSize) + PenY0;
		 DrawLine(X, Y, Color);
		];
	];
PenX:= PenX0 + fix(8.0*FontSize);	\move to next character cell
PenY:= PenY0;
];	\DrawVectChar



proc	DrawChar(Font, Ch, Color);	\Display a character at PenX,PenY
int	Font, Ch, Color;		\background is transparent
int	I, J, Byte;			\chars can be rotated by 90 degrees
int	FontHi;				\char height in pixels = number of bytes
char	FontOff, FontSeg;		\address of table (offset and segment)
[if Font = 3 then [DrawVectChar(Ch, Color);  return];
case Font of
  0:	[FontOff:= GetFont(0);  FontHi:= 16];
  1:	[FontOff:= GetFont(1);  FontHi:= 8];
  2:	[FontOff:= GetFont(2);  FontHi:= 14]
other	[];
for J:= 0 to FontHi-1 do
	[Byte:= FontOff(Ch*FontHi + J);
	for I:= 0 to 7 do		\for each bit in the Byte...
		[if Byte & $80 then
			if CharDir then Point(PenX+J, PenY-I, Color)
			       else Point(PenX+I, PenY+J, Color);
		Byte:= Byte << 1;
		];
	];
if CharDir then PenY:= PenY - 8
       else PenX:= PenX + 8;		\move to next character position
];	\DrawChar



proc	DrawText(Font, Str, Color);	\Display a text string at PenX,PenY
int	Font;
char	Str;
int	Color;
while Str(0) do [DrawChar(Font, Str(0), Color);  Str:= Str+1];	



proc	DrawInt(Font, N, Color);	\Display an integer at PenX,PenY
int	Font, N, Color;
int	Ch;
[OpenI(8);  OpenO(8);
IntOut(8, N);  ChOut(8, 0);
Ch:= ChIn(8);
while Ch do [DrawChar(Font, Ch, Color);  Ch:= ChIn(8)];
];	\DrawInt



proc	DrawReal(Font, X, Color);	\Display a real numbmer at PenX,PenY
int	Font;
real	X;
int	Color;
int	Ch;
[OpenI(8);  OpenO(8);
RlOut(8, X);  ChOut(8, 0);
Ch:= ChIn(8);
while Ch do [DrawChar(Font, Ch, Color);  Ch:= ChIn(8)];
];	\DrawReal



proc	WordOut(Dev, Word);	\Output 32-bit word in binary
int	Dev, Word;
[ChOut(Dev, Word);
ChOut(Dev, Word>>8);
ChOut(Dev, Word>>16);
ChOut(Dev, Word>>24);
];	\WordOut



proc	HalfOut(Dev, Half);	\Output 16-bit half word in binary
int	Dev, Half;
[ChOut(Dev, Half);
ChOut(Dev, Half>>8);
];	\HalfOut



proc	SaveBmp(FileName);	\Save graphic screen to specified .bmp file
char	FileName;		\this must have a ".bmp" extension
int	FD;			\output file descriptor
int	X, Y, Color,		\pixel coordiantes and pixel color
	R, G, B,		\red, green, blue
	Addr, Width, Height, Depth;
int	FileSize, Offset, BytesPerPixel;

[Trap(false);
FD:= FOpen(FileName, 1);
FSet(FD, ^O);
OpenO(3);
if GetErr then return false;
Trap(true);

Addr:= GetFB;
Width:= Addr(0);
Height:= Addr(1);
Depth:= Addr(2);

Offset:= 54;					\assume no color table
if Depth < 8 then Depth:= 8;			\round up to full byte per pixel
if Depth = 8 then Offset:= Offset + 256*4;	\image data are beyond color tbl
if Depth = 32 then Depth:= 24;			\alpha intensity is meaningless
BytesPerPixel:= Depth/8;
FileSize:= Width*Height*BytesPerPixel + Offset;

ChOut(3, ^B);  ChOut(3, ^M);	\0: file must begin with "BM" (Bit Map)
WordOut(3, FileSize);		\2: size of entire file (default mode $101)
HalfOut(3, 0);			\6: 0
HalfOut(3, 0);			\8: 0
WordOut(3, Offset);		\10: offset from start of file to image data
WordOut(3, 40);			\14: size of sub-header (bytes)
WordOut(3, Width);		\18: image width in pixels
WordOut(3, Height);		\22: image height in pixels
HalfOut(3, $0001);		\26: planes
HalfOut(3, Depth);		\28: bits per pixel
WordOut(3, 0);			\30: compression type (not used)
WordOut(3, 0);			\34: size of compressed image data (not used)
WordOut(3, 0);			\38: horizontal resolution (not used)
WordOut(3, 0);			\42: vertical resolution (not used)
WordOut(3, 0);			\46: number of colors used (not used)
WordOut(3, 0);			\50: number of "important" colors (not used)

if Depth = 8 then		\include color table
    for X:= 0 to 256-1 do
	[Color:= GetPalette(X);
	ChOut(3, Color);	\B
	ChOut(3, Color>>8);	\G
	ChOut(3, Color>>16);	\R
	ChOut(3, 0);
	];

for Y:= Height-1 downto 0 do	\image data
	for X:= 0 to Width-1 do
		[Color:= ReadPix(X, Y);
		case Depth of
		   8:	ChOut(3, Color);
		  16:	[B:= Color & $1F;	\convert 5:6:5 format to 5:5:5
			G:= Color>>6 & $1F;	\ which is the form used by .bmp
			R:= Color>>11 & $1F;
			Color:= R<<10 + G<<5 + B;
			ChOut(3, Color);
		  	ChOut(3, Color>>8);
			];
		  24:	[ChOut(3, Color);	\B
		  	ChOut(3, Color>>8);	\G
		  	ChOut(3, Color>>16);	\R
		  	]
		else	[];
		];
Close(3);
FClose(FD);
return true;			\no errors detected
];	\SaveBmp



func	LoadBmp(FileName);	\Load specified .bmp file into 2nd graphic page
char	FileName;		\Returns 'true' if successful
\A compatible graphic mode is assumed to have been set up with SetVid or SetFB.
\Reference: Microsoft MSDN Library; and "Graphics File Formats" by Kay & Levine
int	Y0,		\offset to 2nd graphic page (= screen height)
	FD,		\file descriptor (handle)
	Offset,		\offset from start of file to image data (bytes)
	HeadSize,	\header size: 40=Windows format; 12=OS/2 (old) format
	Width, Height,	\file image dimensions (pixels)
	Depth,		\file image depth (bits)
	R, G, B,	\red, green, blue (0..255)
	X, Y,		\screen coordinates (pixels)
	I, J, T,	\indexes and temporary scratch
	CTblSize;	\number of bytes in BMP's color table

[Y0:= GetFB;  Y0:= Y0(1);	\height of graphic screen (= offset to 2nd page)

Trap(false);			\turn off error trapping (if error don't abort)
FD:= FOpen(FileName, 0);	\get input file descriptor
if GetErr \#0\ then return false;
Trap(true);
FSet(FD, ^I);			\set device 3 to opened file
OpenI(3);

if ChIn(3) # ^B then return false;	   \file must begin with "BM" (Bit Map)
if ChIn(3) # ^M then return false;
for I:= 2 to 9 do X:= ChIn(3);	\2, skip unused header info
Offset:= ChIn(3) + ChIn(3)<<8;	\10, offset from start of file to image data
T:= ChIn(3);  T:= ChIn(3);	\12, skip unused header info (32767 max. is ok)

HeadSize:= ChIn(3) + ChIn(3)<<8;	   \14, size of header (40 or 12)
T:= ChIn(3);  T:= ChIn(3);		   \16, skip high bytes of size
Width:= ChIn(3) + ChIn(3)<<8;		   \18
if HeadSize = 12 then			   \OS/2 (old) format:
	[Height:= ChIn(3) + ChIn(3)<<8;	   \20
	T:= ChIn(3);  T:= ChIn(3);	   \22, skip "number of image planes"
	Depth:= ChIn(3) + ChIn(3)<<8;	   \24, bits per pixel
	]
else					   \Windows (normal) format:
	[T:= ChIn(3);  T:= ChIn(3);	   \20, skip unused high bytes of Width
	Height:= ChIn(3) + ChIn(3)<<8;	   \22
	T:= ChIn(3);  T:= ChIn(3);	   \24, skip unused high bytes of Height
	T:= ChIn(3);  T:= ChIn(3);	   \26, skip "number of image planes"
	Depth:= ChIn(3) + ChIn(3)<<8;	   \28, bits per pixel
	for I:= 30 to 53 do T:= ChIn(3);   \30, skip rest of header
	];

\Read in and set palette registers with color table if it's provided
CTblSize:= Offset - 14 - HeadSize;	\number of bytes of color table data
if CTblSize > 256*4 then CTblSize:= 256*4;
I:= 0;  J:= 0;
while J < CTblSize do
	[B:= ChIn(3);			\(things tend to be backwards in bmps)
	 G:= ChIn(3);
	 R:= ChIn(3);
	 J:= J+3;
	 if HeadSize # 12 then		\if not OS/2 (old) format
		[T:= ChIn(3);  J:= J+1];
	if I < 256 then			\(for safety)
		[SetPalette(I, R, G, B);  I:= I+1];
	];

\Note: scan lines are padded to end on a 4-byte boundary
for Y:= Height-1 downto 0 do		\bmps are upside down (!)
	[case Depth of
	  32:	[for X:= 0 to Width-1 do
			[T:= ChIn(3) + ChIn(3)<<8 + ChIn(3)<<16; \xxRRGGBB
			Point(X, Y0+Y, T);
			T:= ChIn(3);	\discard unused high byte
			];
		];
	  24:	[for X:= 0 to Width-1 do
			[T:= ChIn(3) + ChIn(3)<<8 + ChIn(3)<<16; \xxRRGGBB
			Point(X, Y0+Y, T);
			];
		for I:= Width*3 to ((Width*3+3)&$FFFC)-1 do
			T:= ChIn(3);			\4-byte boundary
		];
	  16:	[for X:= 0 to Width-1 do
			[T:= ChIn(3) + ChIn(3)<<8;	\change RGB555 to RGB565
			R:= (T&$7C00)<<1;
			G:= (T&$03E0)<<1;
			B:= T&$001F;
			Point(X, Y0+Y, R+G+B);
			];
		for I:= Width*2 to ((Width*2+3)&$FFFC)-1 do
			T:= ChIn(3);			\4-byte boundary
		];
	  8:	[for X:= 0 to Width-1 do
			Point(X, Y0+Y, ChIn(3));
		for I:= Width, ((Width+3)&$FFFC)-1 do
			T:= ChIn(3);			\4-byte boundary
		];
	  4:	for X:= 0 to ((Width+7)&$FFF8)-1 do	\4-byte boundary =
			[				\ 8-nibble boundary
			T:= ChIn(3);			\high nibble is left pix
			if X < Width then Point(X, Y0+Y, T>>4);
			X:= X+1;			\low nibble is right pix
			if X < Width then Point(X, Y0+Y, T&$0F);
			];
	  1:	for X:= 0 to ((Width+31)&$FFE0)-1 do	\4-byte boundary =
			[T:= ChIn(3);			\ 32-bit boundary
			for I:= 0 to 7 do
				[if X < Width then
					Point(X, Y0+Y, T>>7&1);
				X:= X+1;
				T:= T<<1;
				];
			X:= X-1;
			]
	other	return false;		\unsupported depth
	];
FClose(FD);
return true;				\no errors detected
];	\LoadBmp
